/* Copyright (c) 2011 Asustor Inc. All rights reserved. */
Ext.Loader.setConfig({enabled:true});

Ext.ns('DownloadCenter');
/* utils */
DownloadCenter.changeValueUseEllipsis = function(value, target, showMaxLength) {
    var showValue = Ext.util.Format.ellipsis(value, showMaxLength);
	target.setValue(showValue);
	target.el.dom.setAttribute('data-qtip', AS.ARC.util.replaceHtmlSymbols(value));
};

/**
 * create gridpanel can use shift, ctrl to control scrollbar action
 */
Ext.define('DownloadCenter.gridPanel', {
	extend: 'Ext.grid.GridPanel',
	useSpecialkey: false,
	setSpecialKey: function(value) {
		this.useSpecialkey = value;
	},
	getSpecialKey: function() {
		return this.useSpecialkey;
	},
	initComponent: function () {
		this.useSpecialkey = false;

		var config = {},
		me = this;

		Ext.apply(this, Ext.apply(this.initialConfig, config));
		this.callParent(arguments);
	},
	listeners: {
		render: function(com, eOpts) {
			Ext.fly(this.el).on('keyup', function(e, t) {
				this.useSpecialKey = false;
			});
		},
		afterrender: function(com, eOpts) {
			var config = [{
					key: Ext.EventObject.SHIFT,
					fn: function() {
						this.useSpecialKey = true;
					}
				},
				{
					key: Ext.EventObject.CTRL,
					fn: function() {
						this.useSpecialKey = true;
					}
				}];
			var gridMap = Ext.create('Ext.util.KeyMap', this.el, config);
			Ps.initialize(com.body.dom);
			Ps.update(com.body.dom);
		}
	}
});

/**
 * tree selector
 */
Ext.define('DownloadCenter.treeSelector', {
	extend: 'Object',
	
	selectPath: '',
	volumePath: '',
	//define msg show error type
	MSG_TYPE_ERROR: 'error',
	//define msg show warning type
	MSG_TYPE_WARNING: 'warning',
	FEUrl: AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi',
	paramsUrl: AS.ARC.config.baseUrl + 'apis/params.cgi',
	
	SHARE_FOLDERS_UNKNOWN: 0,
	SHARE_FOLDERS_READ_ONLY : 1,
	SHARE_FOLDERS_WRITE_ONLY: 2,
	SHARE_FOLDERS_DECLINE: 3,
	SHARE_FOLDERS_TYPE_SHARE: 0,
	SHARE_FOLDERS_TYPE_MOUNT: 1,
	SHARE_FOLDERS_TYPE_FOLDER: 2,

    // access permission
	ASACL_PERM_WRITE_DATA_OR_ADD_FILE: 0x00000002,
	ASACL_PERM_APPEND_DATA_OR_ADD_DIR: 0x00000004,
	ASACL_PERM_DELETE: 0x00000200,
	ASACL_PERM_DELETE_CHILD: 0x00000040,

	// folder type
	SHARE_FOLDERS_TYPE_MOUNT: 'virtual_share',

	//max can create create folder window count
	MAX_CREATEFOLDER_WIN: 1,
	//count create folder window
	CREATEFOLDER_WIN_NUMBER: 0,
	expandList: new Array(),	
	//save get params create folder number
	createFolderNumber: 0,
	
	defaultShowMaxLength: 10,

	isShowHome: true,
	
	disableMyArchive: false,
	/**
	 * @property {Boolean} hideReadOnly
	 * Default is false, hide read only node when set to true.
	 */
	hideReadOnly: false,

	//parentWin, objectPath, type
	constructor: function(config) {
		Ext.apply(this, config);
		this.callParent();
		this.init();
		this.getParams();
		this.createWindow();
	},
	
	init: function() {
		this.selectPath = '';
		this.volumePath = '';
		this.expandList = new Array();
	},
	
    isReadOnly: function(value) {
		var fs = this;

		if (!(fs.ASACL_PERM_APPEND_DATA_OR_ADD_DIR & value) &&
			!(fs.ASACL_PERM_WRITE_DATA_OR_ADD_FILE & value) &&
			!(fs.ASACL_PERM_DELETE & value) &&
			!(fs.ASACL_PERM_DELETE_CHILD & value)) {
				return true;
		} else {
			return false;
		}
	},

	getFolderName: function(path) {
		var findIndex = path.lastIndexOf('/');
		var folderName = path;
		if (findIndex != -1 ) {
			folderName = path.substring(findIndex+1, path.length);			
		}
		return folderName;			
	},
	getParams: function() {
		var fs = this;
		var urlOpts = {
			act: 'get'
		};
		
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fs.paramsUrl, urlOpts),
			method: 'post',
			success: function (json, opts) {
				if (json.createFolderNumber ==  'undefined' || json.createFolderNumber == 'NaN') {
					fs.createFolderNumber = 0;
				} else {
					fs.createFolderNumber = json.createFolderNumber;
				}
			},
			failure: function (json, opts) {
			}
		});
	},
	saveParams: function() {
		var fs = this;
		fs.createFolderNumber++;
		var urlOpts = {
			act: 'set',
			createFolderNumber: fs.createFolderNumber
		};
		
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fs.paramsUrl, urlOpts),
			method: 'post',
			success: function (json, opts) {								
			},
			failure: function (json, opts) {
			}
		});
	},
	buildCreateFolderNodeChilds: function(win, buildPath) {
		var fs= this;
		var findindex = -1;
		var buildNode;
		for (var i=0; i< fs.expandList.length; i++) {
			if (fs.expandList[i].data.file_path == selectedNode.data.file_path) {
				findindex = i;
				break;
			}
		}
		
		var checkExists = false;
		if (findindex != -1) {
			//use expand node
			buildNode = fs.expandList[findindex];
			checkExists = true;
		} else {
			//find selectedNode's expandNode
			if (typeof(selectedNode) != 'undefined') {
				var checkid = selectedNode.data.file_path;
				var checkindex = checkid.lastIndexOf('/');
				if (checkindex != -1 && checkindex != 0) {
					var checkid = checkid.substring(0, checkindex);
					
					var findindex = -1;
					var checkNode = selectedNode;
					for (var i=0; i< fs.expandList.length; i++) {
						if (fs.expandList[i].data.file_path == checkid) {
							findindex = i;
							break;
						}
					}
					if (findindex != -1) {
						buildNode = fs.expandList[findindex];
						checkExists = true;
					}
				}
			} else {
			}
		}
		if (checkExists) {			
			//get folder's node list
			var urlOpts = {
				act: 'file_list',
				path: buildNode.data.id,
				onlydir: true
			};

			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fs.FEUrl, urlOpts),
				method: 'post',			
				success: function (json, opts) {
					var datas = json.data;
					if (datas.length > 0 ) {
						buildNode.removeAll();
						for (var i=0; i< datas.length; i++) {
							var folderName = fs.getFolderName(datas[i].file_path);
							var nodeConfig = {
								text: Ext.htmlEncode(folderName).replace(/\u0020/ig, '&nbsp;'),
								leaf: false,
								id: datas[i].file_path,
								type: datas[i].share_folder_type,
								phy_path: buildNode.data.physical_path+"/"+folderName,
								qtip: Ext.htmlEncode(Ext.htmlEncode(folderName)),
								access_permission: datas[i].access_permission
							};
							buildNode.appendChild(nodeConfig);
						}
					}
				},
				failure: function (json, opts) {
					AS.ARC.util.msgDialog(fs.win, fs.MSG_TYPE_ERROR, json.error_msg);
				}
			});
		}
	},
	openCreateFolderWin: function () {
		var fs = this;
		
		var node = fs.locationTree.getSelectionModel().getSelection()[0];
		node.expand();
		
		if (fs.CREATEFOLDER_WIN_NUMBER < fs.MAX_CREATEFOLDER_WIN) {
			if (fs.selectPath != '') {				
				var runCreateFolder = function () {
					folderText.disable();

					var cb = function () {
						folderText.enable();
					}

			        var checkFolder = folderText.getValue().trim();
			        if (checkFolder.length == 0) {
			            
			        	AS.ARC.util.msgDialog(win, fs.MSG_TYPE_ERROR, _S('MESSAGE', 'HF00014'), cb);
			        } else {
			        	
			            win.el.mask(_S('COMMON', 'APPLYING'));			            
			            var urlOpts = {
			                act: 'createdir',
			                dest_path: fs.selectPath.trim(),
			                dest_folder: folderText.getValue().trim()
			            };

			            AS.ARC.ajax({
			                url: AS.ARC.util.getApiUrlWithSid(fs.FEUrl, urlOpts),
			                method: 'post',
			                success: function (json, opts) {
								
								var child = node.appendChild({
									text: folderText.getValue().replace(/\u0020/ig, '&nbsp;'),
									leaf: false,
									id: node.data.id + '/' + folderText.getValue(),
									type: 2,
									phy_path: node.data.phy_path + "/" + folderText.getValue(),
									qtip: folderText.getValue(),
									access_permission: node.data.access_permission
								});

								var sm = fs.locationTree.getSelectionModel();
								sm.select(child);
								fs.selectPath = node.data.id + '/' + folderText.getValue();
								
			                    fs.saveParams();
			                    win.close();
			                },
			                failure: function (json, opts) {
			                    win.el.unmask();
			                    var errors = {
			                    	5008: _S('ERROR', 'UNABLE_CREATE_ALREADY_FOLDER'),
			                    	5011: _S('ERROR', 'UNABLE_MODIFY_FILE_PROPERTIES'),
			                    	5019: _S('ERROR', 'CANOT_CREATE_FOLDER'),
			                    	5025: _S('ERROR', 'NOT_ALLOWED_OPERATION'),
			                    	5026: _S('ERROR', 'READ_ONLY_FILE'),
			                    	5045: _S('ERROR', 'MAXIMUN_USAGE_QUOTA'),
			                    	5605: _S('ERROR', 'NO_SPACE_DISK')
			                    };
			                    
			                    AS.ARC.util.showMsgWindow(errors, json, win, 'warning', cb);
			                }
			            });
			        }			        
				};
				
			    var buttonApply = Ext.create('Ext.button.Button', {
					disabled: true,
					text: _S('COMMON', 'OK'),
					handler: function () {
						runCreateFolder();
					}
				});
				
				var folderText = Ext.create(Ext.form.field.Text, {
					fieldLabel: _S('COMMON', 'NEW_NAME'),
					width: 350,
					itemId: 'name',
					vtype: 'createFolder',
					blankText: _S('MESSAGE', 'HF00011'),
					allowBlank: false,
					msgTarget: AS.ARC.config.msgTarget,
					listeners: {						
						validitychange: function( field, isValid, eOpts ) {
							if (isValid) {
							    buttonApply.setDisabled(false);
							} else {
							    buttonApply.setDisabled(true);
							}
						},
						specialkey: function (field, e) {
							
							if (e.getKey() == e.ENTER && !field.disabled && field.isValid()) {
								runCreateFolder();
							}
						}
					}
				});
				
				
				var win = Ext.create('AS.ARC.subWindow', {
					title: _S('COMMON','CREATE_FOLDER'),
					width: 400,
					height: 150,
					parentWin: fs.win,
					fbar: [
					buttonApply,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						}
					}],					
					items:[{
						xtype: 'asPanelTop10',
						itemId: 'panel',
						buttonApply: buttonApply,
						defaults: {
						    labelWidth: AS.ARC.config.layout.defaultLabelWidth,
						    msgTarget: AS.ARC.config.msgTarget,
						    blankText: _S('MESSAGE', 'HF00011')
						},
						height: 50,
						labelWidth: 50,
						items: [folderText]
					}],
					listeners: {
					    show: function (win) {
					        win.items.get('panel').items.get('name').focus(true, 10);
					    },
						afterrender: function ( com, eOpts ) {
							fs.CREATEFOLDER_WIN_NUMBER++;
						},
						beforeclose: function() {
							fs.CREATEFOLDER_WIN_NUMBER--;
						}
					}
				});
			
				win.show();	
				
			} else {
				AS.ARC.util.msgDialog(fs.win, fs.MSG_TYPE_ERROR, _S('COMMON','SELECT_FOLDER'));
			}			
		}
	},
	createTreeNodes: function(rootNode) {
		var fs = this;
		rootNode.removeAll();
		//create all share_folders treeNodes use ajax		
		var urlOpts = {
			act: 'file_list',
			path: 'share_folders'
		};			
		
		if (fs.isShowHome)
			Ext.apply(urlOpts, {showhome: true})

		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fs.FEUrl, urlOpts),
			method: 'post',			
			success: function (json, opts) {
				fs.locationTree.el.unmask();

				var datas = json.data;
				if (datas.length === 0) {
					var noFolderWin = Ext.create('AS.ARC.msgWindow', {
						title: _S('COMMON', 'INFORMATION'),
						parentWin: fs.win, //preferences window
						iconType: 'info', // info, question, warning
						asItems: [
							{
								xtype: 'displayfield',
								value: _S('ERROR', 'NO_ACCESS_RIGHT_SHARE_FOLDERS')
							}
						],
						fbar: [{
							text: _S('COMMON', 'OK'),
							handler: function () {
								noFolderWin.close();
							}
						}]
					}).show();
				}
				for (var i = 0; i < datas.length; i++) {

					var myarchiveFormat = '/volume1/MyArchive';
                    var path = datas[i].physical_path;
                    var isMyArchive = function () {
                        array = path.split(myarchiveFormat);
                        if (array.length === 2) {
                            if ((array[1] !== '') && (array[1] <= AS.ARC.config.bay - 1)) {
                                return true;
                            } else {
                                return false;
                            }
                        } else {
                            return false;
                        }
                    };
					if (fs.disableMyArchive && isMyArchive()) {
						continue;
					}
						
					
					if (!fs.hideReadOnly || !fs.isReadOnly(datas[i].access_permission)) {
						if (datas[i].share_folder_type != fs.SHARE_FOLDERS_TYPE_MOUNT) {
							if (datas[i].type != fs.SHARE_FOLDERS_TYPE_MOUNT) {
								var nodeConfig = {
									text: Ext.htmlEncode(datas[i].filename),
									leaf: false,
									id: datas[i].file_path,
									type: datas[i].share_folder_type,
									phy_path: datas[i].physical_path,
									qtip: Ext.htmlEncode(Ext.htmlEncode(datas[i].filename)),
									access_permission: datas[i].access_permission
								}
							} else {
								var nodeConfig = {
									text: Ext.htmlEncode(datas[i].filename),
									leaf: false,
									id: datas[i].file_path,
									type: datas[i].share_folder_type,
									icon: AS.ARC.util.fixDc('apps/fileExplorer/images/files_list/iso.png'),
									phy_path: datas[i].physical_path,
									qtip: Ext.htmlEncode(Ext.htmlEncode(datas[i].filename)),
									access_permission: datas[i].access_permission
								}
							}
							rootNode.appendChild(nodeConfig);
						}
					}
					winapp.ALL_FOLDER[i] = datas[i].file_path;
				}

				var fileSelectorTreePanelBody = fs.locationTree.el.dom.querySelector('.x-panel-body');
				Ps.update(fileSelectorTreePanelBody);
			},
			failure: function (json, opts) {
				fs.locationTree.el.unmask();
				AS.ARC.util.msgDialog(fs.parentWin, fs.MSG_TYPE_ERROR, json.error_msg);
			}
		});
	},
	createLocationTree: function() {
		var fs = this;
		
		//create tree mount context menu
		var treeContextMenu = Ext.create('Ext.menu.Menu', {
			items:[{
				xtype: 'menuitem',
				text: _S('COMMON','CREATE_FOLDER'),
				scope: this,
				handler: fs.openCreateFolderWin
			}]
		});	
		
		// create the Tree
		fs.locationTree = Ext.create('Ext.tree.TreePanel', {
			rootVisible: false,			
			useArrows : true,				
			autoScroll:true, 								
			height: 250,	
			flex: 1,
			resizable: false,
			scope: this,
			listeners: {				
				afterrender: function( com, eOpts) {
					//treePandel's root node
					var rootNodes = {
						text:'root',
						expanded:true,
						id: ''
					};
					fs.locationTree.setRootNode(rootNodes);
					fs.createTreeNodes(fs.locationTree.getRootNode());
					
					fs.locationTree.el.mask(_S('COMMON', 'LOADING'));
				},
				itemcontextmenu : function(view, record, item, index, event){
					event.stopEvent();
					selectedNode = record;	
					fs.selectPath = record.data.id;
					fs.volumePath = record.data.phy_path;
					fs.btnCreate.setDisabled(false);
					x = event.browserEvent.clientX;
					y = event.browserEvent.clientY;
					treeContextMenu.showAt([x, y]);
				},
				itemclick: function(view, record, item, index, e, eOpts) {
					/** 判斷是否有資料夾權限，並給予相對應的字串 */
					if(!fs.isReadOnly(record.data.access_permission)) {
						fs.win.items.items[0].items.get('folderAccess').setValue('');
						fs.btnOk.enable(true);
						fs.btnCreate.setDisabled(false);
					} else {
						if(AS.ARC.isAdmin) {
							fs.win.items.items[0].items.get('folderAccess').setValue(_S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN'));
						} else {
							fs.win.items.items[0].items.get('folderAccess').setValue(_S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER'));
						}
						fs.btnOk.disable(true);
						fs.btnCreate.setDisabled(true);
					}
					selectedNode = record;	
					fs.selectPath = record.data.id;
					fs.volumePath = record.data.phy_path;
				},											
				itemexpand: function(node, eOpts) {
					selectedNode = node;
					fs.expandList.push(node);
					node.removeAll();
					//get folder's node list
					var urlOpts = {
						act: 'file_list',
						path: node.data.id,
						onlydir: true
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fs.FEUrl, urlOpts),
						method: 'post',			
						success: function (json, opts) {
							var datas = json.data;
							for (var i = 0; i < datas.length; i++) {
								var folderName = fs.getFolderName(datas[i].file_path);
								
								var nodeConfig = {
									text: Ext.htmlEncode(folderName).replace(/\u0020/ig, '&nbsp;'),
									leaf: false,
									id: datas[i].file_path,
									type: datas[i].share_folder_type,
									phy_path: node.data.physical_path + "/" + folderName,
									qtip: Ext.htmlEncode(Ext.htmlEncode(folderName)),
									access_permission: datas[i].access_permission
								}
								node.appendChild(nodeConfig);
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.msgDialog(fs.parentWin, fs.MSG_TYPE_ERROR, json.error_msg);
						}
					});
				}
			}
		});
		return fs.locationTree;
	},		
	changeValue: function(value) {
        var checkValue = AS.ARC.util.replaceHtmlSymbols(value);
		var fs = this;
		if (fs.useEllipsis) {
			if (fs.showMaxLength) {
			    DownloadCenter.changeValueUseEllipsis(value, fs.objectPath);
			} else {
			    DownloadCenter.changeValueUseEllipsis(value, fs.objectPath);
			}
		} else {
		    fs.objectPath.setValue(value);
		    fs.objectPath.el.dom.setAttribute('data-qtip', checkValue);
		}
	},
	createWindow: function() {
		var fs = this;
		var buildTree = fs.createLocationTree();
		fs.selectPath = '';
		fs.volumePath = '';
		fs.btnCreate = Ext.create(Ext.button.Button, {
			text: _S('COMMON','CREATE_FOLDER'),
			scale: AS.ARC.config.defaultActionButtonSize,
			handler: fs.openCreateFolderWin,			
			scope: this,
			disabled: true
		});
		fs.btnOk = Ext.create(Ext.button.Button, {
			text: _S('COMMON', 'OK'),
			scale: AS.ARC.config.defaultActionButtonSize,
			handler: function() {
				var temp = [],
					tempString = '/Home',
					num = 0;
				if (fs.selectPath != '') {
					fs.objectPath.volumePath = fs.volumePath;
					temp = fs.selectPath.split('/');
					
					if (fs.type == 'volume') {
						fs.changeValue(fs.volumePath);
					} else {
						if(temp[1] === 'home') {
							for(num = 3; num < temp.length; num++) {
								tempString = tempString + '/' + temp[num];
							}
							fs.changeValue(tempString);
						} else {
							fs.changeValue(fs.selectPath);
						}
					}
					fs.win.close();	
				} else {
					AS.ARC.util.msgDialog(fs.win, fs.MSG_TYPE_ERROR, _S('COMMON','SELECT_FOLDER'));
				}
			}
		});
		fs.win = Ext.create('AS.ARC.subWindow', {
			title: _S('COMMON', 'DIRECTORY'),
			parentWin: fs.parentWin,
			width: 550,
			height: 450,
			scope: this,
			fbar: [
				fs.btnOk,
			{
				text: _S('COMMON', 'CANCEL'),
				handler: function () {
					fs.win.close();
				}
			}],							
			items: [
			{
				xtype: 'asPanelTop10',
				height: 350,
				items: [
				{
					xtype: 'asPanelToolbarTop',
					items: [
						fs.btnCreate
					]
				},
				buildTree,
				{
					itemId: 'folderAccess',
					xtype: 'displayfield',
					fieldStyle: 'color:red; width: 526px;'
				}]
			}]
		});
		
		fs.win.show();		
	}
});

/**
 * @class AS.ARC.apps.downloadCenter.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */
Ext.define('AS.ARC.apps.downloadCenter.core', {
    extend: 'Ext.util.Observable',

    constructor: function (config) {
        Ext.apply(this, config);

        this.init(config);
    },

	MAX_DISPLAY_LEHGTH_OF_PATH_DIALOG: 40,		//path string display length, in all dialog(torrent info, add task...)

	MAX_DISPLAY_LEHGTH_OF_DOWNLOAD_PATH: 80,		//path string display length, in download center preferences

	MAX_DISPLAY_LEHGTH_OF_PATH: 160,		//RSS save to somewhere, path string display length in words

	//max number of tasks can be perform at same time
	MAX_TASK_NUMBER_EACH_TIME: 1000,

    //max can create add task window
    MAX_ADD_WIN: 1,
    //count create add task window number
    ADD_WIN_NUMBER: 0,
    //max can create location window
    MAX_LOCATION_WIN: 1,
    //count create location window number
    LOCATION_WIN_NUMBER: 0,
    //max can create preference window
    MAX_PREFERENCE_WIN: 1,
    //count create preference window number
    PREFERENCE_WIN_NUMBER: 0,
    //max can create update torrent site window from preference window
    MAX_PREFERENCE_UPDATE_TORRENT_SITE_WIN: 1,
    //count create update torrent site window from preference window number
    PREFERENCE_UPDATE_TORRENT_SITE_WIN_NUMBER: 0,
    //max can create add/edit hosting site window from preference window
    MAX_PREFERENCE_AE_HOSTING_SITE_WIN: 1,
    //count create add/edit hosting site window from preference window number
    PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER: 0,
    //max can create remove hosting site window from preference window
    MAX_PREFERENCE_REMOVE_HOSTING_SITE_WIN: 1,
    //count create remove hosting site window from preference window number
    PREFERENCE_REMOVE_HOSTING_SITE_WIN_NUMBER: 0,
    //max can create update hosting site window from preference window
    MAX_PREFERENCE_UPDATE_HOSTING_SITE_WIN: 1,
    //count create update hosting site window from preference window number
    PREFERENCE_UPDATE_HOSTING_SITE_WIN_NUMBER: 0,

    //max can create error/warning msg dialg
    MAX_MSG_DIALG_WIN: 1,
    //count create error/warning msg dialog number
    MSG_DIALG_WIN_WIN_NUMBER: 0,

    //max can create create folder window count
    MAX_CREATEFOLDER_WIN: 1,
    //count create folder window
    CREATEFOLDER_WIN_NUMBER: 0,

    //MAX_ can create upload window count
    MAX_UPLOAD_WIN: 1,
    //count create upload window
    UPLOAD_WIN_NUMBER: 0,

    //MAX_ can create add rss window count
    MAX_RSS_ADD_WIN: 1,
    //count create add rss window
    RSS_ADD_WIN_NUMBER: 0,

    //MAX_ can create edit rss window count
    MAX_RSS_EDIT_WIN: 1,
    //count create edit rss window
    RSS_EDIT_WIN_NUMBER: 0,

    //MAX_ can create rss filter window count
    MAX_RSS_FILTER_WIN: 1,
    //count create rss filter window
    RSS_FILTER_WIN_NUMBER: 0,

    //define root path
    ROOT_PATH: '/vm_root',

    //define file explorer cgi url
    FEUrl: AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi',
    //define download center cgi url
    BTUrl: '../apps/download-center' + '/' + 'btdlm.cgi',
    UploadUrl: '../apps/download-center' + '/' + 'upload.cgi',
    SearchUrl: '../apps/download-center' + '/' + 'btsearch.cgi',

    //define get tree share_folders value
    SHARE_FOLDERS_UNKNOWN: 0,
    SHARE_FOLDERS_READ_ONLY : 1,
    SHARE_FOLDERS_READ_WRITE: 2,
    SHARE_FOLDERS_DECLINE: 3,
    SHARE_FOLDERS_TYPE_SHARE: 0,
    SHARE_FOLDERS_TYPE_MOUNT: 1,
	SHARE_FOLDERS_TYPE_FOLDER: 2,
	
	// access permission
	ASACL_PERM_WRITE_DATA_OR_ADD_FILE: 0x00000002,
	ASACL_PERM_APPEND_DATA_OR_ADD_DIR: 0x00000004,
	ASACL_PERM_DELETE: 0x00000200,
	ASACL_PERM_DELETE_CHILD: 0x00000040,

	// folder type
	SHARE_FOLDERS_TYPE_MOUNT: 'virtual_share',

    //define preference card layout value
    PREFERENCE_PANEL_INDEX: 0,
    PREFERENCE_GENERAL: 0,
    PREFERENCE_CONNECTION: 1,
    PREFERENCE_BANDWIDTH: 2,
    PREFERENCE_DOWNLOAD_SCHEDULE: 3,
    PREFERENCE_TORRENT_SITE: 4,
    PREFERENCE_HOST_SITE: 5,

    //define window image path
    WIN_IMAGE_PATH: '../apps/download-center/images/',

    //define refresh timeout id
    BT_REFRESH_TIMEOUT_ID: '',
    //define refresh time interval
    BT_REFRESH_TIME_INTERVAL: 3000,
    //define refresh rss timeout id
    RSS_REFRESH_TIMEOUT_ID: '',
    //define refresh rss time interval
    RSS_REFRESH_TIME_INTERVAL: 5000,
    //define isStart boolean
    ISSTART: false,

    //define toolbar card index value
    TOOLBAR_INDEX_DOWNLOAD: 0,
    TOOLBAR_INDEX_SEARCH: 1,
    TOOLBAR_INDEX_RSS: 2,
    TOOLBAR_INDEX_ITEM_RSS: 3,

    //define info show id
    infoRecords: null,

    //define delete confirm type
    CONFIRM_TYPE_DOWNLOAD_RESULT: 'DOWNLOAD-RESULT',
    CONFIRM_TYPE_SEARCH_PANEL: 'SEARCH-PANEL',
    CONFIRM_TYPE_RSS_PANEL: 'RSS-PANEL',

    //define msg show error type
    MSG_TYPE_ERROR: 'error',
    //define msg show warning type
    MSG_TYPE_WARNING: 'warning',

    //define type of undefined type
    TYPEOF_UNDEFINE: 'undefined',

    //show grid page size
    GRIDPANEL_PAGESIZE: 0, // origin 15

    BT_SEARCH_TIME_INTERVAL: 5000,

    INDEX_ADD_TASK_TORRENT_LINK: 0,
    INDEX_ADD_TASK_HTTP_FTP: 1,
    DEFAULT_DOWNLOAD_DIR: '/Download',
	HOME_FOLDER_ARRAY: [],
	NO_ACCESS_FOLDER: [],
	ALL_FOLDER: [],
	RSS_FILTER_DIR_ACCESS: false,
	RSS_ROWINDEX: [],

	PRE_CHECK_DEFAULT: false,
	PRE_CHECK_INCOMPLETE: false,
	PRE_CHECK_WATCH: false,

    INDEX_DOWNLOAD_RESULT: 0,
    INDEX_SEARCH_RESULT: 1,
    INDEX_RSS_RESULT: 2,
    INDEX_RSS_FEEDGRID_PANEL: 2,
    INDEX_RSS_ITEMGRID_PANEL: 3,
    defaultValue: '--',

    FOCUS_DOWNLOAD: 0,
    FOCUS_SEARCH: 1,
    FOCUS_RSS: 2,
    FOCUS_BT: 3,
    FOCUS_SEARCHRESULT: 4,
    FOCUS_RSSFEEDGRID: 5,
    FOCUS_RSSFEEDITEM: 6,

    MAX_ADDLINKNUMBER: 20,
    //default width
    WESTPANEL_WIDTH: 240,
    BTStore: null,
    scrollTop: 0,
    reloadSelections: [],
	trackerSelections: [],

	currentTaskCount: 0,	//current task number

	btSearchResultShowCount: 30,
	isMainWindowClosed: false,
	isChangeSearchKeywordResult: false,
	isRefreshResultPanel: false,
	isRemoveToSelectFirstItem: false,
	isInitSearchTypeComboBox: true,
	currentUpdateSearchId: 0,

    setFields: function () {
        winapp = this;
        
        Ext.apply(AS.ARC.re, {
            downloadText: /^[0-9a-zA-Z~!@#$%^&(){}\'\[\]\.\-_,\s\u0800-\u4E00\u4E00-\u9fa5\u9fa5-\uFFFF\u0080-\uFFFF\uFE30-\uFFA0]*$/,
            filterName: /^[0-9a-zA-Z~!@#$%^&*\s]*$/,
            torrent: /^[0-9a-zA-Z~!@#$%^&(){}\[\]\.\-_,\s\u0800-\u4E00\u4E00-\u9fa5\u9fa5-\uFFFF\u0080-\uFFFF\uFE30-\uFFA0]*$/
        });
        
        //donwloadText text
        //file explorer create folder
        Ext.form.VTypes.downloadTextMask = /[0-9a-zA-Z~!@#$%^&(){}\'\[\]\.\-_,\s\u0800-\u4E00\u4E00-\u9fa5\u9fa5-\uFFFF\u0080-\uFFFF\uFE30-\uFFA0]/;
        Ext.form.VTypes.downloadTextRe = AS.ARC.re.downloadText;
        Ext.form.VTypes.downloadText = function (v) {
            var MAX_LENGTH = 32;
            if (v.length > MAX_LENGTH) {
                Ext.form.VTypes.downloadTextText = Ext.String.format(_S('MESSAGE', 'HF00016'), MAX_LENGTH);

                return false;
            } else {
                if (!Ext.form.VTypes.downloadTextRe.test(v)) {
                    return false;
                } else {
                    return true;
                }
            }

        };
        Ext.form.VTypes.downloadTextText = Ext.String.format(_S('MESSAGE', 'HF00018'), _S('COMMON', 'COLON'), "0-9, a-z , ~!@#$%^&.',-_{}()[]");


        //download center filter
        Ext.form.VTypes.torrentMask = /[0-9a-zA-Z~!@#$%^&*\s]/;
        Ext.form.VTypes.torrentRe = AS.ARC.re.torrent;
        Ext.form.VTypes.torrent = function (v, f) {
            var findIndex = f.rawValue.lastIndexOf('.');
            if (findIndex != -1) {
                var checkFileExtension = f.rawValue.substring(findIndex + 1);
                if (checkFileExtension.toLowerCase() == 'torrent') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }

        };
        Ext.form.VTypes.torrentText = _S('DOWNLOAD_CENTER', 'SELECT_TORRENT_FILE');

        //download center filtermanager filter
        Ext.form.VTypes.filterNameMask = /[0-9a-zA-Z~!@#$%^&*\s]/;
        Ext.form.VTypes.filterNameRe = AS.ARC.re.filterName;
        Ext.form.VTypes.filterName = function (v, f) {
            var MAX_LENGTH = 32;
            if (!AS.ARC.re.filterName.test(v)) {
                Ext.form.VTypes.filterNameText = Ext.String.format(_S('MESSAGE', 'HF00018'), _S('COMMON', 'COLON'), "0-9, a-z, ~!@#$%^&*");

                return false;
            } else if (v.length > MAX_LENGTH) {
                Ext.form.VTypes.filterNameText = Ext.String.format(_S('MESSAGE', 'HF00016'), MAX_LENGTH);

                return false;
            } else if (v != '' && (f.workName != v)) {
                f.workName = v;
                // check if name exist
                AS.ARC.ajax({
                    url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, { act: 'rss-filter-list' }),
                    method: 'post',
                    success: function (json, opts) {
                        var datas = json.items;
                        var find = false;
                        for (var i = 0; i < datas.length; i++) {
                            var item = datas[i];
                            if (item.name == f.workName) {
                                find = true;
                                break;
                            }
                        }

                        if (!find) {
                            f.ajaxError = false;
                            f.ajaxErrorText = '';
                            return true;
                        } else {
                            f.ajaxError = true;
                            f.ajaxErrorText = Ext.String.format(_S('MESSAGE', 'HN00020'));
                            Ext.form.VTypes.filterNameText = Ext.String.format(_S('MESSAGE', 'HN00020'));
                            return false;
                        }
                    },
                    failure: function (json, opts) {
                        f.ajaxError = true;
                        f.ajaxErrorText = json.error_msg + '(Error ' + json.error_code + ')';
                        Ext.form.VTypes.filterNameText = f.ajaxErrorText;
                        return false;
                    }

                });

                return true;
            }

            if (f.ajaxError) {
                Ext.form.VTypes.filterNameText = f.ajaxErrorText;
                return false;
            }
            return true;

        };
    },
    showErrorMsgWin: function (act, json, win, icon, cb) {
        var errors;

        if (act == 'torrent-list') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_LIST')
            };
        } else if (act == 'torrent-info') {
            errors = {
            };
        } else if (act == 'multi-torrent-upload') {
            errors = {
				5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_URL'),
                5041: _S('DOWNLOAD_CENTER', 'ERROR_URL'),
				5044: _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_UPLOAD_TORRENT'),
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
        } else if (act == 'torrent-add-url') {
            errors = {
                5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_URL'),
                5019: _S('DOWNLOAD_CENTER', 'TORRENT_ALREADY'),
                5040: _S('DOWNLOAD_CENTER', 'UNABLE_DOWNLOAD_TORRENT_FILE'),
                5041: _S('DOWNLOAD_CENTER', 'INVALID_FORMAT'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_TORRENT_URL')
            };
        } else if (act == 'torrent-add') {
            errors = {
				5008: _S('MESSAGE', 'HN00007'),
                5019: _S('DOWNLOAD_CENTER', 'TORRENT_ALREADY'),
                5041: _S('DOWNLOAD_CENTER', 'ERROR_URL'),
				5044: _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_TORRENT'),
                5605: _S('ERROR', 'NO_SPACE_DISK'),
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
        } else if (act == 'torrent-set') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_CONFIG_INFORMATION')
            };
        } else if (act == 'torrent-remove') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_REMOVE_TORRENT')
            };
        } else if (act == 'torrent-start') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_START_SEEDING')
            };
        } else if (act == 'torrent-stop') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_STOP_SEEDING')
            };
        } else if (act == 'torrent-queue') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_CHANGE_DOWNLOAD_ORDER')
            };
        } else if (act == 'get-user-pref') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_PERFENCES'),
                5302: _S('ERROR', 'INCORRECT_PARAMETER')
            };
        } else if (act == 'set-pref') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_PERFENCES'),
				5048: _S('EZ_ACCESS', 'NOTE_CONFLICT'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS'),
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
        } else if (act == 'set-user-initial-pref') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_PERFENCES'),
				5044 : _S('ERROR', 'UNKNOWN_ERROR'),
                5205: _S('DOWNLOAD_CENTER', 'CANNOT_APPLY'),
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
		} else if (act == 'extract-get') {
			errors = {
                5302: _S('ERROR', 'INCORRECT_PARAMETER')
            };
		} else if (act == 'extract-set') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_PERFENCES'),
				5048: _S('EZ_ACCESS', 'NOTE_CONFLICT'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS'),
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
        } else if (act == 'torrent-search-site-list') {
            errors = {
                5005: _S('ERROR', 'UNABLE_OBTAIN_SEARCH_LIST')
            };
        } else if (act == 'torrent-search-site-enable') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS')
            };
        } else if (act == 'torrent-search-request') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'UNABLE_SEARCH_KEYWORD')
            };
        } else if (act == 'torrent-search-response') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_RESULTS_TRY_KEY')
            };
        } else if (act == 'torrent-search-index') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_RESULTS_TRY')
            };
        } else if (act == 'torrent-search-delete') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'KEYWORD_NOT_EXIST')
            };
        } else if (act == 'torrent-search-category') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_CATEGORY_LIST')
            };

        } else if (act == 'torrent-scheduler-get') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_DOWNLOAD_SCHEDULE')
            };
        } else if (act == 'torrent-scheduler-set') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_PERFENCES'),
                5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_DOWNLOAD_SCHEDULE'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS')
            };
        } else if (act == 'rss-feed-list') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_RSS_FEED_LIST')
            };
        } else if (act == 'rss-feed-add') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_RSS_FEED')
            };
        } else if (act == 'rss-feed-edit') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS')
            };
        } else if (act == 'rss-feed-delete') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_REMOVE_RSS_FEED')
            };
        } else if (act == 'rss-feed-update') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_UPDATE_RSS_FEED')
            };
        } else if (act == 'rss-item-list') {
            errors = {
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_RSS_ITEM_LIST')
            };
        } else if (act == 'rss-filter-list') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'CREATE_FILTER_NO_FEED'),
                5006: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_RSS_FILTER_LIST')
            };
        } else if (act == 'rss-filter-add') {
            errors = {
                5005: _S('DOWNLOAD_CENTER', 'CREATE_FILTER_NO_FEED'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_RSS_FILTER')
            };
        } else if (act == 'rss-filter-edit') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS')
            };
        } else if (act == 'rss-filter-delete') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_REMOVE_RSS_FILTER')
            };
        } else if (act == 'download-list') {
            errors = {
                5000: _S('DOWNLOAD_CENTER', 'SESSION_TIMEOUT')
            };
        } else if (act == 'download-add') {
            errors = {
				5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_URL'),
                5041: _S('DOWNLOAD_CENTER', 'ERROR_URL'),
				5044: _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_TASK'),
				5402: _S('DOWNLOAD_CENTER', 'NO_MORE_TASK'),	//1000 tasks!
                5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
            };
        } else if (act == 'download-delete') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_REMOVE_TASK')
            };
        } else if (act == 'download-start') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_START_TASK')
            };
        } else if (act == 'download-stop') {
            errors = {
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_STOP_TASK')
            };
        } else if (act == 'tracker-add') {
            errors = {
                5000: _S('DOWNLOAD_CENTER', 'SESSION_TIMEOUT'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_TRACKER')
            };
        } else if (act == 'tracker-remove') {
            errors = {
                5000: _S('DOWNLOAD_CENTER', 'SESSION_TIMEOUT'),
                5401: _S('DOWNLOAD_CENTER', 'UNABLE_DELET_TRACKER')
            };
        } else {
            errors = {
                0000: act
            };
            json.error_code = 0000;
        }

        winapp.errorMsgWindow = AS.ARC.util.showMsgWindow(errors, json, win, icon, cb);
    },
    isShowRssMsg: false,
    showMsgWin: function (msg) {
        var info = Ext.create(Ext.form.field.Display, {
            value: msg
        });
        var win = new AS.ARC.msgWindow({
            title: _S('COMMON', 'WARNING'),
            parentWin: winapp.win,
            scope: this,
            iconType: 'question',
            fbar: [{
                text: _S('COMMON', 'OK'),
                handler: function () {
                    winapp.isShowMsg = false;
                    win.close();
                }
            }],
            asItems: [info]
        });

        win.show();
        winapp.isShowMsg = true;
	},
	isReadOnly: function(value) {
		var fs = this;

		if (!(fs.ASACL_PERM_APPEND_DATA_OR_ADD_DIR & value) &&
			!(fs.ASACL_PERM_WRITE_DATA_OR_ADD_FILE & value) &&
			!(fs.ASACL_PERM_DELETE & value) &&
			!(fs.ASACL_PERM_DELETE_CHILD & value)) {
				return true;
		} else {
			return false;
		}
	},
    init: function (config) {
		//******************************************************** DEFINE VALUE ********************************************************************
		//define this
		var winapp = this;
		//define selected tree node id
		var locationTreeSelectedId = winapp.ROOT_PATH;
		//define expand node list
		var expandList = new Array();
		//define bt download list
		var btDownloadList = new Array();
		//define BtStore's use filter
		var BTStoreFilter = null;
		//define Search sue filter
		var SearchStoreFilter = null;
		//define preferences default download dir path
		var defaultDir = winapp.DEFAULT_DOWNLOAD_DIR;
		var assignDir = defaultDir;

		var allIndex = -1;
		var downloadingIndex = -1;
		var completedIndex = -1;
		var activeIndex = -1;
		var inactiveIndex = -1;
		var downloadPanelValue = 'all';

		var doActionWin = false;

		var urlList = new Array();
		var urlResultList = new Array();

		var downloadType = '';
		var torrent_list = [];
		var torrent_list_index = 0;
		var torrentListTypeSavePath = '';
		var upload_files = [];

        //sort value
		var gridSort = 'position';
		var gridDir = 'asc';
		var filterKey = '';

		//_D('AS.ARC.config.baseUrl:'+AS.ARC.config.baseUrl);
		//******************************************************** DEFINE CONSTRUCT & PROTOTYPE ********************************************************************
		function RemoveArray(array,attachId)
		{
			for(var i=0,n=0;i<array.length;i++)
			{
				if(array[i]!=attachId)
				{
					array[n++]=array[i]
				}
			}
			array.length -= 1;
		}
		Array.prototype.remove = function (obj) {
			return RemoveArray(this,obj);
		};

		winapp.setFields();
		//********************************************************  DEFINE FUNCTION ********************************************************************
		//========================================================= COMMON FUNCTION =========================================================

		var createErrorMsgWin = function (json, parentWin, cb) {
		    if (typeof height === 'undefined') {
		        var winheight = 180;
		    } else {
		        var winheight = height;
		    }
		    if (typeof width === 'undefined') {
		        var winwidth = 400;
		    } else {
		        var winwidth = width;
		    }
		    var s = '',
            title = _S('COMMON', 'WARNING');
		    var errors = {};
		    if (json.apiResponseError) {
		        s = _S('ERROR', 'UNKNOWN_ERROR') + ': API Error';
		    } else {
		        var allErrors = {
		            3001: _S('ERROR', 'CONFIG_ERROR'),
		            5000: _S('COMMON', 'SESSION_TIMEOUT'),
		            5006: _S('ERROR', 'CONFIG_ERROR'),
					5008: _S('MESSAGE', 'HN00007'),
		            5009: _S('DOWNLOAD_CENTER', 'INVALID_FORMAT'),
		            5019: _S('DOWNLOAD_CENTER', 'TORRENT_ALREADY'),
		            5040: _S('DOWNLOAD_CENTER', 'UNABLE_DOWNLOAD_TORRENT_FILE'),
                    5041: _S('DOWNLOAD_CENTER', 'INVALID_FORMAT'),
					5044: _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE'),
		            5301: _S('ERROR', 'UNEXPECTED_ACTION'),
		            5302: _S('ERROR', 'INCORRECT_PARAMETER'),
		            5303: _S('ERROR', 'INCORRECT_PARAMETER'),
		            5401: Ext.String.format(_S('ERROR', 'CANNOT_APPLY'), _S('ERROR', 'UNKNOWN_ERROR')),
		            5605: _S('ERROR', 'NO_SPACE_DISK'),
					5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
		        };

		        Ext.apply(allErrors, errors);

		        if (typeof allErrors[json.error_code] !== 'undefined') {
		            s = allErrors[json.error_code];
		        } else {
		            s = _S('ERROR', 'UNKNOWN_ERROR');
		        }

		        if (json.hide_error_code !== true) {
		            s += ' (Ref. ' + json.error_code + ')';
		        }
		    }

		    if (typeof icon === 'undefined' || icon === '') {
		        icon = 'warning';
		    } else {
		        if (typeof AS.ARC.config.iconTypes[icon] === 'undefined') {
		            icon = 'warning';
		        }
		    }

		    if (icon === 'info') {
		        title = _S('COMMON', 'INFORMATION');
		    }

		    var topContainer = new Ext.create(Ext.container.Container, {
		        height: 1
		    });
		    //s = 'Configuration parameter is incorrect. (Error 5302)'+'Configuration parameter is incorrect. (Error 5302)'+'Configuration parameter is incorrect. (Error 5302)';
		    if (s.length <= 50) {
		        topContainer.setHeight(12);
		    } else if (s.length <= 100) {
		        topContainer.setHeight(6);
		    } else {
		        topContainer.setHeight(0);
		    }

		    var win = new AS.ARC.msgWindow({
		        parentWin: parentWin,
		        title: title,
		        width: winwidth,
		        height: winheight,
		        iconType: icon,
		        asItems: [
                {
                    xtype: 'container',
                    layout: 'vbox',
                    width: winwidth - 50,
                    height: winheight - 85,
                    items: [
                    topContainer,
                    {
                        xtype: 'displayfield',
                        width: winwidth - 90,
                        value: s
                    }
                    ]
                }
		        ],
		        fbar: [{
		            text: _S('COMMON', 'OK'),
		            handler: function (btn) {
		                btn.up().up().close();
						isFirstOpen = false;

		                if (typeof cb !== 'undefined' && cb !== '') {
							parentWin.close();
							cb();
		                }
		                checkStatusFromDoMultiSelectAction();
		                reloadBTStore();
		                winapp.isShowMsg = false;
		            },
		            scope: this
		        }]
		    });

		    win.show();
		    winapp.isShowMsg = true;
		};

		function trim(stringToTrim) {
			return stringToTrim.replace(/^\s+|\s+$/g,"");
		};
		//get folder name
		var getFolderName = function(path) {
			var findIndex = path.lastIndexOf('/');
			var folderName = path;
			if (findIndex != -1 ) {
				var folderName = path.substring(findIndex+1, path.length);
			}
			return folderName;
		};

		//replace array value
		function replace(arrayName,replaceTo, replaceWith) {
			for(var i=0; i<arrayName.length;i++ ) {
				if(arrayName[i]==replaceTo)
				arrayName.splice(i,1,replaceWith);
			}
		};

		var totalDLData = [];
		var reDrawChart = function() {
			//create chart data
			var urlOpts = {
				act: 'torrent-list'

			};

			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					var totalData = [json.total_download_speed, json.total_upload_speed,  new Date()];
					totalDLData.push(totalData);
					speedStore = createSpeedStore();
				},
				failure: function (json, opts) {
					winapp.showErrorMsgWin('torrent-list', json, winapp.win);
				}
			});
		};

		//create all filter
		var filterType = '';
		var settingDownloadStateFilter = function(state) {
			var filters;

			if (state === 'all') {
				filters = null;
				filterType = 'all';
			} else if (state === 'downloading') {
				filters = new Ext.util.Filter({
					filterFn: function(item) {
					    return item.get('status') == 'Downloading' || item.get('status') == 'Stopped' || item.get('status') == 'Queued' || item.get('status') == 'Limited';
					}
				});

				filterType = 'download';
			} else if (state === 'completed') {
				filters = new Ext.util.Filter({
					filterFn: function(item) {
					    return item.get('status') == 'Finished' || item.get('status') == 'Seeding' || item.get('status') == 'Limited';
					}
				});

				filterType = 'completed';
			} else if (state === 'active') {
				filters = new Ext.util.Filter({
					filterFn: function(item) {
					    return item.get('status') == 'Downloading' || item.get('status') == 'Seeding' || item.get('status') == 'Limited';
					}
				});

				filterType = 'active';
			} else if (state === 'inactive') {
				filters = new Ext.util.Filter({
					filterFn: function(item) {
					    return item.get('status') == 'Stopped' || item.get('status') == 'Error' || item.get('status') == 'Queued' || item.get('status') == 'Finished';
					}
				});

				filterType = 'inactive';
			} else {
				filters = null;
				filterType = 'all';
			}

			BTStoreFilter = filters;
			filterKey = '';
		};

		//create search bt key filter

		var createBTKeyFilter = function (key) {
			var filters =
				new Ext.util.Filter({
				    filterFn: function (item) {
				        var check = item.get('name');
				        check = check.toLowerCase();
						var lowKey = key.toLowerCase();
						return check.indexOf(lowKey) != -1;
				  }
				})
			;
			BTStoreFilter = filters;
			filterKey = key;
		};

		//open new window use searchRecord
		var openWindow = function(link, title) {
			if (link.indexOf('magnet:') === -1) {
				window.open(link,"_blank", title);
			}
		};

		//get file size transfor number file size
		var getInfoSize = function(value) {
			var result = '';
			if (value > (1024 * 1024 * 1024)) {
				var gb = value / (1024 * 1024 * 1024);
				result = gb.toFixed(2) + ' GB';
			} else if (value > (1024* 1024)) {
				var mb = value / (1024 * 1024);
				result = mb.toFixed(2) + ' MB';
			} else if (value > 1024) {
				var kb = value /1024;
				result = kb.toFixed(2) + ' KB';
			} else if ( value > 0 ) {
				result = '1 KB';
			}
			else {
				result = '0 KB';
			}
			return result;
		};

		//get file size from string ex: 393 MB
		var getSize = function(value) {
			var result=0;
			if (value.length != 0) {
				var unit = 0;
				var number = 0;
				var tindex = value.indexOf('TB');
				var gindex = value.indexOf('GB');
				var mindex = value.indexOf('MB');
				var kindex = value.indexOf('KB');
				if (tindex != -1) {
					unit = 1024* 1024* 1024* 1024;
					number = value.substring(0, tindex).trim();
				}
				else if (gindex != -1) {
					unit = 1024* 1024* 1024;
					number = value.substring(0, gindex).trim();
				}
				else if (mindex != -1) {
					unit = 1024* 1024;
					number = value.substring(0, mindex).trim();
				} else {
					unit = 1024;
					number = value.substring(0, kindex).trim();
				}

				number = AS.ARC.util.decimal(number, 2);
				result = number * unit;
			}
			return result;
		};

		//get selected download record total size
		var countSize = function(valueArray) {
			var total = 0;
			var eachNumber = 0;
			for (var i=0; i< valueArray.length; i++) {
				eachNumber = getSize(valueArray[i]);
				total += eachNumber;
			}
			total = getInfoSize(total);
			return total;
		};
		//========================================================= HISTORY FUNCTION =========================================================
		var HistoryData = [];

		var insertSearchRecord = function(key) {
			var checkHistoryDataLimit = function() {
				var historyDataLimit = 20,
					isHistoryDataOverLimit = HistoryData.length > historyDataLimit;

				if (isHistoryDataOverLimit) {
					HistoryData.splice(0, 1);
				}
			};

			if (typeof(key) != 'undefined') {
				var length = HistoryData.length;
				var find = false;
				for (var i=0; i< length; i++) {
					var item = HistoryData[i];
					//console.dir(item);
					if (item.query == key) {
						find = true;
						break;
					}

				}
				if (!find) {
					var item = {
						query: key,
						sort: searchSort,
						order: searchOrder
					};
					HistoryData.push(item);

					checkHistoryDataLimit();
				}
			}
		};
		var changeSearchData = function(sort, order) {
			var length = HistoryData.length;

			for (var i = 0; i < length; i++) {
				var item = HistoryData[i];

				item.sort = sort;
				item.order = order;
			}
		};

		var getSearchData = function(urlOpts, key) {
			if (HistoryData.length != 0) {
				var length = HistoryData.length;
				for (var i=0; i< length; i++) {
					var item = HistoryData[i];
					if (item.query == key) {
						var option = {
							sortby: item.sort,
							orderby: item.order
						}
						urlOpts = Ext.apply(urlOpts, option);
						break;
					}
				}
			}
			return urlOpts;
		};
		var removeSearchData = function(key) {
			var checkHistoryData = HistoryData.clone();
			var length = checkHistoryData.length;
			HistoryData= [];
			for (var i=0; i< length; i++) {
				var item = checkHistoryData[i];
				if (item.query != key) {
					HistoryData.push(item);
				}
			}
		};
		//========================================================= RENDERER FUNCTION =========================================================
		var replaceStr = function (string) {
			var tempStr = '',
				tempArray;
			tempArray = string.split('&quot;');
			for(var i = 0; i < tempArray.length; i++) {
				tempStr = tempStr + tempArray[i];
			}
			return tempStr;
		};
		var fileOfTorrentRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
			var folderPath = '';
			if(record.data.save_as !== undefined) {
				if (winapp.RSS_ROWINDEX.indexOf(rowIndex) !== -1) {
					result = '<font color="#FF0000">' + value + '</font>';
					document.getElementById('rssIcon').style.display = 'inline-block';
				} else {
					result = Ext.htmlEncode(value);
				}
			} else {
				result = Ext.htmlEncode(value);
			}
			
			if (result.indexOf('&quot;') !== -1 ) {
				result = Ext.htmlEncode(result);
				result = replaceStr(result);
			}
			metaData.tdAttr = 'data-qtip="' + result + '"';
			return result;
		};
		var rssFeedGridRenderer = function (value, metaData, record, rowIndex, colIndex, store) {
		    var code = record.data['error-code'];
		    if (code < 0) {
		        result = '<font color="#FF0000">' + value + '</font>';
		    } else {
		        result = value;
		    }
		    metaData.tdAttr = 'data-qtip="' + value + '"';
		    return result;
		};
		//========================================================= DOWNLOAD CENTER FUNCTION WINDOW =========================================================
		//create edit torrent info window

		var openEditTorrentInfoWindow = function(parentWin) {
			//-------------------------------------- edit torrent info UI ---------------------------------------------------
			doActionWin = true;
			var infoStore = null;
			var dirInfo = Ext.create(Ext.form.field.Display, {
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_DIRECTORY'),
				labelWidth: 100,
				width: 100,
				margin: '0'
			});
			var directoryText = Ext.create('Ext.form.field.Display', {
				width: 250,
				flex: 1
			});
			var browser = Ext.create('Ext.button.Button', {
				text: _S('COMMON','BROWSE'),
				flex: 0,
				disabled: true,
				handler: function () {
					var fs = Ext.create('Downloadcenter.treeselector', {
						parentWin: editInfoWin,
						objectPath: directoryText
					});
					fs.win.show();
				}
			});
			var showName = Ext.create('Ext.form.field.Display', {
				value: '',
				fieldLabel: _S('COMMON','NAME'),
				anchor: '100%'
			});
			var showSize = Ext.create('Ext.form.field.Display', {
				value: '',
				fieldLabel: _S('COMMON','SIZE'),
				anchor: '100%'
			});
			var sm = Ext.create('Ext.selection.CheckboxModel');
			//create torrent info grid data store
			var torrentName = '';
			var totalSizeArray;
			var sortBy = 'file_name';
			var orderBy = 'asc';
			var showId = '';
			var createEditInfoStore = function(id) {
				showId = id;
				var urlOpts = {
					act: 'torrent-info',
					id: id,
					sortby: sortBy,
					orderby: orderBy
				};

				//grid store
				var listStore = Ext.create('Ext.data.JsonStore', {
				    autoDestroy: true,
                    autoLoad: false,
					pageSize: winapp.GRIDPANEL_PAGESIZE,
					fields: [
						'file_id', 'file_wanted', 'file_name', 'file_size', 'file_downloaded', 'file_percent', 'file_isize'
					],
					remoteSort: true,
					proxy: {
						type: 'ajax',
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						reader: {
							type: 'json',
							root: 'files'
						}
					},
					listeners: {
						load: function( store, records, successful, operation, eOpts ) {

							if (records.length !== 0) {
								editInfoPanel.bindStore(listStore);

								var getProxy = store.getProxy();

								DownloadCenter.changeValueUseEllipsis(getProxy.reader.jsonData.name, showName);
                                
                                var downloadDir = getProxy.reader.jsonData.download_dir;
                                downloadDir = changeToHome(downloadDir);
								DownloadCenter.changeValueUseEllipsis(downloadDir, directoryText);

								var check = false;
								var recordlsit = new Array();
								totalSizeArray = new Array();
								for (var i=0; i< records.length; i++) {
									check = records[i].data.file_wanted;
									var record = records[i];
									if (check) {
										recordlsit.push(record);
										totalSizeArray.push(records[i].data.file_size);
									}
								}
								editInfoPanel.getSelectionModel().select(recordlsit);
								
								var torrentSize = countSize(totalSizeArray);
								showSize.setValue(torrentSize);
							}

							if (typeof(editInfoPanel) != 'undefined') {
							    if (typeof (editInfoPanel.el) != 'undefined') {
							        editInfoPanel.el.unmask();
							    }
							}
						}
					}
				});

				return listStore;
			};

			var reloadEditInfoStore = function(id) {

				var urlOpts = {
					act: 'torrent-info',
					id: showId,
					sortby: sortBy,
					orderby: orderBy
				};

				//grid store
				var listStore = Ext.create('Ext.data.JsonStore', {
				    autoDestroy: true,
				    autoLoad: false,
					pageSize: winapp.GRIDPANEL_PAGESIZE,
					fields: [
						'file_id', 'file_wanted', 'file_name', 'file_size', 'file_downloaded', 'file_percent', 'file_isize'
					],
					remoteSort: true,
					proxy: {
						type: 'ajax',
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						reader: {
							type: 'json',
							root: 'files'
						}
					},
					listeners: {
						load: function( store, records, successful, operation, eOpts ) {

							if (records.length != 0) {
								editInfoPanel.bindStore(listStore);

								var getProxy = store.getProxy();

								DownloadCenter.changeValueUseEllipsis(getProxy.reader.jsonData.name, showName);
								
								var downloadDir = getProxy.reader.jsonData.download_dir;
								downloadDir = changeToHome(downloadDir);
								DownloadCenter.changeValueUseEllipsis(downloadDir, directoryText);

								var check = false;
								var recordlsit = new Array();
								totalSizeArray = new Array();
								for (var i=0; i< records.length; i++) {
									check = records[i].data.file_wanted;
									var record = records[i];
									if (check) {
										recordlsit.push(record);
										totalSizeArray.push(records[i].data.file_size);
									}

								}
								editInfoPanel.getSelectionModel().select(recordlsit);
								var torrentSize = countSize(totalSizeArray);
								showSize.setValue(torrentSize);
							}
							if (typeof(editInfoPanel) != 'undefined') {
							    if (typeof (editInfoPanel.el) != 'undefined') {
							        editInfoPanel.el.unmask();
							    }
							}
						}
					}
				});

				listStore.load();
			};

			var editInfoPanel = Ext.create('Ext.grid.GridPanel', {
				itemId: 'info-grid',
				height: 210,
				cls: 'download-center-edit-torrent-gridPanel',
				border: false,
				resizable: false,
				autoScroll: true,
				scope: this,
				selModel: sm,
				buffered: true,
				viewConfig: {
					emptyText: _S('DOWNLOAD_CENTER', 'INFO_NO_RECORDS'),
					onStoreLoad: Ext.emptyFn,
					focusRow: Ext.emptyFn,
					loadMask: false,
					style: {overflow: 'auto', overflowX: 'auto'}
				},
				scope: this,
				columns: [{
					xtype: 'gridcolumn',
					flex: 1,
					width: 100,
					dataIndex: 'file_name',
					text: _S('COMMON','NAME'),
					resizable: false,
					renderer: fileOfTorrentRenderer
				},{
					xtype: 'gridcolumn',
					flex: 0,
					width: 100,
					resizable: false,
					dataIndex: 'file_size',
					text: _S('COMMON','SIZE'),
					renderer: sizeUnitRender
				}],
				listeners: {
					selectionchange: function( model, selected, eOpts )	{
						totalSizeArray = new Array();
						for (var i=0; i< selected.length; i++) {
							totalSizeArray.push(selected[i].data.file_size);
						}
						var torrentSize = countSize(totalSizeArray);
						showSize.setValue(torrentSize);
					},
					sortchange: function ( ct, column, direction, eOpts ) {
						sortBy = column.dataIndex;
						if (direction !== null) {
							orderBy = direction.toLowerCase();
						}
						reloadEditInfoStore();
					},
					afterrender: function(Grid) {
						Ps.initialize(Grid.body.dom);
						Ps.update(Grid.body.dom);
					}
				}
			});
			//-------------------------------------- edit torrent info action ---------------------------------------------------
			var goEditTorrentInfo = function() {
				var store = editInfoPanel.getStore();
				var records = store.getRange();
				var select = editInfoPanel.getSelectionModel().getSelection();
				var unWantList = '';
				var wantList = '';
				for (var i=0; i< records.length; i++) {
					var record_id = records[i].data.file_id;
					var find = false;
					for (var j=0; j < select.length; j++) {
						var check_id = select[j].data.file_id;
						if (record_id == check_id)
						{
							find = true;
							break;
						}
					}

					if (!find) {
						unWantList += record_id+',';
					} else {
						wantList += record_id+',';
					}

				}

				var downloadDir = directoryText.getValue();
                downloadDir = changeHomeFolder(downloadDir);

				var urlOpts = {
					act: 'torrent-set',
					id: downloadRecord.data.id,
					download_dir: downloadDir,
					file_wanted: wantList,
					file_unwanted: unWantList
				};

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						reloadBTStore();
						var layout = mainPanel.getLayout();
						layout.setActiveItem(0);
						var tlayout = toolBarContainer.getLayout();
						tlayout.setActiveItem(winapp.TOOLBAR_INDEX_DOWNLOAD);

						totalDLInfo.show();
						tabPanel.show();
					},
					failure: function (json, opts) {
					    if (typeof(winapp.win) != 'undefined') {
					        if (typeof(winapp.win.el) != 'undefined') {
					            winapp.win.el.unmask();
					        }
					    }
						winapp.showErrorMsgWin('torrent-set', json, winapp.win);
					}
				});

			};
			//-------------------------------------- edit torrent info window ---------------------------------------------------
			var editInfoWin = Ext.create('AS.ARC.subWindow', {
				title: _S('DOWNLOAD_CENTER', 'TITLE_EDIT_TASK'),
				width: 550,
				height: 550,
				cls: 'download-center-edit-torrent-win',
				parentWin: parentWin,
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function() {
						goEditTorrentInfo();
						editInfoWin.close();
					}
				},{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						editInfoWin.close();
					}
				}],
				items: [
				{
					xtype: 'asPanelTop20',
					height: 400,
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					items: [{
						xtype: 'fieldset',
						itemId: 'edit-torrent-info-general-set',
						title: _S('COMMON', 'GENERAL'),
						items: [{
							xtype: 'asFlexbox',
							border: false,
							margin: '0',
							padding: '0',
							items: [
							dirInfo,
							directoryText
							]
						}]
					},{
						xtype: 'fieldset',
						itemId: 'edit-torrent-info-content-set',
						title: _S('DOWNLOAD_CENTER', 'INFO_FILES'),
						items: [
						showName,
						showSize,
						editInfoPanel
						]
					}]
				}],
				listeners: {
					render: function(com , eOpts) {
						doActionWin = true;
					},
					show: function(com, eOpts) {
					    editInfoPanel.el.mask(_S('COMMON', 'LOADING'));

						setTimeout(function() {
						    infoStore = createEditInfoStore(downloadRecord.data.id);
						    infoStore.load();

						}, 1000);
					},
					beforeclose: function(com, eOpts) {
						doActionWin = false;
					}
				}
			});
			editInfoWin.show();

		};

		//create add torrent info window
		var openAddTorrentInfoWindow = function(result, path, magnet) {

			if(winapp.currentTaskCount + 1 >= winapp.MAX_TASK_NUMBER_EACH_TIME) {	//is task full?
				winapp.showErrorMsgWin('download-add', {error_code: 5402}, winapp.win);
				return false;
			}

			//-------------------------------------- add torrent info UI ---------------------------------------------------
			var infoName = '';
			var infoSize = '';
			var addInfoStore = null;
			if (typeof(result.name) != winapp.TYPEOF_UNDEFINE) {
				infoName = result.name;
			}
			if (typeof(result.total_size) != winapp.TYPEOF_UNDEFINE) {
				infoSize = result.total_size;
			}
			var directoryText = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_DIRECTORY'),
				labelWidth: 150,
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				width: 400,
				msgTarget : 'side',
				listeners: {
				    afterrender: function (com, eOpts) {
						if(path !== '') {
							path = (path?changeToHome(path):path);

							var directoryValue = changeToHome(defaultDir);
						} else { path = changeToHome(defaultDir); }
                        
						DownloadCenter.changeValueUseEllipsis(path?path:directoryValue, directoryText);
					}
				}
			});
			var browser = Ext.create('Ext.button.Button', {
				text: _S('COMMON','BROWSE'),
				style: 'left: 20px;',
				handler: function () {
					var fs = Ext.create('DownloadCenter.treeSelector', {
						parentWin: addInfoWin,
						objectPath: directoryText
					});
					fs.win.show();
				}
			});
			var topQueue = Ext.create('Ext.form.field.Checkbox', {
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ADD_TOP_QUEUE'),
				anchor: '100%'
			});
			var showName = Ext.create('Ext.form.field.Text', {
				fieldLabel: _S('COMMON','NAME'),
				labelWidth: 100,
				width: 490,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				msgTarget : 'side',
				listeners: {
				    afterrender: function (com, eOpts) {
						if (typeof(result.files) !== winapp.TYPEOF_UNDEFINE) {
							com.setValue(result.name);
						} else {
							com.setValue(result.title);
						}
				    },
					validitychange: function( com, isValid, eOpts ) {
						if (addInfoWin) {
							addInfoWin.down('[itemId=addInfoWin-btnOk]').setDisabled(!isValid);
						}
					}
				}
			});
			var showSize = Ext.create('Ext.form.field.Display', {
				value: result.total_size,
				fieldLabel: _S('COMMON','SIZE'),
				anchor: '100%'
			});

			var allInfoId = null;
			var getaddInfoStore = function() {
				var itemsDatas=[];
				allInfoId = new Array();
				for (var i=0; i< result.files.length; i++) {
					var data = [result.files[i].file_id, result.files[i].file_name, result.files[i].file_size, result.files[i].file_isize];
					itemsDatas.push(data);
					allInfoId.push(result.files[i].file_id);
				}

				var addInfoStore = new Ext.data.ArrayStore({
					fields: [
						{name: 'file_id'},
						{name: 'file_name'},
						{name: 'file_size'},
						{name: 'file_isize'}
					]
				});
				addInfoStore.loadData(itemsDatas);

				return addInfoStore;
			};

			if (typeof(result.files) != winapp.TYPEOF_UNDEFINE) {
				addInfoStore = getaddInfoStore();
			} else {
				showName.setValue('--');
				showSize.setValue('--');
			}

			var sm = Ext.create('Ext.selection.CheckboxModel', {
				listeners: {
					selectionchange: function( model, selected, eOpts ) {
						if (selected.length != 0) {
							btnOK.setDisabled(false);
						} else {
							btnOK.setDisabled(true);
						}
					}
				}
			});

			var addInfoPanel = Ext.create('Ext.grid.GridPanel', {
				itemId: 'info-grid',
				height: 200,
				border: false,
				resizable: false,
				store: addInfoStore,
				autoScroll: true,
				scope: this,
				selModel: sm,
				buffered: true,
				viewConfig: {
					emptyText: _S('COMMON','EMPTY_NO_RECORDS'),
					onStoreLoad: Ext.emptyFn,
					focusRow: Ext.emptyFn,
					loadMask: false,
					style: {overflow: 'auto', overflowX: 'hidden'}
				},
				columns: [
				{
					xtype: 'gridcolumn',
					flex: 1,
					width: 100,
					dataIndex: 'file_name',
					text: _S('COMMON','NAME'),
					resizable: false,
					renderer: fileOfTorrentRenderer
				},{
					xtype: 'gridcolumn',
					flex: 0,
					width: 90,
					dataIndex: 'file_isize',
					resizable: false,
					text: _S('COMMON','SIZE'),
					renderer: sizeUnitRender
				}],
				listeners: {
					selectionchange: function( model, selected, eOpts )	{

						totalSizeArray = new Array();
						for (var i=0; i< selected.length; i++) {
							totalSizeArray.push(selected[i].data.file_size);
						}
						var torrentSize = countSize(totalSizeArray);
						showSize.setValue(torrentSize);

					},
					afterrender: function (addGrid) {
						Ps.initialize(addGrid.body.dom);
						Ps.update(addGrid.body.dom);
					}
				}
			});
		    //-------------------------------------- add torrent info action ---------------------------------------------------

			var checkTorrentList = function() {
				if (downloadType === 'torrent_list') {
					if (torrent_list_index < torrent_list.length - 1) {
						openAddTorrentInfoWindow(torrent_list[++torrent_list_index], torrentListTypeSavePath);
					} else {
						downloadType = '';
						torrentListTypeSavePath = '';
					}
				}
				else
					checkStatusFromDoMultiSelectAction();
			}

			var goAddTorrentInfo = function(win) {
				var select = addInfoPanel.getSelectionModel().getSelection();

				if (allInfoId != null) {

					var unWantList = '';
					var check = '';
					for (var i=0; i< allInfoId.length; i++) {
						check = allInfoId[i];
						var find = false;
						for (var j=0; j< select.length; j++) {
							if (check == select[j].data.file_id) {
								find = true;
								break;
							}
						}

						if (!find) {
							unWantList += check+',';
						}
					}
				} else {
					var unWantList = '';
				}

				var torrent = '';
				if (typeof(result.torrent) != winapp.TYPEOF_UNDEFINE) {
					//http
					torrent = result.torrent;
				} else {
					//magnet
					torrent = result.url;
				}

				if(result.error_code === 5040) {
					torrent = magnet;
				}

				var directoryValue = changeHomeFolder(directoryText.getValue());

				if (magnet) {
					torrent = magnet;
				}
                
				var urlOpts = {
					act: 'torrent-add',
					download_dir: directoryValue,
					enable_top_queue: topQueue.getValue(),
					file_unwanted: unWantList,
					torrent: torrent
				};

				if (showName.getValue() !== '') {
					Ext.apply(urlOpts, {
						filename: showName.getValue()
					});
				}

				win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						// JN: batch torrent download
						win.el.unmask();
						win.close();
						checkTorrentList();
						reloadBTStore();
					},
					failure: function (json, opts) {
						win.el.unmask();
                        if (!AS.ARC.user.isAdmin) {
                            if(json.error_code === 5044) {
								isFirstOpen = true;
                                win.close();
                                AS.ARC.util.showMsgWindow({
            						5044: _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER')
            					}, json, winapp.win, 'warning', function () {isFirstOpen = false;});
                            } else {
                                createErrorMsgWin(json, win, checkTorrentList);
                            }
                        } else {
							winapp.showErrorMsgWin('torrent-add', json, win);
                        }
					}
				});
			};

			var goAddMultiTorrentInfo = function (enable, directoryValue) {
				if (urlResultList.length >1) {
					for (var i=0; i<urlResultList.length; i++) {
						var torrent = '';
						var item = urlResultList[i];
						if (typeof(item.torrent) != winapp.TYPEOF_UNDEFINE) {
							//http
							torrent = item.torrent;
						} else {
							//magnet
							torrent = item.url;
						}
						var downloadDirValue = changeHomeFolder(directoryValue);

						var urlOpts = {
							act: 'torrent-add',
							torrent: torrent,
							download_dir: downloadDirValue,
							enable_top_queue: enable,
							file_unwanted: '',
							filename: showName.getValue()
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								checkStatusFromDoMultiSelectAction();
								reloadBTStore();
							},
							failure: function (json, opts) {
                                if (!AS.ARC.user.isAdmin) {
                                    if(json.error_code === 5044) {
                                        isFirstOpen = true;
                                        AS.ARC.util.showMsgWindow({
                    						5044: _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER')
                    					}, json, winapp.win, 'warning', function () {isFirstOpen = false;});
                                    } else {
                                        winapp.showErrorMsgWin('torrent-add', json, winapp.win);
                                    }
                                } else {
                                    winapp.showErrorMsgWin('torrent-add', json, winapp.win);
                                }
								checkStatusFromDoMultiSelectAction();
								reloadBTStore();
							}
						});
					}
				}
			}
			//-------------------------------------- add torrent info window ---------------------------------------------------

			var infoFileSet = Ext.create(Ext.form.FieldSet, {
				flex: 1,
				itemId: 'add-torrent-info-content-set',
				title: _S('DOWNLOAD_CENTER', 'INFO_CONTENT'),
				items:[
					showName,
					showSize,
					addInfoPanel
				]
			});

			if (typeof(result.files) !== winapp.TYPEOF_UNDEFINE) {
				infoFileSet.setDisabled(false);
			} else {
				infoFileSet.setDisabled(true);
			}

			var btnOK = Ext.create(Ext.button.Button, {
			    text: _S('COMMON', 'OK'),
                disabled: true,
				itemId: 'addInfoWin-btnOk',
				handler: function () {
				    if (urlResultList.length != 0) {
				        if (urlResultList.length == 1) {
				            goAddTorrentInfo(addInfoWin);
				        } else {
							var directoryValue = directoryText.el.dom.getAttribute('data-qtip');
				            goAddMultiTorrentInfo(topQueue.getValue(), directoryValue);
				        }
				        if (doMultiSelectAction) {
				            winapp.win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));
				        }
				    } else {
				        goAddTorrentInfo(addInfoWin);
				    }
				}
			});

			var addInfoWin = Ext.create('AS.ARC.subWindow', {
				title: _S('DOWNLOAD_CENTER', 'TITLE_ADD_TASK'),
				width: 550,
				height: 570,
				parentWin: winapp.win,
				fbar: [
				btnOK,
				{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						addInfoWin.close();

						// JN: batch torrent download
						checkTorrentList();

						if (doMultiSelectAction) {
							winapp.win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));
						}

					}
				}],
				items: [{
					xtype: 'asPanelTop10',
					flex: 1,
					cls: 'dc-add-win-have-gridpanel',
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					items: [{
						xtype: 'fieldset',
						itemId: 'add-torrent-info-general-set',
						title: _S('COMMON','GENERAL'),
						items: [
						{
							xtype: 'asFlexbox',
							border: false,
							margin: '0 0 0 0',
							items: [
								directoryText,
								browser
							]
						},
						topQueue
						]
					},
					infoFileSet
					]
				}],
				listeners: {
					beforerender: function( addInfoWin, eOpts) {
						var user = AS.ARC.user.isAdmin,
							panel = addInfoWin.items.items[0].items.items[0].items.items[1];

						if(!user) {
							panel.hide();
						}
					},
					show: function( com, eOpts ) {
					    if (addInfoStore != null) {

						    addInfoPanel.el.mask(_S('COMMON', 'APPLYING'));
						    setTimeout(function () {
						        addInfoPanel.getSelectionModel().selectAll();
						        if (typeof (addInfoPanel) != 'undefined') {
						            if (typeof (addInfoPanel.el) != 'undefined') {
						                addInfoPanel.el.unmask();
						            }
						        }
						        btnOK.setDisabled(false);
						    }, 1000);

						} else {
						    setTimeout(function () {
						        btnOK.setDisabled(false);
						    }, 1000);
						}
						if (doAddUrl) {
						    doAddUrl = false;
						}
					},
					render: function(com , eOpts) {
						doActionWin = true;
					},
					beforeclose: function(com, eOpts) {
					    doActionWin = false;

					}
				}
			});
			addInfoWin.show();

		};

		var openAddTorrentInfoNoFileDataWindow = function(result, path, magnet) {
			if (winapp.currentTaskCount + 1 >= winapp.MAX_TASK_NUMBER_EACH_TIME) {
				winapp.showErrorMsgWin('download-add', {error_code: 5402}, winapp.win);
				return false;
			}

			var directoryText = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_DIRECTORY'),
				itemId: 'noFileDataWinDirectoryText',
				labelWidth: 150,
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				width: 400,
				msgTarget : 'side',
				listeners: {
				    afterrender: function(com, eOpts) {
						if (path !== '') {
							path = (path ? changeToHome(path) : path);

							var directoryValue = changeToHome(defaultDir);
						} else {
							path = changeToHome(defaultDir);
						}
                        
						DownloadCenter.changeValueUseEllipsis(path ? path : directoryValue, directoryText);
					}
				}
			});
			
			var browser = Ext.create('Ext.button.Button', {
				text: _S('COMMON','BROWSE'),
				itemId: 'noFileDataWinBrowser',
				style: 'left: 20px;',
				handler: function() {
					var fs = Ext.create('DownloadCenter.treeSelector', {
						parentWin: addInfoNoFileDataWin,
						objectPath: directoryText
					});
					fs.win.show();
				}
			});

			var topQueue = Ext.create('Ext.form.field.Checkbox', {
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ADD_TOP_QUEUE'),
				itemId: 'noFileDataWinTopQueue',
				anchor: '100%'
			});

			var showName = Ext.create('Ext.form.field.Text', {
				fieldLabel: _S('COMMON','NAME'),
				itemId: 'noFileDataWinShowName',
				labelWidth: 100,
				width: 490,
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				msgTarget : 'side',
				listeners: {
				    afterrender: function(com, eOpts) {
						if (typeof(result.files) !== winapp.TYPEOF_UNDEFINE) {
							com.setValue(result.name);
						} else {
							com.setValue(result.title);
						}
				    },
					validitychange: function(com, isValid, eOpts) {
						if (addInfoNoFileDataWin) {
							addInfoNoFileDataWin.down('#noFileDataWinButtonOK').setDisabled(!isValid);
						}
					}
				}
			});

			var checkTorrentList = function() {
				if (downloadType === 'torrent_list') {
					if (torrent_list_index < torrent_list.length - 1) {
						openAddTorrentInfoWindow(torrent_list[++torrent_list_index]);
					} else {
						downloadType = '';
					}
				} else {
					checkStatusFromDoMultiSelectAction();
				}
			};

			var goAddTorrentInfo = function(win) {
				var unWantList = '';
				var torrent = '';

				if (typeof(result.torrent) !== winapp.TYPEOF_UNDEFINE) {
					torrent = result.torrent;
				} else {
					torrent = result.url;
				}

				if (result.error_code === 5040) {
					torrent = magnet;
				}

				var directoryValue = changeHomeFolder(directoryText.getValue());

				if (magnet) {
					torrent = magnet;
				}
                
				var urlOpts = {
					act: 'torrent-add',
					download_dir: directoryValue,
					enable_top_queue: topQueue.getValue(),
					file_unwanted: unWantList,
					torrent: torrent
				};

				if (showName.getValue() !== '') {
					Ext.apply(urlOpts, {
						filename: showName.getValue()
					});
				}

				win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					method: 'post',
					success: function(json, opts) {
						win.el.unmask();
						win.close();
						checkTorrentList();
						reloadBTStore();
					},
					failure: function(json, opts) {
						win.el.unmask();
                        if (!AS.ARC.user.isAdmin) {
                            if (json.error_code === 5044) {
								isFirstOpen = true;
                                win.close();
                                AS.ARC.util.showMsgWindow({
            						5044: _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER')
            					}, json, winapp.win, 'warning', function() {isFirstOpen = false;});
                            } else {
                                createErrorMsgWin(json, win, checkTorrentList);
                            }
                        } else {
							winapp.showErrorMsgWin('torrent-add', json, win);
                        }
					}
				});
			};

			var goAddMultiTorrentInfo = function(enable, directoryValue) {
				if (urlResultList.length > 1) {
					for (var i = 0; i < urlResultList.length; i++) {
						var torrent = '';
						var item = urlResultList[i];

						if (typeof(item.torrent) !== winapp.TYPEOF_UNDEFINE) {
							torrent = item.torrent;
						} else {
							torrent = item.url;
						}

						var downloadDirValue = changeHomeFolder(directoryValue);

						var urlOpts = {
							act: 'torrent-add',
							torrent: torrent,
							download_dir: downloadDirValue,
							enable_top_queue: enable,
							file_unwanted: '',
							filename: showName.getValue()
						};

						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function(json, opts) {
								checkStatusFromDoMultiSelectAction();
								reloadBTStore();
							},
							failure: function(json, opts) {
                                if (!AS.ARC.user.isAdmin) {
                                    if (json.error_code === 5044) {
                                        isFirstOpen = true;
                                        AS.ARC.util.showMsgWindow({
                    						5044: _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER')
                    					}, json, winapp.win, 'warning', function() {isFirstOpen = false;});
                                    } else {
                                        winapp.showErrorMsgWin('torrent-add', json, winapp.win);
                                    }
                                } else {
                                    winapp.showErrorMsgWin('torrent-add', json, winapp.win);
								}
								
								checkStatusFromDoMultiSelectAction();
								reloadBTStore();
							}
						});
					}
				}
			};
			
			var fileInfoFieldSet = Ext.create(Ext.form.FieldSet, {
				flex: 1,
				itemId: 'noFileDataWinFileInfoFieldSet',
				title: _S('DOWNLOAD_CENTER', 'INFO_CONTENT'),
				items:[
					showName
				]
			});

			var btnOK = Ext.create(Ext.button.Button, {
			    text: _S('COMMON', 'OK'),
                disabled: true,
				itemId: 'noFileDataWinButtonOK',
				handler: function() {
				    if (urlResultList.length !== 0) {
				        if (urlResultList.length === 1) {
				            goAddTorrentInfo(addInfoNoFileDataWin);
				        } else {
							var directoryValue = directoryText.el.dom.getAttribute('data-qtip');
				            goAddMultiTorrentInfo(topQueue.getValue(), directoryValue);
						}
						
				        if (doMultiSelectAction) {
				            winapp.win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));
				        }
				    } else {
				        goAddTorrentInfo(addInfoNoFileDataWin);
				    }
				}
			});
			
			var addInfoNoFileDataWin = Ext.create('AS.ARC.subWindow', {
				title: _S('DOWNLOAD_CENTER', 'TITLE_ADD_TASK'),
				width: 550,
				height: 350,
				parentWin: winapp.win,
				fbar: [
					btnOK,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function() {
							addInfoNoFileDataWin.close();

							checkTorrentList();

							if (doMultiSelectAction) {
								winapp.win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));
							}
						}
					}
				],
				items: [
					{
						xtype: 'asPanelTop10',
						flex: 1,
						cls: 'dc-add-win-have-gridpanel',
						defaults: {
							labelWidth: AS.ARC.config.layout.defaultLabelWidth
						},
						items: [
							{
								xtype: 'fieldset',
								itemId: 'noFileDataWinGeneralFieldSet',
								title: _S('COMMON','GENERAL'),
								items: [
									{
										xtype: 'asFlexbox',
										border: false,
										margin: '0 0 0 0',
										items: [
											directoryText,
											browser
										]
									},
									topQueue
								]
							},
							fileInfoFieldSet
						]
					}
				],
				listeners: {
					beforerender: function(addInfoNoFileDataWin, eOpts) {
						var user = AS.ARC.user.isAdmin,
							panel = addInfoNoFileDataWin.items.items[0].items.items[0].items.items[1];

						if (!user) {
							panel.hide();
						}
					},
					show: function(com, eOpts) {
						setTimeout(function() {
							btnOK.setDisabled(false);
						}, 1000);

						if (doAddUrl) {
						    doAddUrl = false;
						}
					},
					render: function(com , eOpts) {
						doActionWin = true;
					},
					beforeclose: function(com, eOpts) {
					    doActionWin = false;
					}
				}
			});

			addInfoNoFileDataWin.show();
		};

		//create add task window use torrent or link
		var openAddWin = function () {
			if(winapp.currentTaskCount + 1 >= winapp.MAX_TASK_NUMBER_EACH_TIME) {	//is task full?
				winapp.showErrorMsgWin('download-add', {error_code: 5402}, winapp.win);
				return false;
		    } else if (winapp.ADD_WIN_NUMBER < winapp.MAX_ADD_WIN) {
		        urlList.clear();
		        //-------------------------------------- add torrent UI ---------------------------------------------------
                //torrent url, thunder, magnet, qqdl
				var torrentText = Ext.create('Ext.form.field.TextArea', {
					fieldLabel:  _S('DOWNLOAD_CENTER','INFO_URL'),
					margin: '0, 0, 0, 10',
					labelWidth: 220,
					width: 580,
					flex: 0,
					listeners: {
						change: function( field, newValue, oldValue, eOpts ) {
						    urlList = [];
							var checkValue = newValue.replace(new RegExp("\n", "gm"), ",");
							var checkType = torrentType.getValue();
							checkType = (checkType.localeCompare('link') == 0) ? 'https' : checkType;
							var errorCount = 0;
							var correctCount = 0;
							validOtherLink.setValue('0');
							if (checkValue != '') {
								var temp = checkValue.split(',');
								var checkIndex= -1;
								var length = temp.length;
								for (var i=0; i< length; i++) {
									var tempItem = temp[i];
									if (tempItem != '') {
										checkIndex = tempItem.indexOf(':');
										if (checkIndex != -1) {
											var check = tempItem.substring(0, checkIndex);
											check = check.toLowerCase().trim();
											if (check == checkType) {
												correctCount++;
												urlList.push(tempItem);
											} else {
												if (checkType == 'https') {
													if (check == 'http' || check == 'https' || check == 'magnet' || check == 'ftp') {
														correctCount++;
														urlList.push(tempItem);
													} else {
														errorCount++;
													}
												} else {
													errorCount++;
												}
											}

										} else {
											errorCount++;
										}
									}
								}
								validOtherLink.setValue(correctCount);
								if (errorCount != 0) {
									btnOk.setDisabled(true);
								} else {
									btnOk.setDisabled(false);
								}
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});

				var checksavePathTorrents = true;
				var checksavePath = true;

				var canChangeLayout = false;
				//http_ftp
				var linkArea = Ext.create(Ext.form.field.TextArea, {
					cls: 'dc-add-win-textarea',
					margin: '0 0 0 10',
					height: 125,
					width: 580,
					fieldLabel: _S('DOWNLOAD_CENTER','INFO_URLS'),
					labelWidth: 220,
					listeners: {
						change: function( field, newValue, oldValue, eOpts ) {
							urlList = [];
							var errorCount = 0;
							var correctCount = 0;
							validLink.setValue('0');
							if (newValue != '') {
								var temp = newValue.split('\n');
								var checkIndex= -1;
								for (var i=0; i< temp.length; i++) {
								    var tempItem = temp[i];
								    if (tempItem != '') {
								        checkIndex = tempItem.indexOf(':');
										if (checkIndex != -1) {
										    var check = tempItem.substring(0, checkIndex);
											check = check.toLowerCase().trim();
											if (check === 'http' || check === 'https' || check === 'ftp'
											|| check === 'magnet' || check === 'thunder' || check === 'flashget' || check === 'qqdl') {
											    correctCount++;
											    urlList.push(tempItem);
											} else {
												errorCount++;
											}
										} else {
											errorCount++;
										}
									}
								}
								validLink.setValue(correctCount);
								inValidLink.setValue(errorCount);
								if (errorCount != 0) {
									btnOk.setDisabled(true);
								} else {
									btnOk.setDisabled(false);
								}
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});
				var validOtherLink = Ext.create(Ext.form.field.Display, {
					labelWidth: 150,
					value: '0',
					width: 300,
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_TOTAL_VALID_LINK'),
					margin: '0, 0, 0, 235'
				});
				var validLink = Ext.create(Ext.form.field.Display, {
					labelWidth: 150,
					value: '0',
					width: 300,
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_TOTAL_VALID_LINK'),
					margin: '0, 0, 0, 235'
				});
				var inValidLink = Ext.create(Ext.form.field.Display, {
					labelWidth: 150,
					value: 0
				});

				var pathText = Ext.create(Ext.form.field.Display, {
					value: _S('DOWNLOAD_CENTER', 'INFO_SAVE_FILES_TO')+':',
					labelWidth: 220,
					margin: '0, 0, 0, 5',
					width: 215
				});

				var saveOtherPath = Ext.create('Ext.form.field.Display',{
					labelWidth: 220,
					width: 260,
					listeners: {
						afterrender: function(com, eOpts) {
							DownloadCenter.changeValueUseEllipsis(defaultDir, saveOtherPath);
						}
					}
				});

				var saveOtherBrowse = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'BROWSE'),
					flex: 0,
					handler: function() {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							useEllipsis: true,
							showMaxLength: winapp.MAX_DISPLAY_LEHGTH_OF_PATH_DIALOG,
							objectPath: saveOtherPath
						});
						fs.win.show();
					}
				});
				var savePath = Ext.create('Ext.form.field.Text',{
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_SAVE_FILES_TO'),
					labelWidth: 225,
					width: 495,
					margin: '0, 5',
					msgTarget : 'side',
					validator: function(value){
						if(checksavePath) {
							btnOk.setDisabled(true);
							if(AS.ARC.user.isAdmin) {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
							} else {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
							}
						} else {
							btnOk.setDisabled(false);
						}

						return true;
					},
					listeners: {
						afterrender: function(com, eOpts) {
							var savePathValue = changeToHome(defaultDir);
							DownloadCenter.changeValueUseEllipsis(savePathValue, savePath);
						},
						change: function(me, newValue, oldValue, eOpts) {
							if(oldValue !== undefined) {
								if(newValue !== oldValue) {
									checksavePath = false;
								}
							}
							assignDir = newValue;
						}
					}
				});
				var savePathTorrents = Ext.create('Ext.form.field.Text',{
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_SAVE_FILES_TO'),
					labelWidth: 100,
					width: 450,
					margin: '0, 5',
					msgTarget : 'side',
					validator: function(value){
						if(checksavePathTorrents) {
							btnOk.setDisabled(true);
							if(AS.ARC.user.isAdmin) {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
							} else {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
							}
						} else {
							btnOk.setDisabled(false);
						}
						return true;
					},
					listeners: {
						change: function(me, newValue, oldValue, eOpts) {
							if(oldValue !== undefined) {
								if(newValue !== oldValue) {
									checksavePathTorrents = false;
								}
							}
							assignDir = newValue;
						}
					}
				});

				var saveBrowse = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'BROWSE'),
					flex: 0,
					handler: function() {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							useEllipsis: true,
							showMaxLength: winapp.MAX_DISPLAY_LEHGTH_OF_PATH_DIALOG,
							objectPath: savePath
						});
						fs.win.show();
					}
				});
				var saveBrowseTorrents = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'BROWSE'),
					handler: function() {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							useEllipsis: true,
							showMaxLength: winapp.MAX_DISPLAY_LEHGTH_OF_PATH_DIALOG,
							objectPath: savePathTorrents
						});
						fs.win.show();
					}
				});

				// for torrent
				var autoParseTorrent = Ext.create(Ext.form.field.Checkbox, {
					boxLabel: _S('DOWNLOAD_CENTER','AUTO_PARSE_TORRENT_URL'),
					cls: 'common-layout-horizontal-3-0'
				});
				var showDlgForDL = Ext.create(Ext.form.field.Checkbox, {
					boxLabel: _S('DOWNLOAD_CENTER','SHOW_DLG_FOR_DL'),
					cls: 'common-layout-horizontal-3-0'
				});

				var authen = Ext.create(Ext.form.field.Checkbox, {
					fieldLabel: '',
					boxLabel: _S('COMMON','AUTHENTICATION'),
					cls: 'common-layout-horizontal-3-0',
					listeners: {
						change: function( field, newValue, oldValue, eOpts ) {
							if (newValue) {
								account.setDisabled(false);
								password.setDisabled(false);
							} else {
								account.setDisabled(true);
								password.setDisabled(true);
							}
						}
					}
				});

				var account = Ext.create(Ext.form.field.Text, {
					labelWidth: 202,
					disabled: true,
					fieldLabel: _S('DOWNLOAD_CENTER','INFO_USERNAME'),
					margin: '8, 0, 0, 26',
					width: 489
				});

				var password = Ext.create(Ext.form.field.Text, {
					fieldLabel: _S('COMMON', 'PWD'),
					labelWidth: 202,
					disabled: true,
					inputType: 'password',
					margin: '8, 0, 0, 26',
					width: 489
				});

				var linkContainer = Ext.create('Ext.container.Container', {
					activeItem: 0,
					layout: {
						type: 'card'
					},
					height: 150,
					itemId: 'link-container',
					items: [
					{
						xtype: 'container',
						itemId: 'http-group',
						items: [
							linkArea,
							validLink,
							autoParseTorrent,
							showDlgForDL,
							authen,
							account,
							password,
							{
								xtype: 'asFlexbox',
								cls: 'common-layout-horizontal-3-0',
								border: false,
								height: 28,
								items: [
									savePath,
									saveBrowse
								]
							}
						],
						listeners: {
							beforeshow: function(com, eOpts) {
								var activeItem = linkContainer.getLayout().getActiveItem();
								var activeIndex = linkContainer.items.indexOf(activeItem);
								if (activeIndex == winapp.INDEX_ADD_TASK_HTTP_FTP) {
									btnOk.setDisabled(true);
								}
							}
						}
					}
					]
				});

				var torrentType = Ext.create('Ext.form.ComboBox', {
					fieldLabel: _S('DOWNLOAD_CENTER','INFO_TORRENT_URL'),
					labelWidth: 220,
					margin: '0, 0, 5, 10',
					store: new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: [
							[_S('DOWNLOAD_CENTER', 'DATA_HTTP_FTP'), 'http_ftp'],
							[_S('DOWNLOAD_CENTER', 'DATA_TORRENT_LINK'), 'link'],
							[_S('DOWNLOAD_CENTER', 'DATA_THUNDER_LINK'), 'thunder'],
							[_S('DOWNLOAD_CENTER', 'DATA_FLASHGET_LINK'), 'flashget'],
							[_S('DOWNLOAD_CENTER', 'DATA_QQDL_LINK'), 'qqdl']
						]
					}),
					displayField: 'display',
					valueField: 'value',
					editable: false,
					width: 580,
					//flex: 0,
					scope: this,
					listeners: {
						render: function( combo, eOpts ) {
							btnOk.setDisabled(true);
							torrentType.select('link');
						},
						change: function( field, newValue, oldValue, eOpts ) {
							if (canChangeLayout) {
								var panelGroup = win.items.get('panel-group').items;
								var linkGroup = panelGroup.get('link-group');
								if (!linkGroup.isHidden()) {
									var layout = linkContainer.getLayout();

									if (newValue == 'http_ftp') {
										layout.setActiveItem(1);
									} else {
										btnOk.setDisabled(true);
										torrentText.setValue('');
										layout.setActiveItem(0);
									}
								}
							}
						}
					}


				});

				// JN: for torrent list
				var showTorrentList = function(error_files, tmp_torrent_list, save_to) {
					if (error_files.length > 0) {
						var file = error_files.shift();
						var winConfirm = new AS.ARC.msgWindow({
							parentWin: win,
							title: _S('COMMON', 'ERROR'),
							iconType: 'warning',
							height: 230,
							asItems: [{
								xtype: 'displayfield',
                                itemId: 'upload-files-errwin',
								margin: '12 0 0 0',
                                width: 313
							}],
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {
                                        isFirstOpen = false;
                                        winConfirm.close();
										showTorrentList(error_files, tmp_torrent_list, save_to);
									},
									scope: this
								}
							],
                            listeners: {
                                afterrender: function(panel) {
									var errorString = '';
									
									if (!AS.ARC.user.isAdmin && file.error === 5044) errorString = _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER');
									else errorString = _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE');

									errors = {
										5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_URL'),
										5041: _S('DOWNLOAD_CENTER', 'ERROR_URL'),
										5044: errorString,
										5401: _S('DOWNLOAD_CENTER', 'UNABLE_UPLOAD_TORRENT'),
										5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
									};

									if (file.error === 5631) panel.items.items[0].items.items[0].items.get('upload-files-errwin').setValue(errors[file.error]);
									else panel.items.items[0].items.items[0].items.get('upload-files-errwin').setValue(file.name + '</br></br>' + errors[file.error]);
                                }
                            }
						});
						winConfirm.show();
					}
					else {
						win.close();
						if (tmp_torrent_list.length > 0) {
							downloadType = 'torrent_list';
		            		torrent_list = tmp_torrent_list;
							torrent_list_index = 0;
							torrentListTypeSavePath = save_to;
							openAddTorrentInfoWindow(torrent_list[torrent_list_index], save_to);
						}
						else
	                    	reloadBTStore();
					}
				};

				var showTorrentError = function(error_files, save_to) {
					isFirstOpen = true;
					if (error_files.length > 0) {
						var file = error_files.shift();
						var winError = new AS.ARC.msgWindow({
							parentWin: winapp.win,
							title: _S('COMMON', 'ERROR'),
							iconType: 'warning',
							height: 230,
							asItems: [{
								xtype: 'displayfield',
								itemId: 'upload-url-errwin',
								width: 313
							}],
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {
										if (error_files.length = 0);
											isFirstOpen = false;
										winError.close();
										showTorrentError(error_files, save_to);
									},
									scope: this
								}
							],
							listeners: {
								afterrender: function(panel) {
									var errorString = '';
									if (!AS.ARC.user.isAdmin && file.error === 5044) errorString = _S('DOWNLOAD_CENTER','TORRENT_USED_BY_ANOTHER_USER');
									else errorString = _S('DOWNLOAD_CENTER', 'DUPLICATE_FILE');

									errors = {
										5009: _S('DOWNLOAD_CENTER', 'UNABLE_OBTAIN_TORRENT_URL'),
										5041: _S('DOWNLOAD_CENTER', 'ERROR_URL'),
										5044: errorString,
										5401: _S('DOWNLOAD_CENTER', 'UNABLE_ADD_TASK'),
										5402: _S('DOWNLOAD_CENTER', 'NO_MORE_TASK'),//1000 tasks!
										5613: _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR')
									};

									if (file.error === 5631 || file.error === 5402) panel.items.items[0].items.items[0].items.get('upload-url-errwin').setValue(errors[file.error]);
									else panel.items.items[0].items.items[0].items.get('upload-url-errwin').setValue(file.name + '</br></br>' + errors[file.error]);
								}
							}
						}).show();
					}
				};

				var btnOk = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'OK'),
					disabled: true,
					handler: function() {
						if (!torrent.getValue()) {
							var save_to = '';
                            save_to = changeHomeFolder(savePathTorrents.getValue());
							var isShowDlg = win.items.get('panel-group').items.get('browser-group').items.get('isShowDlg');
							var url = winapp.UploadUrl+'?sid='+AS.ARC.user.sid+'&act=multi-torrent-upload&show_dialog_enabled='+isShowDlg.getValue()+'&save_to='+save_to;
							win.el.mask(_S('UPDATE', 'UPLOADING_FILE')+'...');

							var fd = new FormData();
							var len = upload_files.length;
							for (var i = 0; i < len; i++)
					        	fd.append("files", upload_files[i]);

					        var xhr = new XMLHttpRequest();
					        xhr.open("POST", url);
					        xhr.send(fd);

					        xhr.onload = function(e) {
					        	if (this.status === 200) {
					        		var json = Ext.decode(this.response);
									if(json.success === false) {
                                        winapp.showErrorMsgWin('multi-torrent-upload', json, win, 'warning', 
                                        function () {
                                            win.el.unmask();
                                            win.close();
                                        });
                                    } else {
                                        showTorrentList(json.error_file, json.torrent_list, save_to);
                                    }
					        	}
					        }

						} else {
							win.el.mask(_S('COMMON', 'LOADING'));
							// JN: http(s), ftp, torrent(magnet), thunder, flashget, qqdl
							var urls = '';
							urls = urlList.join(',');

							var save_to = '';
                            save_to = changeHomeFolder(savePath.getValue());

					        var urlOpts = {
					            act: 'download-add',
					            url: urls,
					            save_to: save_to,
					            auth_enabled: authen.getValue(),
					            auth_account: account.getValue(),
					            auth_password: password.getValue(),
					            auto_torrent_enabled: autoParseTorrent.getValue(),
					            show_dialog_enabled: showDlgForDL.getValue()
					        };

					        AS.ARC.ajax({
					            url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					            method: 'post',
					            success: function (json, opts) {
					            	win.close();
					            	var torrent_list_len = json.torrent_list.length;
									
									if (json.error_url.length > 0)
										showTorrentError(json.error_url, save_to);
									
					            	if (torrent_list_len > 0) {
					            		downloadType = 'torrent_list';
					            		torrent_list = json.torrent_list;
										torrent_list_index = 0;
										torrentListTypeSavePath = save_to;
										if (torrent_list[torrent_list_index].url) {
											if(torrent_list[torrent_list_index].url.indexOf('magnet') === 0)
												openAddTorrentInfoWindow(torrent_list[torrent_list_index], save_to, torrent_list[torrent_list_index].url);
										} else {
											openAddTorrentInfoWindow(torrent_list[torrent_list_index], save_to);
										}
					            	}
					            	else {
					                    reloadBTStore();
					            	}
					            },
					            failure: function (json, opts) {
					                win.close();
					                winapp.showErrorMsgWin('download-add', json, winapp.win);
					            }
					        });
						}
					}
				});

				var uploadFile = Ext.create('Ext.form.field.Text', {
					readOnly: true,
					fieldLabel: _S('COMMON','FILE'),
					width: 450,
					msgTarget: AS.ARC.config.msgTarget,
					allowBlank: false,
					blankText: _S('MESSAGE','HF00011'),
					labelWidth: 100,
					margin: '0, 0, 0, 5',
					listeners: {
						validitychange: function( field, isValid, eOpts ) {
							if (isValid) {
								btnOk.setDisabled(false);
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});

				winapp.selectFiles = function(files) {
					upload_files = [];

					var invalid_names = [];
					for (var i = 0; i < files.length; i++) {
						var dotIndex = files[i].name.lastIndexOf('.');
						if (dotIndex !== -1) {
							var extName = files[i].name.substring(dotIndex + 1);
							if (extName.toLowerCase() !== 'torrent')
								invalid_names.push(files[i].name);
							else
								upload_files.push(files[i])
						}
						else {
							invalid_names.push(files[i].name);
						}
					}
					if (invalid_names.length > 0) {
						var invalid_names_str = '<br><br>';
						for (var i = 0; i < invalid_names.length; i++) invalid_names_str += '- ' + invalid_names[i] + '<br>';

						var winConfirm = new AS.ARC.msgWindow({
							parentWin: win,
							title: _S('COMMON', 'INFORMATION'),
							iconType: 'info',
							asItems: [{
								xtype: 'displayfield',
								margin: '12 0 0 0',
								value: Ext.String.format(_S('DOWNLOAD_CENTER','INVALID_FILES'), invalid_names.length)
							}],
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {
										winConfirm.close();
										var selected_file_count = files.length - invalid_names.length;
										if (selected_file_count !== 0)
											uploadFile.setValue(Ext.String.format(_S('DOWNLOAD_CENTER', 'SELECTED_FILES'), selected_file_count));
										else
											uploadFile.setValue('');
									},
									scope: this
								}
							]
						});
						winConfirm.show();
					}
					else
						uploadFile.setValue(Ext.String.format(_S('DOWNLOAD_CENTER', 'SELECTED_FILES'), files.length));
				}

				var browerBtn = Ext.create('Ext.form.field.File', {
					name: 'files',
					margin: '0, 0, 0, 5',
					buttonText: _S('COMMON','BROWSE'),
					buttonOnly: true,
					listeners: {
						render: function() {
							this.fileInputEl.set({multiple: 'multiple'});
						},
						change: function( field, value, eOpts ) {
							// JN: check multi uploading
							var files = this.fileInputEl.dom.files;
							winapp.selectFiles(files);
						}
					}
				});
				var myuploadform = Ext.create('Ext.form.FormPanel', {
					bodyPadding: 0,
					title: '',
					fileUpload: true,
					border: false,
					defaults: {
						msgTarget: AS.ARC.config.msgTarget
					},
					items: [
						browerBtn
					]
				});
				var torrent = Ext.create(Ext.form.field.Radio, {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_URLS'),
					name: 'add'
				});
				//-------------------------------------- add torrent window ---------------------------------------------------


				var win = Ext.create('AS.ARC.subWindow', {
					title: _S('DOWNLOAD_CENTER', 'TITLE_ADD_TASK'),
					width: 650,
					height: 570,
					parentWin: winapp.win,
					fbar: [
					btnOk,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {

							win.close();
						}
					}],
					items: [
					{
						xtype: 'asPanelTop20',
						height: 450,
						itemId: 'panel-group',
						items:[
						{
							xtype: 'container',
							itemId: 'add-group',
							layout: 'hbox',
							items: [
							{
								xtype: 'radiofield',
								boxLabel: _S('DOWNLOAD_CENTER', 'INFO_BY_TORRENT'),
								itemId: 'add-torrent',
								name: 'add',
								labelWidth: 200,
								width: 225,
								checked: true,
								scope: this,
								listeners: {
									change: function( field, newValue, oldValue, eOpts ) {
										var panelGroup = win.items.get('panel-group').items;
										var browserGroup =panelGroup.get('browser-group');
										var linkGroup = panelGroup.get('link-group');
										if (newValue) {
											browserGroup.show();
											linkGroup.hide();
										} else {
											browserGroup.hide();
											linkGroup.show();
											var layout = linkContainer.getLayout();
											layout.setActiveItem(0);
											canChangeLayout = true;
										}

									}
								}
							},
							torrent
							]
						},
						{
							xtype: 'panel',
							itemId: 'browser-group',
							cls: 'dc-browser-group',
							height: 410,
							border: false,
							items:[
							{
								xtype: 'asFlexbox',
								scope: this,
								items: [
									uploadFile,
									myuploadform
								]
							}, {
	                        	xtype: 'checkbox',
	                        	itemId: 'isShowDlg',
	                        	boxLabel: _S('DOWNLOAD_CENTER','SHOW_DLG_FOR_DL'),
								checked: true
	                        }, {
								xtype: 'asFlexbox',
								cls: 'common-layout-horizontal-3-0',
								scope: this,
								height: 28,
								items: [
									savePathTorrents,
									saveBrowseTorrents
								]
							}, {
								xtype: 'displayfield',
								cls: 'note-string',
								width: 600,
								style: 'position: relative; top: 230px;',
								value: Ext.String.format(_S('DOWNLOAD_CENTER', 'INFO_DROP_FILES'), _S('COMMON','BROWSE'))
							}],
							listeners: {
								afterrender: function(win) {
									// JN: drag & drop files for multi uploading
									var dropPanelDiv = document.createElement('div');
									dropPanelDiv.className = "app-fileExplorer-HTML5DDPanel";
									win.el.dom.insertBefore(dropPanelDiv, win.el.dom.firstChild);

									var to;
									win.getEl().on(
										{
											'dragover': function(e) {
												clearTimeout(to);

												e.preventDefault();
												dropPanelDiv.style.display = "block";
											},
											'dragleave': function(e) {
												to = setTimeout(function(){dropPanelDiv.style.display = "none";}, 0);
											},
											'drop': function(e) {
												e.preventDefault();
												dropPanelDiv.style.display = "none";
												winapp.selectFiles(e.browserEvent.dataTransfer.files);
											}
										}
									);
								},
								show: function() {
									if(!checksavePathTorrents) btnOk.setDisabled(false);
								}
							}
						},
						{
							xtype: 'panel',
							height: 410,
							hidden: true,
							itemId: 'link-group',
							layout: {
								align: 'stretch',
								type: 'auto'
							},
							items: [
								linkContainer
							],
							listeners:{
								show: function() {
									if(!checksavePath) btnOk.setDisabled(false);
								}
							}
						}]
					}],
					listeners: {
						beforeshow: function() {
							var urlOpts = {
        						act: 'get-user-pref'
        					};
        
                            AS.ARC.ajax({
        						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
        						method: 'post',
        						success: function (json, opts) {
        							var dirValue = json.default_dl_dir;

									var folderTreeValue = dirValue.split('/'),
										isHomeFolder = folderTreeValue[1] === 'home' || folderTreeValue[1] === 'Home';

            						if (isHomeFolder) {
										if (folderTreeValue.length <= 3) {
											dirValue = changeToHome(dirValue);
										}
            						}

									var lastFolderString = "/" + dirValue.split("/").pop(),
										node = dirValue.split(lastFolderString).shift();

									if(node === "") node = 'share_folders';

									var urlOpts = {
										act: 'file_list',
										path: node,
										showhome: true,
										onlydir: true
									};

									AS.ARC.ajax({
										url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
										method: 'post',			
										success: function (json, opts) {
											win.el.unmask();
											var datas;

											if(node !== 'share_folders') datas = json.data;
											else  datas = json.data;
											
											for (var i=0; i< datas.length; i++) {
												var folderName = datas[i].filename;
												if(folderName === dirValue.split("/").pop()){
													if(winapp.isReadOnly(datas[i].access_permission)) {
														checksavePathTorrents = true;
														checksavePath = true;
													} else {
														checksavePathTorrents = false;
														checksavePath = false;
													}
												}
											}

											if (isHomeFolder) {
												if (folderTreeValue.length > 3) {
													dirValue = changeToHome(dirValue);
												}
											}
											DownloadCenter.changeValueUseEllipsis(dirValue, savePathTorrents);
										},
										failure: function (json, opts) {
											win.el.unmask();
										}
									});
        						},
        						failure: function (json, opts) {
									if (AS.ARC.user.isAdmin) {
										win.el.unmask();
									} else {
										var dirValue = json.default_dl_dir;

										var folderTreeValue = dirValue.split('/'),
											isHomeFolder = folderTreeValue[1] === 'home' || folderTreeValue[1] === 'Home';

            							if (isHomeFolder) {
											if (folderTreeValue.length <= 3) {
												dirValue = changeToHome(dirValue);
											}
            							}

										var lastFolderString = "/" + dirValue.split("/").pop(),
											node = dirValue.split(lastFolderString).shift();

										if(node === "") node = 'share_folders';

										var urlOpts = {
											act: 'file_list',
											path: node,
											showhome: true,
											onlydir: true
										};

										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
											method: 'post',			
											success: function (json, opts) {
												win.el.unmask();
												var datas;

												if(node !== 'share_folders') datas = json.data;
												else  datas = json.data;
												
												for (var i=0; i< datas.length; i++) {
													var folderName = datas[i].filename;
													if(folderName === dirValue.split("/").pop()){
														if(winapp.isReadOnly(datas[i].access_permission)) {
															checksavePathTorrents = true;
															checksavePath = true;
														} else {
															checksavePathTorrents = false;
															checksavePath = false;
														}
													}
												}

												if (isHomeFolder) {
													if (folderTreeValue.length > 3) {
														dirValue = changeToHome(dirValue);
													}
												}
												DownloadCenter.changeValueUseEllipsis(dirValue, savePathTorrents);
											},
											failure: function (json, opts) {
												win.el.unmask();
											}
										});
									}
        						}
        					});
						},
						show: function(win, eOpts) {
							win.el.mask(_S('COMMON', 'LOADING'));
						},
					    render: function (com, eOpts) {
							winapp.ADD_WIN_NUMBER++;
							doActionWin = true;
						},
					    beforeclose: function (panel, eOpts) {
					        winapp.ADD_WIN_NUMBER--;
							doActionWin = false;
						}
					}
				});

				win.show();
				return true;
			}
		};

		var isShowDelWin = false;
		//create delete confirm messagebox
		var openDeleteConfirmWin = function(type) {

			var name = '';
			if (type == winapp.CONFIRM_TYPE_DOWNLOAD_RESULT) {
				var select = btPanel.getSelectionModel().getSelection();
				if (select.length == 1) {
				name = downloadRecord.data.name;
				} else {
					name = _S('DOWNLOAD_CENTER','FILES');
				}
			} else if (type == winapp.CONFIRM_TYPE_SEARCH_PANEL) {
				name = searchRecord.data.search_id;
			} else if (type == winapp.CONFIRM_TYPE_RSS_PANEL) {
				name = rssRecord.data.title;
			} else if (type == winapp.CONFIRM_TYPE_RSS_FEED_PANEL) {
				name = rssFeedRecord.data.title;
			}

			name = Ext.util.Format.ellipsis(name, 50);
			name+='?';

			var delTask = Ext.create(Ext.form.field.Radio, {
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_DELETE_TASK'),
				name: 'del',
				checked: true
			});
			var delData = Ext.create(Ext.form.field.Radio, {
				boxLabel: _S('DOWNLOAD_CENTER', 'DELETE_TASK_DATA'),
				name: 'del'
			});
			if (type == winapp.CONFIRM_TYPE_SEARCH_PANEL) {
				var win = new AS.ARC.msgWindow({
					title: _S('COMMON','REMOVE'),
					parentWin: winapp.win,
					scope: this,
					iconType: 'question',
					fbar: [{
						text: _S('COMMON', 'OK'),
						handler: function() {
							doRemoveSearch();
							win.close();
						}
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function() {
							win.close();
						}
					}],
					asItems: [{
						xtype: 'displayfield',
						value: _S('COMMON', 'REMOVE_SELECTED_ITEMS')
					}
					], listeners: {
						render: function(com , eOpts) {
							isShowDelWin = true;
							doActionWin = true;
						},
						beforeclose: function(com, eOpts) {
							isShowDelWin = false;
							doActionWin = false;
						}
					}
				});

				win.show();
			} else if (type == winapp.CONFIRM_TYPE_RSS_PANEL || type == winapp.CONFIRM_TYPE_RSS_FEED_PANEL) {
				var win = new AS.ARC.msgWindow({
					title: _S('COMMON','REMOVE'),
					parentWin: winapp.win,
					scope: this,
					iconType: 'question',
					fbar: [{
						text: _S('COMMON', 'OK'),
						handler: function() {
							doRemoveRss(type);
							win.close();
						}
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function() {
							win.close();
						}
					}],
					asItems: [
					{
						xtype: 'displayfield',
						value: _S('DOWNLOAD_CENTER', 'CONFIRM_REMOVE')+' '+name
					}
					], listeners: {
						render: function(com , eOpts) {
							isShowDelWin = true;
							doActionWin = true;
						},
						beforeclose: function(com, eOpts) {
							isShowDelWin = false;
							doActionWin = false;
						}
					}
				});

				win.show();
			} else {
				//general
				var win = new AS.ARC.msgWindow({
					title: _S('COMMON','REMOVE'),
					height: 250,
					parentWin: winapp.win,
					scope: this,
					iconType: 'question',
					fbar: [{
						text: _S('COMMON', 'OK'),
						handler: function() {
							if (type == winapp.CONFIRM_TYPE_DOWNLOAD_RESULT) {
								var mode = delTask.getValue() ? 0: 1;
								doRemove(mode);
							} else if (type == winapp.CONFIRM_TYPE_SEARCH_PANEL) {
								doRemoveSearch();
							} else if (type == winapp.CONFIRM_TYPE_RSS_PANEL || type == winapp.CONFIRM_TYPE_RSS_FEED_PANEL) {
								doRemoveRss(type);
							}
							win.close();
						}
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function() {
							win.close();
						}
					}],
					asItems: [
					{
						xtype: 'displayfield',
						value: _S('COMMON', 'REMOVE_SELECTED_ITEMS')
					},
					delTask,
					delData
					], listeners: {
						render: function(com , eOpts) {
							isShowDelWin = true;
							doActionWin = true;
						},
						beforeclose: function(com, eOpts) {
							isShowDelWin = false;
							doActionWin = false;
						}
					}
				});

				win.show();
			}
		};

		//do bt delete
		var doRemove = function(mode) {

			var select = btPanel.getSelectionModel().getSelection();
			if (select.length != 0) {
				var torrentList = '';
				var downloadList = '';
				for (var i=0; i< select.length; i++) {
					if (select[i].data.type == 'BT') {
						torrentList += select[i].data.id+',';
					} else {
						downloadList += select[i].data.id+',';
					}
				}
				if (typeof (winapp.win) != 'undefined') {
				    if (typeof (winapp.win.el) != 'undefined') {
				        winapp.win.el.unmask();
				    }
				}
				winapp.win.el.mask(_S('COMMON', 'APPLYING'));
				torrentList = torrentList.substring(0, torrentList.length-1);
				downloadList = downloadList.substring(0, downloadList.length-1);
				if (torrentList != '') {
					var urlOpts = {
						act: 'torrent-remove',
						id: torrentList,
						mode: mode
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							winapp.reloadSelections = [];
							reloadBTStore();

						},
						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('torrent-remove', json, winapp.win);
						}
					});
				}
				//download- start
				if (downloadList != '') {
					var urlOpts = {
						act: 'download-delete',
						id: downloadList,
						mode: mode
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							winapp.reloadSelections = [];
							reloadBTStore();
						},
						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('download-delete', json, winapp.win);
						}
					});

				}
			}
		};

		//do bt start
		var doStart = function() {
			var select = btPanel.getSelectionModel().getSelection();
			if (select.length != 0) {
				var torrentList = '';
				var downloadList = '';
				for (var i=0; i< select.length; i++) {
					if (select[i].data.type == 'BT') {
						torrentList += select[i].data.id+',';
					} else {
						downloadList += select[i].data.id+',';
					}
				}
				torrentList = torrentList.substring(0, torrentList.length-1);
				downloadList = downloadList.substring(0, downloadList.length-1);

				//torrent- start

				if (torrentList != '') {
					var urlOpts = {
						act: 'torrent-start',
						id: torrentList
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							reloadBTStore();
						},
						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('torrent-start', json, winapp.win);
						}
					});

				}

				//download- start
				if (downloadList != '') {
					var urlOpts = {
						act: 'download-start',
						id: downloadList
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							reloadBTStore();
						},

						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('download-start', json, winapp.win);
						}
					});

				}
			}
		};

		//do bt stop
		var doStop = function() {
			var select = btPanel.getSelectionModel().getSelection();
			if (select.length != 0) {
				var torrentList = '';
				var downloadList = '';
				for (var i=0; i< select.length; i++) {
					if (select[i].data.type == 'BT') {
						torrentList += select[i].data.id+',';
					} else {
						downloadList += select[i].data.id+',';
					}
				}
				torrentList = torrentList.substring(0, torrentList.length-1);
				downloadList = downloadList.substring(0, downloadList.length-1);

				//torrent- start
				if (torrentList != '') {
					var urlOpts = {
						act: 'torrent-stop',
						id: torrentList
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
					        reloadBTStore();
						},
						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('torrent-stop', json, winapp.win);
						}
					});
				}

				//download- start
				if (downloadList != '') {
					var urlOpts = {
						act: 'download-stop',
						id: downloadList
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							reloadBTStore();

						},
						failure: function (json, opts) {
						    if (typeof(winapp.win) != 'undefined') {
						        if (typeof(winapp.win.el) != 'undefined') {
						            winapp.win.el.unmask();
						        }
						    }
							winapp.showErrorMsgWin('download-stop', json, winapp.win);
						}
					});
				}
			}
		};

		//do bt torrent direction (up/down) from grid
		var doDirection = function(dir) {
			var select = btPanel.getSelectionModel().getSelection();
			if (select.length != 0) {
				var idlist = '';
				for (var i=0; i< select.length; i++) {
					idlist += select[i].data.id+',';
				}

				idlist = idlist.substring(0, idlist.length-1);
				var urlOpts = {
					act: 'torrent-queue',
					id: idlist,
					direction: dir
				};
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						reloadBTStore();
					},
					failure: function (json, opts) {
						winapp.showErrorMsgWin('torrent-queue', json, winapp.win);
					}
				});
			}
		};

		/*
        @ Get the home folder real path
        @ ex: /home/admin 
        */
        var getHomeFolderPath = function() {
            AS.ARC.ajax({
                url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', {
        			act: 'file_list',
        			path: 'share_folders',
        			showhome: true
        		}),
                method: 'post',
                success: function (json, opts) {
                    var i = 0;
                    for(count = 0; count < json.data.length; count ++) {
						winapp.ALL_FOLDER[count] = json.data[count].file_path;
						if(json.data[count].filename === 'Home') {
							winapp.HOME_FOLDER_ARRAY = json.data[count].file_path;
						}
                        if(winapp.isReadOnly(json.data[count].access_permission)) {
                            winapp.NO_ACCESS_FOLDER[i] = json.data[count].file_path;
							i++;
                        }
                    }
                },
                failure: function (json, opts) {
                }
            });
        }

		//-------------------------------------- general UI use define out preference function ---------------------------------------------------
		//create add task window use torrent or link
		var openPreferenceWin = function() {
			if (winapp.PREFERENCE_WIN_NUMBER < winapp.MAX_PREFERENCE_WIN) {
				//vaild check
				var doAppClose;
				//general
				var maxDLNumber;
				var enableShareRatio;
				var shareRatioValue;
				var enableAutoRemove;
				var defaultDLDir;
				var enableGuide;
				var enableWatch;
				var watchDir;
				var enableApns;
				var enableIgnoreOther;
				var tempDir;
				//connection
				var port;
				var enableEncryption;
				var enableDHT;
				//bnadwidth
				var enableMaxDLRate;
				var maxDLRate;
				var enableMaxUPRate;
				var maxUPRate;
				var maxConn;
				var maxConnPerPeer;
				var enableHttpFtpSpeedLimit;
				var httpFtpSpeedLimit;
				var initApply = false;

				var isEnableAutoExtract,
					isEnableAutoDeleteArchives,
					isEverSwitchToExtractTab = false;

				//watch dir error status
				var watch_dir_error = false;

				var getPreferenceData = function() {
					win.el.mask(_S('COMMON', 'LOADING'));
					//get preference
					var urlOpts = {
						act: 'get-user-pref'
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {

							var total = [json.default_dl_dir,json.incomplete_dir,json.watch_dir];
							var num = 0;
							var checkFolderAccess = function(cb) {
								if(num < 3) {
									var folderPath = total[num],
									lastFolderString = "/" + folderPath.split("/").pop(),
									node = changeHomeFolder(folderPath.split(lastFolderString).shift());

									if(node === "") node = 'share_folders';

									var urlOpts = {
										act: 'file_list',
										path: node,
										showhome: true,
										onlydir: true
									};

									AS.ARC.ajax({
										url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
										method: 'post',			
										success: function (json, opts) {
											var datas;

											if(node !== 'share_folders') datas = json.data;
											else  datas = json.data;
											
											for (var i=0; i< datas.length; i++) {
												var folderName = datas[i].filename;
												if(folderName === folderPath.split("/").pop()){
													if (winapp.isReadOnly(datas[i].access_permission)) {
														isFirstOpen = true;
														if(num === 0)  	winapp.PRE_CHECK_DEFAULT = true;
														else if(num === 1) winapp.PRE_CHECK_INCOMPLETE = true;
														else winapp.PRE_CHECK_WATCH = true;
													}
												}
											}
											num++;
											checkFolderAccess();
										},
										failure: function (json, opts) {
										}
									});
								}
								if (Ext.isFunction(cb)){
									cb();  
								} 
							}

							checkFolderAccess(function(){
								maxDLNumber = json.max_dl_number;
								enableShareRatio = json.enable_share_ratio;
								shareRatioValue = json.share_ratio;
								enableAutoRemove = json.enable_auto_remove;
								
								defaultDLDir = changeToHome(json.default_dl_dir);
								
								enableGuide = json.enable_guide;
								port = json.port;
								enableEncryption = json.enable_encryption;
								enableDHT = json.enable_dht;
								enableMaxDLRate = json.enable_max_dl_rate;
								maxDLRate = json.max_dl_rate;
								enableMaxUPRate = json.enable_max_up_rate;
								maxUPRate = json.max_up_rate;
								maxConn = json.max_conn;
								maxConnPerPeer = json.max_conn_per_peer;
								enableHttpFtpSpeedLimit = json.enable_http_ftp_speed_limit;
								httpFtpSpeedLimit = json.http_ftp_speed_limit;
								enableIgnoreOther = json.ignore_other_user;

								enableWatch = json.enable_watch;
								watchDir = changeToHome(json.watch_dir);
								watch_dir_error = json.watch_dir_error;
								if (watch_dir_error) {
									var msgInfo = Ext.create('Ext.form.field.Display', {
										value: _S('DOWNLOAD_CENTER', 'WATCH_FOLDER_ERROR'),
										//value: 'Java appears to be not installed / not enabled.<br>Or, perhaps you need to use a different browser or a different version of Java.',
										flex: 1
									});
									var msgWin = new AS.ARC.msgWindow( {
										title: _S('COMMON', 'INFORMATION'),
										border: false,
										resizable: false,
										closable: false,
										shadow: true,
										parentWin: win,
										iconType: 'info',
										fbar: [
										{
											text: _S('COMMON', 'OK'),
											handler: function() {
												msgWin.close();
											}
										}],
										asItems: [msgInfo]
									});
									msgWin.show();
								}

								tempDir = changeToHome(json.incomplete_dir);
								
								//general
								taskNumber.select(maxDLNumber);

								if (enableShareRatio) {
									shareRatio.setValue(true);
								} else {
									shareRatio.setValue(false);
								}

								shareRatioText.setValue(shareRatioValue);

								if (enableAutoRemove) {
									enableRemoveTask.setValue(true);
								} else {
									enableRemoveTask.setValue(false);
								}

								DownloadCenter.changeValueUseEllipsis(defaultDLDir, preferenceDirectoryText);

								if (enableWatch) {
									enableSmartDownload.setValue(true);
									watchBrowser.setDisabled(false);
									enableIgnore.setDisabled(false);
									enableIgnore.setValue(enableIgnoreOther);
									watchDirectoryText.setDisabled(false);
								} else {
									enableSmartDownload.setValue(false);
									watchBrowser.setDisabled(true);
									enableIgnore.setDisabled(true);
									enableIgnore.setValue(enableIgnoreOther);
									watchDirectoryText.setDisabled(true);
								}

								if (watchDir == "") {
									DownloadCenter.changeValueUseEllipsis(defaultDLDir, watchDirectoryText);
								} else {
									DownloadCenter.changeValueUseEllipsis(watchDir, watchDirectoryText);
								}

								DownloadCenter.changeValueUseEllipsis(tempDir, tempFolderPath);

								enableApns = json.enable_apns;
								if (enableApns) {
									enablePushNotification.setValue(true);
								} else {
									enablePushNotification.setValue(false);
								}

								//connection
								TCPPort.setValue(port);

								encryptionSettingsComboBox.setValue(enableEncryption);

								if (enableDHT) {
									enableDHTNetwork.setValue(true);
								} else {
									enableDHTNetwork.setValue(false);
								}

								//bandwidth
								if (enableMaxDLRate) {
									maxDownloadRate.setValue(true);
									maxDownloadRateText.setDisabled(false);
								} else {
									maxDownloadRate.setValue(false);
									maxDownloadRateText.setDisabled(true);
								}
								maxDownloadRateText.setValue(maxDLRate);

								if (enableMaxUPRate) {
									maxUploadRate.setValue(true);
									maxUploadRateText.setDisabled(false);
								} else {
									maxUploadRate.setValue(false);
									maxUploadRateText.setDisabled(true);
								}
								maxUploadRateText.setValue(maxUPRate);
								maxConnectionNumberText.setValue(maxConn);
								maxPeerTorrentText.setValue(maxConnPerPeer);

								if (enableHttpFtpSpeedLimit) {
									maxDownloadRatePeerTask.setValue(true);
									maxDownloadRatePeerTaskText.setDisabled(false);
								} else {
									maxDownloadRatePeerTask.setValue(false);
									maxDownloadRatePeerTaskText.setDisabled(true);
								}
								maxDownloadRatePeerTaskText.setValue(httpFtpSpeedLimit);
								initApply = true;

								if (typeof(win) != 'undefined') {
									if (typeof(win.el) != 'undefined') {
										win.el.unmask();
									}
								}
								win.el.unmask();
							});
							//_D('get-user-pref success');
						},
						failure: function (json, opts) {
							if (!AS.ARC.user.isAdmin) {
								var total = [json.default_dl_dir,json.incomplete_dir,json.watch_dir];
								var num = 0;
								var checkFolderAccess = function(cb) {
									if(num < 3) {
										var folderPath = total[num],
										lastFolderString = "/" + folderPath.split("/").pop(),
										node = changeHomeFolder(folderPath.split(lastFolderString).shift());

										if(node === "") node = 'share_folders';

										var urlOpts = {
											act: 'file_list',
											path: node,
											showhome: true,
											onlydir: true
										};

										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
											method: 'post',			
											success: function (json, opts) {
												var datas;

												if(node !== 'share_folders') datas = json.data;
												else  datas = json.data;
												
												for (var i=0; i< datas.length; i++) {
													var folderName = datas[i].filename;
													if(folderName === folderPath.split("/").pop()){
														if(winapp.isReadOnly(datas[i].access_permission)) {
															isFirstOpen = true;
															if(num === 0)  	winapp.PRE_CHECK_DEFAULT = true;
															else if(num === 1) winapp.PRE_CHECK_INCOMPLETE = true;
															else winapp.PRE_CHECK_WATCH = true;
														}
													}
												}
												num++;
												checkFolderAccess();
											},
											failure: function (json, opts) {
											}
										});
									}
									if (Ext.isFunction(cb)){
										cb();  
									} 
								}
								checkFolderAccess(function(){
									defaultDLDir = changeToHome(json.default_dl_dir);
                                
									enableAutoRemove = json.enable_auto_remove;
									enableIgnoreOther = json.ignore_other_user;

									enableWatch = json.enable_watch;
									watchDir = changeToHome(json.watch_dir);
									
									watch_dir_error = json.watch_dir_error;

									tempDir = changeToHome(json.incomplete_dir);

									if (watch_dir_error) {
										var msgInfo = Ext.create('Ext.form.field.Display', {
											value: _S('DOWNLOAD_CENTER', 'WATCH_FOLDER_ERROR'),
											flex: 1
										});
										var msgWin = new AS.ARC.msgWindow( {
											title: _S('COMMON', 'INFORMATION'),
											border: false,
											resizable: false,
											closable: false,
											shadow: true,
											parentWin: win,
											iconType: 'info',
											fbar: [
											{
												text: _S('COMMON', 'OK'),
												handler: function() {
													msgWin.close();
												}
											}],
											asItems: [msgInfo]
										});
										msgWin.show();
									}
									if (enableAutoRemove) {
										enableRemoveTask.setValue(true);
									} else {
										enableRemoveTask.setValue(false);
									}

									DownloadCenter.changeValueUseEllipsis(defaultDLDir, preferenceDirectoryText);
									DownloadCenter.changeValueUseEllipsis(tempDir, tempFolderPath);
									if (watchDir == "") {
										DownloadCenter.changeValueUseEllipsis(defaultDLDir, watchDirectoryText);
									} else {
										DownloadCenter.changeValueUseEllipsis(watchDir, watchDirectoryText);
									}

									enableApns = json.enable_apns;

									if (enableApns) {
										enablePushNotification.setValue(true);
									} else {
										enablePushNotification.setValue(false);
									}

									if (enableWatch) {
										enableSmartDownload.setValue(true);
										watchBrowser.setDisabled(false);
										enableIgnore.setDisabled(false);
										watchDirectoryText.setDisabled(false);
									} else {
										enableSmartDownload.setValue(false);
										watchBrowser.setDisabled(true);
										enableIgnore.setDisabled(true);
										watchDirectoryText.setDisabled(true);
									}

									enableIgnore.setValue(enableIgnoreOther);

									initApply = true;
								});
                                
								if (typeof(win) != 'undefined') {
								    if (typeof(win.el) != 'undefined') {
								        win.el.unmask();
								    }
								}
							} else {
								if (typeof(win) != 'undefined') {
							        if (typeof(win.el) != 'undefined') {
							            win.el.unmask();
							        }
								}
								winapp.showErrorMsgWin('get-user-pref', json, win);
							}
						}
					});
				};
				//-------------------------------------- preference layout ---------------------------------------------------

				//-------------------------------------- general UI ---------------------------------------------------
				//create combox for max number of task
				var numberDatas=[];
				for (var i=1; i<= 50; i++) {
					var data = [i.toString(), i];
					numberDatas.push(data);
				}

				var taskNumber = Ext.create('Ext.form.ComboBox', {
					width: 660,
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXINUM_NUMBER_DOWNLOADING_TASK'),
					labelWidth: 460,
					store: new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: numberDatas
					}),
					displayField: 'display',
					valueField: 'value',
					queryMode: 'local',
                    triggerAction: 'all',
					editable: false,
					listeners: {
						change: function(field, newValue, oldValue, eOpts) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var shareRatio = Ext.create('Ext.form.field.Checkbox', {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_SET_SHARE_RATIO'),
					style: 'display: inline-block;',
					labelWidth: 410,
					width: 510,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var shareRatioText = Ext.create('Ext.form.field.Number', {
					width: 136,
					style: 'display: inline-block;',
					maxValue: 999999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var enableRemoveTask = Ext.create('Ext.form.field.Checkbox', {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ENABLE_AUTO_REMOVE_COMPLETED_TASK'),
					anchor: '100%',
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var preferenceDirectoryText = Ext.create('Ext.form.field.Text',{
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_DEFAULT_DOWNLOAD_DIRECTORY'),
					labelWidth: 250,
					readOnly: true,
					allowBlank: false,
					blankText: _S('MESSAGE','HF00011'),
					width: 550,
					msgTarget : 'side',
					validator: function(value){
						if(value !== '') {
							if(winapp.PRE_CHECK_DEFAULT) {
								btnApply.disable = true;
								btnOk.setDisabled(true);
								doAppClose = true;
								if(AS.ARC.user.isAdmin) {
									return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
								} else {
									return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
								}
							} else {
								// doAppClose = false;
							}
						}
						return true;
					},
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if(oldValue !== undefined) {
								if(newValue !== oldValue) {
									winapp.PRE_CHECK_DEFAULT = false;
								}
							}
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
								btnOk.setDisabled(false);
							}
						}
					}
				});
				var browser = Ext.create('Ext.button.Button', {
					text: _S('COMMON','BROWSE'),
					style: 'left: 20px;',
					handler: function () {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							objectPath: preferenceDirectoryText
						});
						fs.win.show();
					}
				});

				var tempFolderPath = Ext.create('Ext.form.field.Text',{
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_TEMP_FOLDER'),
					labelWidth: 250,
					readOnly: true,
					allowBlank: false,
					blankText: _S('MESSAGE','HF00011'),
					width: 550,
					msgTarget : 'side',
					validator: function(value){
						if(winapp.PRE_CHECK_INCOMPLETE) {
							btnApply.disable = true;
							btnOk.setDisabled(true);
							doAppClose = true;
							if(AS.ARC.user.isAdmin) {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
							} else {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
							}
						}
						return true;
					},
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if(oldValue !== undefined) {
								if(newValue !== oldValue) {
									winapp.PRE_CHECK_INCOMPLETE = false;
								}
							}
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
								btnOk.setDisabled(false);
							}
						}
					}
				});

				var tempBrowser = Ext.create('Ext.button.Button', {
					text: _S('COMMON','BROWSE'),
					border: false,
					style: 'left: 20px;',
					handler: function () {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							objectPath: tempFolderPath
						});
						fs.win.show();
					}
				});

				var enableSmartDownload = Ext.create('Ext.form.field.Checkbox', {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ENABLE_SMART_DOWNLOAD'),
					anchor: '100%',
					style: 'display:inline-block;',
					listeners: {
						change: function( field, newValue, oldValue, eOpts ) {
							if (newValue) {
								enableIgnore.setDisabled(false);
								watchBrowser.setDisabled(false);
								watchDirectoryText.setDisabled(false);
							} else {
								enableIgnore.setDisabled(true);
								watchBrowser.setDisabled(true);
								watchDirectoryText.setDisabled(true);
							}
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var watchDirectoryText = Ext.create('Ext.form.field.Text',{
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_SMART_DOWNLOAD_FOLDER'),
					labelWidth: 250,
					readOnly: true,
					allowBlank: false,
					blankText: _S('MESSAGE','HF00011'),
					width: 550,
					msgTarget : 'side',
					validator: function(value){
						if(winapp.PRE_CHECK_WATCH) {
							btnApply.disable = true;
							btnOk.setDisabled(true);
							doAppClose = true;
							if(AS.ARC.user.isAdmin) {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
							} else {
								return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
							}
						}
						return true;
					},
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if(oldValue !== undefined) {
								if(newValue !== oldValue) {
									winapp.PRE_CHECK_WATCH = false;
								}
							}
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
								btnOk.setDisabled(false);
							}
						}
					}
				});

				var watchBrowser = Ext.create('Ext.button.Button', {
					text: _S('COMMON','BROWSE'),
					style: 'left: 20px;',
					handler: function () {
						var fs = Ext.create('DownloadCenter.treeSelector', {
							parentWin: win,
							objectPath: watchDirectoryText
						});
						fs.win.show();
					}
				});

				var enableIgnore = Ext.create('Ext.form.field.Checkbox', {
                	boxLabel: _S('DOWNLOAD_CENTER','IGNORE'),
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var enablePushNotification = Ext.create('Ext.form.field.Checkbox', {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ENABLE_PUSH_NOTIFICATION'),
					anchor: '100%',
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply && !winapp.PRE_CHECK_DEFAULT && !winapp.PRE_CHECK_INCOMPLETE && !winapp.PRE_CHECK_WATCH) {
								btnApply.setDisabled(false);
							}
						}
					}
				});
				//-------------------------------------- ajax action---------------------------------------------------
				var setPreference = function() {
					win.el.mask(_S('COMMON', 'APPLYING'));

					defaultDLDir = changeHomeFolder(preferenceDirectoryText.getValue());
					defaultDir = defaultDLDir;
					watchDir = changeHomeFolder(watchDirectoryText.getValue());
					tempDir = changeHomeFolder(tempFolderPath.getValue());

					var urlOpts = {
						act: 'set-pref',
						enable_auto_remove: enableAutoRemove,
						default_dl_dir: defaultDir,
						enable_watch: enableWatch,
						watch_dir: watchDir,
						ignore_other_user: enableIgnoreOther,
						enable_apns: enableApns,
						incomplete_dir: tempDir
					};

					if(AS.ARC.user.isAdmin) {
						Ext.apply(urlOpts, {
							max_dl_number: maxDLNumber,
							enable_share_ratio: enableShareRatio,
							share_ratio: shareRatioValue,
							enable_guide: enableGuide,
							port: port,
							enable_encryption: enableEncryption,
							enable_dht: enableDHT,
							enable_max_dl_rate: enableMaxDLRate,
							max_dl_rate: maxDLRate,
							enable_max_up_rate: enableMaxUPRate,
							max_up_rate: maxUPRate,
							max_conn: maxConn,
							max_conn_per_peer: maxConnPerPeer,
							enable_http_ftp_speed_limit: enableHttpFtpSpeedLimit,
							http_ftp_speed_limit: httpFtpSpeedLimit
						});
					}

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
						    if (typeof(win) != 'undefined') {
						        if (typeof(win.el) != 'undefined') {
						            win.el.unmask();
						        }
						    }
							btnApply.setDisabled(true);
						},
						failure: function (json, opts) {
						    if (typeof(win) != 'undefined') {
						        if (typeof(win.el) != 'undefined') {
						            win.el.unmask();
						        }
							}
							btnApply.setDisabled(false);
							winapp.showErrorMsgWin('set-pref', json, winapp.win);
						}
					});
				}

				//-------------------------------------- general action---------------------------------------------------
				var setGeneral = function() {
					//do cgi
					maxDLNumber = taskNumber.getValue();
					enableShareRatio = shareRatio.getValue();
					shareRatioValue = shareRatioText.getValue();
					enableAutoRemove = enableRemoveTask.getValue();
					defaultDLDir = changeHomeFolder(preferenceDirectoryText.getValue());
					defaultDir = defaultDLDir;
					tempDir = changeHomeFolder(tempFolderPath.getValue());
					watchDir = changeHomeFolder(watchDirectoryText.getValue());
					
					enableGuide = true;
					enableWatch = enableSmartDownload.getValue();
					enableApns = enablePushNotification.getValue();
					enableIgnoreOther = enableIgnore.getValue();

					setPreference();
				};
				//-------------------------------------- connection UI ---------------------------------------------------
				var portError = false;
				var TCPPort = Ext.create('Ext.form.field.Number', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_TCP_LISTEN_PORT'),
					labelWidth: 440,
					minValue: 1,
					width: 580,
					maxValue: 65535,
					allowBlank: false,
					blankText: _S('MESSAGE', 'HF00011'),
					msgTarget: AS.ARC.config.msgTarget,
					listeners: {
						validitychange: function(field, isValid, eOpts) {
							if (isValid) {
								btnOk.setDisabled(false);
								portError = false;
							} else {
								btnOk.setDisabled(true);
								portError = true;
							}
						},
						change: function(field, newValue, oldValue, eOpts) {
							var isValidTCPPort = !Ext.isEmpty(newValue) && newValue >= 1 && newValue <= 65535;

							if (initApply && isValidTCPPort) {
								btnApply.setDisabled(false);
							} else {
								btnApply.setDisabled(true);
							}
						}
					}
				});

				var encryptionSettingsComboBox = Ext.create('Ext.form.ComboBox', {
					width: 580,
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_ENABLE_PROTOCOL'),
					labelWidth: 320,
					store: new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: [
							[_S('DOWNLOAD_CENTER', 'OPTION_FORCED'), 2],
							[_S('DOWNLOAD_CENTER', 'OPTION_DISABLED'), 0],
							[_S('DOWNLOAD_CENTER', 'OPTION_ENCRYPTION_CONNECTION'), 1]
						]
					}),
					displayField: 'display',
					valueField: 'value',
					queryMode: 'local',
                    triggerAction: 'all',
					editable: false,
					value: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var enableDHTNetwork = Ext.create('Ext.form.field.Checkbox', {
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_ENABLE_DHT_NETWORK'),
					anchor: '100%',
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				//-------------------------------------- connection action---------------------------------------------------
				var setConnection = function() {
					//do cgi
					port = TCPPort.getValue();
					enableEncryption = encryptionSettingsComboBox.getValue();
					enableDHT = enableDHTNetwork.getValue();
					setPreference();
				};
				//-------------------------------------- bandwidth UI ---------------------------------------------------
				var maxDownloadRate = Ext.create('Ext.form.field.Checkbox', {
					labelWidth: 440,
					width: 440,
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXIMUM_DOWNLOAD_RATE'),
					style: 'display: inline-block;',
					listeners: {
						change: function( field, newValue, oldValue, eOpts ) {
							if (newValue) {
								maxDownloadRateText.setDisabled(false);
							} else {
								maxDownloadRateText.setDisabled(true);
							}
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxDownloadRateText = Ext.create('Ext.form.field.Number', {
					width: 140,
					maxValue: 999999,
					minValue: 0,
					style: 'display: inline-block;',
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxUploadRate = Ext.create('Ext.form.field.Checkbox', {
					labelWidth: 440,
					width: 440,
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXIMUM_UPLOAD_RATE'),
					style: 'display: inline-block;',
					listeners: {
						change: function( field, newValue, oldValue, eOpts) {
							if (newValue) {
								maxUploadRateText.setDisabled(false);
							} else {
								maxUploadRateText.setDisabled(true);
							}
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxUploadRateText = Ext.create('Ext.form.field.Number', {
					width: 140,
					style: 'display: inline-block;',
					maxValue: 999999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxConnectionNumberText = Ext.create('Ext.form.field.Number', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXIMUM_CONNECTIONS_NUMBER'),
					labelWidth: 440,
					width: 580,
					maxValue: 9999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxPeerTorrentText = Ext.create('Ext.form.field.Number', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXIMUM_PEERS_PER_TORRENT'),
					labelWidth: 440,
					width: 580,
					maxValue: 9999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxDownloadRatePeerTask = Ext.create('Ext.form.field.Checkbox', {
					labelWidth: 440,
					width: 440,
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_MAXIMUM_DOWNLOAD_RATE_PER_TASK'),
					style: 'display: inline-block;',
					listeners: {
						change: function( field, newValue, oldValue, eOpts) {
							if (newValue) {
								maxDownloadRatePeerTaskText.setDisabled(false);
							} else {
								maxDownloadRatePeerTaskText.setDisabled(true);
							}
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxDownloadRatePeerTaskText = Ext.create('Ext.form.field.Number', {
					width: 140,
					maxValue: 999999,
					minValue: 0,
					style: 'display: inline-block;',
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});
				//-------------------------------------- bandwidth action---------------------------------------------------
				var setBandwidth = function() {
					//do cgi
					enableMaxDLRate = maxDownloadRate.getValue();
					maxDLRate = maxDownloadRateText.getValue();
					enableMaxUPRate = maxUploadRate.getValue();
					maxUPRate = maxUploadRateText.getValue();
					maxConn = maxConnectionNumberText.getValue();
					maxConnPerPeer = maxPeerTorrentText.getValue();
					enableHttpFtpSpeedLimit = maxDownloadRatePeerTask.getValue();
					httpFtpSpeedLimit = maxDownloadRatePeerTaskText.getValue();
					setPreference();
				};
				//-------------------------------------- download schedule UI ---------------------------------------------------
				secheduleData = [];
				var scheduleStore = null;
				var sunData = '';
				var monData = '';
				var tueData = '';
				var wedData = '';
				var thuData = '';
				var friData = '';
				var satData = '';
				var createDataArray = function(type, datas) {
					var data = [];
					switch(type) {
						case 'sun':
						data.push(_S('COMMON', 'SUNDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							sunData += datas[i] +',';
						}
						secheduleData.push(data);
						sunData = sunData.substring(0, sunData.length-1);
						g_CamScheduleData[0]=sunData.split(',');
						break;
						case 'mon':
						data.push(_S('COMMON', 'MONDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							monData += datas[i] +',';
						}
						secheduleData.push(data);
						monData = monData.substring(0, monData.length-1);
						g_CamScheduleData[1]=monData.split(',');
						break;
						case 'tue':
						data.push(_S('COMMON', 'TUESDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							tueData += datas[i] +',';
						}
						secheduleData.push(data);
						tueData = tueData.substring(0, tueData.length-1);
						g_CamScheduleData[2]=tueData.split(',');
						break;
						case 'wed':
						data.push(_S('COMMON', 'WEDNESDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							wedData += datas[i] +',';
						}
						secheduleData.push(data);
						wedData = wedData.substring(0, wedData.length-1);
						g_CamScheduleData[3]=wedData.split(',');
						break;
						case 'thu':
						data.push(_S('COMMON', 'THURSDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							thuData += datas[i] +',';
						}
						secheduleData.push(data);
						thuData = thuData.substring(0, thuData.length-1);
						g_CamScheduleData[4]=thuData.split(',');
						break;
						case 'fri':
						data.push(_S('COMMON', 'FRIDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							friData += datas[i] +',';
						}
						secheduleData.push(data);
						friData = friData.substring(0, friData.length-1);
						g_CamScheduleData[5]=friData.split(',');
						break;
						case 'sat':
						data.push(_S('COMMON', 'SATURDAY'));
						for (var i=0; i< datas.length; i++) {
							data.push(datas[i]);
							satData += datas[i] +',';
						}
						secheduleData.push(data);
						satData = satData.substring(0, satData.length-1);
						g_CamScheduleData[6]=satData.split(',');
						break;
					}

				}
				var SCH_CREATED = false;

				var getScheduleData = function() {
					SCH_CREATED = true;
					var urlOpts = {
						act: 'torrent-scheduler-get'
					};
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							if (!json.enable_scheduler) {
								autoDownload.setValue(true);
								useImg = false;
								maxLimitDownloadSpeedText.setDisabled(true);
								maxLimitUploadSpeedText.setDisabled(true);
							} else {
								scheduleDownload.setValue(true);
								useImg = true;
								maxLimitDownloadSpeedText.setDisabled(false);
								maxLimitUploadSpeedText.setDisabled(false);
							}
							maxLimitDownloadSpeedText.setValue(json.max_download_speed);
							maxLimitUploadSpeedText.setValue(json.max_upload_speed);

							secheduleData = [];
							createDataArray('sun', json.sun);
							createDataArray('mon', json.mon);
							createDataArray('tue', json.tue);
							createDataArray('wed', json.wed);
							createDataArray('thu', json.thu);
							createDataArray('fri', json.fri);
							createDataArray('sat', json.sat);

							UpdateScheduleInfo();
							ScheduleMouseAction('down', 'continue');
							if (!initApply) {
								initApply = true;
							}
						},
						failure: function (json, opts) {
							winapp.showErrorMsgWin('torrent-scheduler-get', json, winapp.win);
						}
					});
				}
				var useImg = false;
				var autoDownload = Ext.create('Ext.form.field.Radio', {
					name: 'download-schedule',
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_AUTO_START_DOWNLOAD'),
					listeners: {
						change: function( field, newValue, oldValue, eOpts) {
							if (newValue) {
								maxLimitDownloadSpeedText.setDisabled(true);
								maxLimitUploadSpeedText.setDisabled(true);
								timeprofile.setDisabled(true);
							} else {
								timeprofile.setDisabled(false);
								maxLimitDownloadSpeedText.setDisabled(false);
								maxLimitUploadSpeedText.setDisabled(false);
							}
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}

				});

				var scheduleDownload = Ext.create('Ext.form.field.Radio', {
					name: 'download-schedule',
					boxLabel: _S('DOWNLOAD_CENTER', 'INFO_SCHEDULE_DOWNLOAD'),
					listeners: {
						change: function( field, newValue, oldValue, eOpts) {
							if (newValue) {
								timeprofile.setDisabled(false);
								maxLimitDownloadSpeedText.setDisabled(false);
								maxLimitUploadSpeedText.setDisabled(false);
								useImg = true;
							} else {
								maxLimitDownloadSpeedText.setDisabled(true);
								maxLimitUploadSpeedText.setDisabled(true);
								timeprofile.setDisabled(true);
								useImg = false;

							}
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}

				});

				var seedRadio = Ext.create('Ext.form.field.Display', {
					width: 300,
					name: 'date-speed',
					value: _S('DOWNLOAD_CENTER', 'INFO_ONLY_SEEDING')
				});

				var maxLimitDownloadSpeed = Ext.create('Ext.form.field.Checkbox', {
					width: 18,
					height: 25,
					margin: '1, 0, 0, 0',
					flex: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxLimitDownloadSpeedText = Ext.create('Ext.form.field.Number', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_LIMITED_MAXIMUM_DOWNLOAD_SPEED'),
					margin: '0, 0, 0, 13',
					labelWidth: 315,
					disabled: true,
					flex: 0,
					maxValue: 999999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxLimitUploadSpeed = Ext.create('Ext.form.field.Checkbox', {
					width: 18,
					height: 25,
					margin: '1, 0, 0, 0',
					flex: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				var maxLimitUploadSpeedText = Ext.create('Ext.form.field.Number', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_LIMITED_MAXIMUM_UPLOAD_SPEED'),
					margin: '0, 0, 0, 13',
					labelWidth: 315,
					disabled: true,
					flex: 0,
					maxValue: 999999,
					minValue: 0,
					listeners: {
						change: function(field, newValue, oldValue, eOpts ) {
							if (initApply) {
								btnApply.setDisabled(false);
							}
						}
					}
				});

				//-------------------------------------- download schedule action---------------------------------------------------
				var setDownloadSchedule = function() {
					var urlString;
					var dataString;
					var timeProfileCount=0;
					var lastGridAction = SCH_TYPE_NONE;
					var watchDog;

					for (var day=0; day<7; day++){
						var updateData = '';
						for (var hidx=0; hidx<48; hidx++){
							var l = "cam_schedule_" + day + "_" + hidx;
							if(document.getElementById(l) !== null)
							{
								var value = document.getElementById(l).value;
								//_D('value:'+value);
								if (value == 'undefined') {
									value = 0;
								}
								updateData += value +',';
							}

						}
						updateData = updateData.substring(0, updateData.length-1);
						if (day == 0) {
							//sunday
							sunData = updateData;
						} else if (day==1) {
							//monday
							monData = updateData;
						} else if (day==2) {
							//tuesday
							tueData = updateData;
						} else if (day==3) {
							//wednesday
							wedData = updateData;
						} else if (day==4) {
							//thursday
							thuData = updateData;
						} else if (day==5) {
							//friday
							friData = updateData;
						} else if (day==6) {
							//satusday
							satData = updateData;
						}
					}
					//do cgi
					win.el.mask(_S('COMMON', 'APPLYING'));

					var urlOpts = {
						act: 'torrent-scheduler-set',
						enable_scheduler: scheduleDownload.getValue(),
						max_download_speed: maxLimitDownloadSpeedText.getValue(),
						max_upload_speed: maxLimitUploadSpeedText.getValue(),
						sun: sunData,
						mon: monData,
						tue: tueData,
						wed: wedData,
						thu: thuData,
						fri: friData,
						sat: satData
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
						    if (typeof(win) != 'undefined') {
						        if (typeof(win.el) != 'undefined') {
						            win.el.unmask();
						        }
							}
						},
						failure: function (json, opts) {
						    if (typeof(win) != 'undefined') {
						        if (typeof(win.el) != 'undefined') {
						            win.el.unmask();
						        }
							}
							winapp.showErrorMsgWin('torrent-scheduler-set', json, win);
						}
					});
				};
				//-------------------------------------- torrent search site UI ---------------------------------------------------
				var getTorrentSearchStore = function() {
					var urlOpts = {
						act: 'torrent-search-site-list'
					};

					//grid store
					var listStore = Ext.create('Ext.data.JsonStore', {
					    autoDestroy: true,
                        autoLoad: false,
						fields: [
							'enable', 'name', 'url', 'version', 'custom', 'account_support'
						],
						proxy: {
							type: 'ajax',
							url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
							reader: {
								type: 'json',
								root: 'items'
							}
						}
					});

					return listStore;
				}

				var reloadTorrentSearchStore = function() {
					var urlOpts = {
						act: 'torrent-search-site-list'
					};

					//grid store
					var listStore = Ext.create('Ext.data.JsonStore', {
					    autoDestroy: true,
					    autoLoad: false,
						fields: [
							'enable', 'name', 'url', 'version'
						],
						proxy: {
							type: 'ajax',
							url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
							reader: {
								type: 'json',
								root: 'items'
							}
						},
						listeners: {
							load: function( store, records, successful, operation, eOpts ) {

							}
						}
					});

					listStore.load();
				};

				var enableRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
					var hasIcon = value;
					var result = '';
					var img = '../apps/download-center/images/check.png';
					if (value) {
						result = '<div align="center"><img src="'+img+'" height="16" width="16" ></div>';
					}
					return result;
				};

				var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {
					clicksToEdit: 1
				});
				var sm = Ext.create('Ext.selection.CheckboxModel');

				var checkGroup = new AS.ARC.checkColumn({
					name: 'check-group',
					dataIndex: 'enable',
					listeners: {
						afterheaderclick: function(){
							if(this.getSelection().length){
								btnOk.enable();
							}else{
								btnOk.disable();
							}
							btnApply.setDisabled(false);
						},
						checkchange: function(){
							if(this.getSelection().length){
								btnOk.enable();
							}else{
								btnOk.disable();
							}
							btnApply.setDisabled(false);
						}
					}
				});
				var checkFailData = function() {
					//_D('checkFailData');
					var length = siteFailData.length;
					//console.dir(siteFailData);
					for (var i=0; i< length; i++) {
						var item = siteFailData[i];
					}
					var records = torrentPanel.getStore().getRange();
				};

				var checkEnableEnd= function(i, length, timeout) {

					torrentPanel.checkEnableItemEnd[i] = true;
					var allDone = true;
					if(!timeout){
						for(var j =0; j<length; j++){
							allDone = allDone && torrentPanel.checkEnableItemEnd[j];
							if(!allDone) return;
						}
					}

					if(allDone){
					    clearTimeout(lastApplyTimeout);
					    if (typeof(win) != 'undefined') {
					        if (typeof(win.el) != 'undefined') {
					            win.el.unmask();
					        }
					    }
						//get fail list & display error msg
						var failListString = '';
						torrentPanel.setSearchSiteResult.each(function(item, index){
							if(!torrentPanel.setSearchSiteResult[index]){
								failListString = ((failListString=='')?'':failListString + ', ') + torrentPanel.store.getAt(index).data.name;
							}
						});
						//if any apply fail occur, reload
						if(failListString != ''){
							var act = _S('DOWNLOAD_CENTER', 'UNABLE_APPLY_SETTINGS_FOR_ARG').replace('ARG', failListString);
							winapp.showErrorMsgWin(act, {}, winapp.win);
							reloadTorrentSearchStore();
							var length = torrentPanel.setSearchSiteResult.length;
						}
					}
				};

                //Add/Edit/Delete panelToolBar
                var btnAddTSS = Ext.create(Ext.button.Button, {
                    text: _S('COMMON', 'ADD'),
                    scale: AS.ARC.config.defaultActionButtonSize,
                    disabled: false,
                    handler: function() {
                        addTorrentSearchSite();
                    },
                    scope: this
                });
                var btnEditTSS = Ext.create(Ext.button.Button, {
                    text: _S('COMMON', 'EDIT'),
                    scale: AS.ARC.config.defaultActionButtonSize,
                    disabled: true,
                    handler: function() {
                        editTorrentSearchSite();
                    },
                    scope: this
                });
                var btnDeleteTSS = Ext.create(Ext.button.Button, {
                    text: _S('COMMON', 'DELETE'),
                    scale: AS.ARC.config.defaultActionButtonSize,
                    disabled: true,
                    handler: function(btn) {
                        var cb= function() {
                            btn.disable();
                        };
                        deleteTorrentSearchSite(cb);
                    },
                    scope: this
                });

				var torrentPanel = Ext.create('Ext.grid.GridPanel', {
					itemId: 'item-grid',
					// width: 707,
					height: 340,
					border: false,
					resizable: false,
					store: getTorrentSearchStore(),
					scope: this,
					buffered: true,
					viewConfig:{
						onStoreLoad: Ext.emptyFn,
						focusRow: Ext.emptyFn,
						loadMask: false,
						style: {overflow: 'auto', overflowX: 'auto'}
					},
					columns: [
					checkGroup,
					{
						xtype: 'gridcolumn',
						dataIndex: 'name',
						width: 120,
						sortable: true,
						align: 'left',
						text: _S('DOWNLOAD_CENTER','NAME'),
						renderer: fileOfTorrentRenderer
					},{
						xtype: 'gridcolumn',
						dataIndex: 'url',
						flex: 1,
						sortable: true,
						align: 'left',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_URL'),
						renderer: fileOfTorrentRenderer
					},{
						xtype: 'gridcolumn',
						dataIndex: 'version',
						resizable: false,
						width: 75,
						sortable: true,
						align: 'left',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_VERSION')
					}],
					listeners: {
						itemclick: function ( view, record, item, index, e, eOpts ) {
                            if(record.data.account_support) {
                                btnEditTSS.enable();
                            } else {
                                btnEditTSS.disable();
                            }

                            if(AS.ARC.user.isAdmin) {
                            	if(record.data.custom) {
	                                btnDeleteTSS.enable();
	                            } else {
	                                btnDeleteTSS.disable();
	                            }
                            } else {
                            	btnDeleteTSS.disable();
                            }
						},
						afterrender: function(Grid) {
							Ps.initialize(Grid.body.dom);
							Ps.update(Grid.body.dom);
						},
						scope: this
					}
				});

                function onTorrentEdit() {
					var record = torrentPanel.getSelectionModel().getSelection()[0];
					var store = torrentPanel.getStore();
					var checkRecords = store.getRange();
					var findEnable = false;
					for (var i=0; i< checkRecords.length; i++) {
						if (checkRecords[i].data.enable) {
							findEnable = true;
							break;
						}
					}
					if (findEnable) {
						var urlOpts = {
							act: 'torrent-search-site-enable',
							name: record.data.name,
							enable: record.data.enable
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								reloadTorrentSearchStore();
							},
							failure: function (json, opts) {
								winapp.showErrorMsgWin('torrent-search-site-enable', json, winapp.win);
							}
						});
					} else {
						AS.ARC.util.msgDialog(win, winapp.MSG_TYPE_ERROR, _S('DOWNLOAD_CENTER', 'ALERT_SELECT_SITE'));
					}
				};

				var setSearchSite = function() {
					var records = torrentPanel.getStore().getRange();
					win.el.mask(_S('COMMON', 'APPLYING'));
					torrentPanel.setSearchSiteResult = [];
					torrentPanel.checkEnableItemEnd = [];

					records.each( function(item, index){
						//make sure last apply would trigger checkEnableEnd to unmask
						if(index == records.length-1){
							lastApplyTimeout = setTimeout(function() {
								checkEnableEnd(index, records.length, true);
								},30000);
						}

						var urlOpts = {
							act: 'torrent-search-site-enable',
							name: item.data.name,
							enable: item.data.enable
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								torrentPanel.setSearchSiteResult[index] = true;
								checkEnableEnd(index, records.length, false);
							},
							failure: function (json, opts) {
								torrentPanel.setSearchSiteResult[index] = false;
								checkEnableEnd(index, records.length, false);
							}
						});
					});
				};
				//-------------------------------------- torrent search site action---------------------------------------------------
				var updateTorrentSearchSite = function() {
					if (winapp.PREFERENCE_UPDATE_TORRENT_SITE_WIN_NUMBER < winapp.MAX_PREFERENCE_UPDATE_TORRENT_SITE_WIN) {
						//-------------------------------------- updateFileHostingSite UI---------------------------------------------------
						var pbar = Ext.create('Ext.ProgressBar', {
							margin: 10
						});
						pbar.wait({
							interval: 500, //bar will move fast!
							duration: 50000,
							increment: 5,
							text: _S('DOWNLOAD_CENTER', 'WAIT_UPDATE'),
							scope: this,
							fn: function(){
								p.updateText(_S('DOWNLOAD_CENTER', 'INFO_DONE'));
							}
						});
						//-------------------------------------- updateFileHostingSite window---------------------------------------------------
						var win = Ext.create('AS.ARC.subWindow', {
							title: _S('DOWNLOAD_CENTER', 'TITLE_UPDATE_TORRENT_SEARCH_SITE'),
							cls: 'as-win-sub',
							bodyCls: 'as-win-subdow-body',
							width: 400,
							height: 200,
							border: false,
							resizable: false,
							fbar: [
							{
								text: _S('COMMON', 'CANCEL'),
								handler: function () {
									win.close();
								}
							}],
							items: [
							{
								xtype: 'asPanelTop10',
								height: 100,
								items: [
									{
									xtype: 'container',
									height: 50,
									margin: 10,
									layout: {
										align: 'stretch',
										type: 'hbox'
									},
									items: [{
										xtype: 'image',
										height: 50,
										width: 50,
										src: '../apps/download-center/images/icon.png'
									},{
										xtype: 'container',
										width: 10,
										flex: 0
									},{
										xtype: 'displayfield',
										value: _S('DOWNLOAD_CENTER', 'INFO_UPDATE_TORRENT_SEARCH_SITE'),
										flex: 1
									}]
								},
								pbar
								]
							}

							],
							listeners: {
								render: function ( com, eOpts ) {
									winapp.PREFERENCE_UPDATE_TORRENT_SITE_WIN_NUMBER++;
								},
								beforeclose: function( panel, eOpts ) {
									winapp.PREFERENCE_UPDATE_TORRENT_SITE_WIN_NUMBER--;
								}
							}
						});

						win.show();
					}
				};
                //btnAddTSS handler
                var addTorrentSearchSite = function() {

                    //addTorrentSearchSite UI
                    var btnUploadTSS = Ext.create('Ext.button.Button', {
                        text: _S('COMMON', 'ADD'),
                        scale: AS.ARC.config.defaultActionButtonSize,
                        handler: function() {
                            //torrent-add-search-engine
                            uploadTSSForm.getForm().submit({
                                url: AS.ARC.util.getApiUrlWithSid(winapp.UploadUrl, {
                                    act: 'torrent-add-search-engine'
                                }),
                                success: function (f, e) {
                                    torrentPanel.el.mask(_S('COMMON', 'APPLYING'));
                                    torrentPanel.getStore().load({
                                        callback: function(records, operation, success) {
                                            torrentPanel.el.unmask();
                                        }
                                    });
                                    addTSSWin.close();
                                },
                                failure: function(form, action){
                                    var json = Ext.decode(action.response.responseText);
                                    AS.ARC.util.showMsgWindow({
                                        5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
                                        5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
                                        5303: _S('ERROR', 'INCORRECT_PARAMETER'),
                                        5041: _S('DOWNLOAD_CENTER', 'INVALID_FORMAT'),
                                    }, json, addTSSWin, 'info', function() {
                                        uploadTSSForm.checkForm();
                                    });
                                }
                            });
                        }
                    });

                    var uploadTSSForm = Ext.create('AS.ARC.panelTop20', {
                        buttonApply: btnUploadTSS,
                        items: [{
                            xtype: 'displayfield',
                            value: _S('FILE_EXPLORER', 'TITLE_UPLOAD') + '(.dlm)' + _S('COMMON', 'COLON')
                        },{
                            xtype: 'filefield',
                            name: 'files',
                            labelWidth: 100,
                            msgTarget: 'side',
                            allowBlank: false,
							blankText: _S('MESSAGE', 'HF00011'),
                            anchor: '100%',
                            buttonText: _S('COMMON', 'BROWSE'),
                            regex: (/.(dlm)$/i),
                            regexText: _S('DOWNLOAD_CENTER', 'FILE_FORMAT_NOT')
                        }]
                    });

                    var addTSSWin = Ext.create('AS.ARC.subWindow', {
                        title: _S('COMMON', 'ADD'),
                        parentWin: win,
                        width: 450,
                        height: 210,
                        scope: this,
                        fbar: [
                            btnUploadTSS,{
                            text: _S('COMMON', 'CANCEL'),
                            handler: function () {
                                addTSSWin.close();
                            }
                        }],
                        items: [uploadTSSForm]
                    });
                    addTSSWin.show();
                    //addTorrentSearchSite action
                };
                //btnEditTSS handler
                var editTorrentSearchSite = function() {
                    //generate fake pswd to show
                    var randomArray = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
                    var pswd = '';
                    for(var i = 0; i < 8; i++) {
                        pswd += randomArray[Math.floor(Math.random()*randomArray.length)];
                    }
                    //editTorrentSearchSite UI
                    var tfAccount = Ext.create('Ext.form.field.Text', {
                        itemId: 'account',
                        fieldLabel: _S('COMMON', 'USERNAME'),
                        allowBlank: false,
                        msgTarget: 'side',
                        width: 315,
                        labelWidth: 160,
                        listeners: {
                            change: function() {
                                tfPassword.setValue('');
                                tfPasswordConfirm.setValue('');
                            }
                        }
                    });

                    var tfPassword = Ext.create('Ext.form.field.Text', {
                        itemId: 'password',
                        fieldLabel: _S('COMMON', 'PWD'),
                        allowBlank: false,
                        maxLength: 32,
                        maxLengthText: Ext.String.format(_S('MESSAGE', 'HF00016'), 32),
                        msgTarget: 'side',
                        labelWidth: 160,
                        inputType: 'password',
                        listeners: {
                            change: function (f) {
                                tfPasswordConfirm.allowBlank = (f.value === '');
                                tfPasswordConfirm.validate();
                            }
                        }
                    });

                    var tfPasswordConfirm = Ext.create('Ext.form.field.Text', {
                        itemId: 'password-confirm',
                        fieldLabel: _S('COMMON', 'CONFIRM_PWD'),
                        maxLength: 32,
                        maxLengthText: Ext.String.format(_S('MESSAGE', 'HF00016'), 32),
                        msgTarget: 'side',
                        inputType: 'password',
                        labelWidth: 160,
                        vtype: 'userPwd'
                    });

                    var btnSetAccount = Ext.create('Ext.button.Button', {
                        text: _S('COMMON', 'OK'),
                        scale: AS.ARC.config.defaultActionButtonSize,
                        handler: function(btn) {
                            var account = tfAccount.getValue(),
                                password = tfPassword.getValue(),
                                name = torrentPanel.getSelectionModel().getSelection()[0].data.name;
                            editTSSWin.el.mask(_S('COMMON', 'APPLYING'));
                            //torrent-set-search-engine
                            var urlOpts;
                            if(password === pswd) {
                                urlOpts = {
                                    act: 'torrent-set-search-engine',
                                    name: name,
                                    account: account
                                };
                            } else {
                                urlOpts = {
                                    act: 'torrent-set-search-engine',
                                    name: name,
                                    account: account,
                                    passwd: password
                                };
                            }
                            AS.ARC.ajax({
                                url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
                                method: 'post',
                                success: function (json, opts) {
                                    editTSSWin.el.unmask();
                                    AS.ARC.util.msgDialog(editTSSWin, 'info', _S('COMMON', 'SUCCESS'),function() {
                                            editTSSWin.close();
                                    });
                                },
                                failure: function (json, opts) {
                                    editTSSWin.el.unmask();
                                    AS.ARC.util.showMsgWindow({
                                        5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
                                        5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
                                        5303: _S('ERROR', 'INCORRECT_PARAMETER')
                                    }, json, editTSSWin, 'info');
                                }
                            });
                        }
                    });

                    var btnTestAccount = Ext.create('Ext.button.Button', {
                        text: _S('COMMON', 'TEST'),
                        scale: AS.ARC.config.defaultActionButtonSize,
                        margin: '0 0 0 3',
                        handler: function(btn) {
                            var account = tfAccount.getValue(),
                                password = tfPassword.getValue(),
                                name = torrentPanel.getSelectionModel().getSelection()[0].data.name;
                            if(account && password) {
                                editTSSWin.el.mask(_S('COMMON', 'APPLYING'));
                                //torrent-test-search-engine-account
                                var urlOpts = {
                                    act: 'torrent-test-search-engine-account',
                                    name: name,
                                    account: account,
                                    passwd: password
                                };
                                AS.ARC.ajax({
                                    url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
                                    method: 'post',
                                    success: function (json, opts) {
                                        editTSSWin.el.unmask();
                                        AS.ARC.util.msgDialog(editTSSWin, 'info', _S('COMMON', 'SUCCESS'));
                                    },
                                    failure: function (json, opts) {
                                        editTSSWin.el.unmask();
                                        AS.ARC.util.showMsgWindow({
                                            5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
                                            5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
                                            5303: _S('ERROR', 'INCORRECT_PARAMETER')
                                        }, json, editTSSWin, 'info');
                                    }
                                });
                            }
                        }
                    });

                    var editTSSWin = Ext.create('AS.ARC.subWindow', {
                        title: _S('COMMON', 'EDIT'),
                        parentWin: win,
                        width: 500,
                        height: 250,
                        scope: this,
                        fbar: [
                            btnSetAccount, {
                            text: _S('COMMON', 'CANCEL'),
                            handler: function () {
                                editTSSWin.close();
                            }
                        }],
                        items: [{
                            xtype: 'asPanelTop20',
                            buttonApply: btnSetAccount,
                            items: [{
                                layout: 'hbox',
                                border: 0,
                                items: [
                                    tfAccount,
                                    btnTestAccount
                                ]
                            },
                                tfPassword,
                                tfPasswordConfirm
                            ]
                        }],
                        listeners: {
                            afterrender: function() {
                                editTSSWin.el.mask(_S('COMMON', 'LOADING'));
                                var name = torrentPanel.getSelectionModel().getSelection()[0].data.name;
                                //torrent-get-search-engine
                                var urlOpts = {
                                    act: 'torrent-get-search-engine',
                                    name: name
                                };
                                AS.ARC.ajax({
                                    url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
                                    method: 'post',
                                    success: function (json, opts) {
                                        editTSSWin.el.unmask();
                                        if(json.account !== '') {
                                            tfAccount.setRawValue(json.account);
                                            tfPassword.setValue(pswd);
                                            tfPasswordConfirm.setValue(pswd);
                                        }
                                    },
                                    failure: function (json, opts) {
                                        editTSSWin.el.unmask();
                                        AS.ARC.util.showMsgWindow({
                                            5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
                                            5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
                                            5303: _S('ERROR', 'INCORRECT_PARAMETER'),
                                            5005: _S('DOWNLOAD_CENTER', 'NO_DATA')
                                        }, json, editTSSWin, 'info');
                                    }
                                });
                            }
                        }
                    });
                    editTSSWin.show();
                    //editTorrentSearchSite action
                };
                //btnDeleteTSS handler
                var deleteTorrentSearchSite = function(callback) {
                    //deleteTorrentSearchSite UI
                    var deleteTSSWin = new AS.ARC.msgWindow({
                        title: _S('COMMON', 'CONFIRMATION'),
                        parentWin: win,
                        scope: this,
                        iconType: 'question',
                        fbar: [{
                            text: _S('COMMON', 'OK'),
                            handler: function () {
                                var name = torrentPanel.getSelectionModel().getSelection()[0].data.name;
                                //torrent-delete-search-engine
                                var urlOpts = {
                                    act: 'torrent-delete-search-engine',
                                    name: name
                                };
                                AS.ARC.ajax({
                                    url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
                                    method: 'get',
                                    success: function (json, opts) {
                                        torrentPanel.el.mask(_S('COMMON', 'APPLYING'));
                                        torrentPanel.getStore().load({
                                            callback: function(records, operation, success) {
                                                torrentPanel.el.unmask();
                                            }
                                        });
                                        callback();
                                        deleteTSSWin.close();
                                    },
                                    failure: function (json, opts) {
                                        AS.ARC.util.showMsgWindow({
                                            5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
                                            5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
                                            5303: _S('ERROR', 'INCORRECT_PARAMETER')
                                        }, json, deleteTSSWin, 'info');
                                    }
                                });
                            }
                        },{
                            text: _S('COMMON', 'CANCEL'),
                            handler: function () {
                                deleteTSSWin.close();
                            }
                        }],
                        asItems: [{
                            xtype: 'displayfield',
                            value: _S('COMMON', 'REMOVE_SELECTED_ITEMS')
                        }]
                    });
                    deleteTSSWin.show();
                    //deleteTorrentSearchSite action
                };

				//-------------------------------------- file hosting site UI---------------------------------------------------
				//Renderer
				var statusRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
					var result = '';
					if (value == 'V') {
						result = '<div style="color:#0F0;" >'+value+'</div>';
					} else {
						result = '<div style="color:#F00;" >'+value+'</div>';;
					}

					return result;
				};
				var getFileHostingStore = function() {
					var myData = [
						['', 'MediaFire', 'Steve', 'V', '2012/1/14', '1.1', '11111'],
						['#', 'Youtube', 'Steve', 'X', 'N/A', '1.2', '22222'],
						['', 'MediaFire', 'Kevin', 'V', '2012/2/24', '1.1', '33333'],
						['', 'Youtube', 'Kevin', 'X', '2012/1/14', '1.5', '44444'],
						['', '4Share', 'Steve', 'V', '2012/1/18', '1.1', '55555'],
						['#', 'MediaFire', 'Albert', 'V', '2012/1/25', '1.1', '66666']
					];

					var dataStore = new Ext.data.ArrayStore({
						fields: [
							{name: 'flag'},
							{name: 'provider'},
							{name: 'account'},
							{name: 'status'},
							{name: 'expir-date'},
							{name: 'version'},
							{name: 'password'}
						]
					});

					dataStore.loadData(myData);

					return dataStore;
				}

				var hostingPanel = Ext.create('Ext.grid.GridPanel', {
					itemId: 'item-grid',
					height: 325,
					//margin: 5,
					border: false,
					autoScroll: true,
					resizable: false,
					store: getFileHostingStore(),
					buffered: true,
					viewConfig:{
						onStoreLoad: Ext.emptyFn,
						focusRow: Ext.emptyFn,
						loadMask: false,
						style: {overflow: 'auto', overflowX: 'auto'}
					},
					scope: this,
					columns: [{
						xtype: 'gridcolumn',
						dataIndex: 'flag',
						width: 50,
						sortable: true,
						align: 'left'
					},{
						xtype: 'gridcolumn',
						dataIndex: 'provider',
						width: 200,
						sortable: true,
						align: 'left',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_FILE_HOSTING_PROVIDER'),
						resizable: true
					},{
						xtype: 'gridcolumn',
						dataIndex: 'account',
						width: 100,
						sortable: true,
						align: 'left',
						text: _S('COMMON','ACCOUNT'),
						resizable: true
					},{
						xtype: 'gridcolumn',
						dataIndex: 'status',
						width: 50,
						sortable: true,
						align: 'left',
						text: _S('COMMON','STATUS'),
						renderer: statusRenderer
					},{
						xtype: 'gridcolumn',
						dataIndex: 'expir-date',
						width: 100,
						sortable: true,
						align: 'left',
						text: _S('COMMON','EXPIRATION_DATE')
					},{
						xtype: 'gridcolumn',
						dataIndex: 'version',
						flex: 1,
						sortable: true,
						align: 'left',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_VERSION')
					}],
					listeners: {
						afterrender: function(Grid) {
							Ps.initialize(Grid.body.dom);
							Ps.update(Grid.body.dom);
						},
						scope: this
					}
				});
				//-------------------------------------- file hosting site action---------------------------------------------------
				var addFileHostingSite = function() {
					if (winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER < winapp.MAX_PREFERENCE_AE_HOSTING_SITE_WIN) {
						//-------------------------------------- addFileHostingSite UI---------------------------------------------------
						var addProvider = Ext.create('Ext.form.ComboBox', {
							margin: 5,
							fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_FILE_HOSTING_PROVIDER'),
							labelWidth: 150,
							store: new Ext.data.ArrayStore({
								fields: ['display', 'value'],
								data: [
									['Youtube', 'youtube'],
									['MediaFire', 'mediafire'],
									['4Share', '4share']
								]
							}),
							displayField: 'display',
							valueField: 'value',
							editable: false,
							scope: this,
							listeners: {
								render: function( combo, eOpts ) {
									addProvider.select('mediafire');
								}
							}
						});

						var addAccount = Ext.create('Ext.form.field.Text', {
							margin: 5,
							fieldLabel: _S('COMMON','ACCOUNT'),
							labelWidth: 150
						});

						var addPassword = Ext.create('Ext.form.field.Text', {
							margin: 5,
							inputType: 'password',
							fieldLabel: _S('COMMON', 'PWD'),
							labelWidth: 150
						});
						//-------------------------------------- addFileHostingSite action---------------------------------------------------
						var doAddFileHostingSite = function() {
							//_D('addProvider:'+addProvider.getValue());
							//_D('addAccount:'+addAccount.getValue());
							//_D('addPassword:'+addPassword.getValue());
						};
						//-------------------------------------- addFileHostingSite window---------------------------------------------------
						var win = Ext.create('Ext.window.Window', {
							title: _S('DOWNLOAD_CENTER', 'TITLE_ADD_FILE_HOSTING_SITE'),
							cls: 'as-win-sub',
							bodyCls: 'as-win-subdow-body',
							width: 330,
							height: 180,
							resizable: false,
							dockedItems: [{
								xtype: 'container',
								height: 25,
								layout: {
									align: 'stretch',
									type: 'hbox'
								},
								dock: 'bottom',
								items: [{
									xtype: 'container',
									flex: 2
								},{
									xtype: 'button',
									text: _S('COMMON', 'OK'),
									flex: 1,
									handler: function() {
										doAddFileHostingSite();
										win.close();
									}
								},{
									xtype: 'button',
									text: _S('COMMON', 'CANCEL'),
									flex: 1,
									handler: function() {
										win.close();
									}
								}]
							}],
							items: [
							addProvider,
							addAccount,
							addPassword
							],
							listeners: {
								render: function ( com, eOpts ) {
									winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER++;
								},
								beforeclose: function( panel, eOpts ) {
									winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER--;
								}
							}
						});

						win.show();
					}
				};

				var editFileHostingSite = function() {
					if (winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER < winapp.MAX_PREFERENCE_AE_HOSTING_SITE_WIN) {
						var select = hostingPanel.getSelectionModel().getSelection();
						if (select.length == 1) {
							//-------------------------------------- editFileHostingSite UI---------------------------------------------------
							var editProvider = Ext.create('Ext.form.ComboBox', {
								margin: 5,
								fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_FILE_HOSTING_PROVIDER'),
								labelWidth: 150,
								store: new Ext.data.ArrayStore({
									fields: ['display', 'value'],
									data: [
										['Youtube', 'youtube'],
										['MediaFire', 'mediafire'],
										['4Share', '4share']
									]
								}),
								displayField: 'display',
								valueField: 'value',
								editable: false,
								scope: this,
								listeners: {
									render: function( combo, eOpts ) {
										editProvider.select(select[0].data.provider);
									}
								}
							});

							var editAccount = Ext.create('Ext.form.field.Text', {
								margin: 5,
								fieldLabel: _S('COMMON','ACCOUNT'),
								labelWidth: 150,
								value: select[0].data.account
							});

							var editPassword = Ext.create('Ext.form.field.Text', {
								margin: 5,
								inputType: 'password',
								fieldLabel: _S('COMMON', 'PWD'),
								labelWidth: 150,
								value: select[0].data.password
							});
							//-------------------------------------- editFileHostingSite action---------------------------------------------------
							var doEditFileHostingSite = function() {
								//_D('editProvider:'+editProvider.getValue());
								//_D('editAccount:'+editAccount.getValue());
								//_D('editPassword:'+editPassword.getValue());
							};
							//-------------------------------------- editFileHostingSite window---------------------------------------------------
							var win = Ext.create('Ext.window.Window', {
								title: _S('DOWNLOAD_CENTER', 'TITLE_EDIT_FILE_HOSTING_SITE'),
								cls: 'as-win-sub',
								bodyCls: 'as-win-subdow-body',
								width: 330,
								height: 180,
								resizable: false,
								dockedItems: [{
									xtype: 'container',
									height: 25,
									layout: {
										align: 'stretch',
										type: 'hbox'
									},
									dock: 'bottom',
									items: [{
										xtype: 'container',
										flex: 2
									},{
										xtype: 'button',
										text: _S('COMMON', 'OK'),
										flex: 1,
										handler: function() {
											doEditFileHostingSite();
											win.close();
										}
									},{
										xtype: 'button',
										text: _S('COMMON', 'CANCEL'),
										flex: 1,
										handler: function() {
											win.close();
										}
									}]
								}],
								items: [
								editProvider,
								editAccount,
								editPassword
								],
								listeners: {
									render: function ( com, eOpts ) {
										winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER++;
									},
									beforeclose: function( panel, eOpts ) {
										winapp.PREFERENCE_AE_HOSTING_SITE_WIN_NUMBER--;
									}
								}
							});

							win.show();
						}
					}
				};

				var removeFileHostingSite = function() {
					//_D('removeFileHostingSite');
					if (winapp.PREFERENCE_REMOVE_HOSTING_SITE_WIN_NUMBER < winapp.MAX_PREFERENCE_REMOVE_HOSTING_SITE_WIN) {
						var select = hostingPanel.getSelectionModel().getSelection();
						if (select.length == 1) {
							var showInfo = select[0].data.provider+'-'+select[0].data.account+'?';
							//-------------------------------------- removeFileHostingSite UI---------------------------------------------------
							var removeName = Ext.create('Ext.form.field.Display', {
								value: showInfo
							});
							//-------------------------------------- removeFileHostingSite action---------------------------------------------------
							var doRemoveFileHostingSite = function() {
								//_D('removeName:'+removeName.getValue());
							};
							//-------------------------------------- removeFileHostingSite window---------------------------------------------------
							var win = Ext.create('Ext.window.Window', {
								title: _S('DOWNLOAD_CENTER', 'TITLE_REMOVE_FILE_HOSTING_SITE'),
								cls: 'as-win-sub',
								bodyCls: 'as-win-subdow-body',
								width: 330,
								height: 180,
								border: false,
								resizable: false,
								dockedItems: [{
									xtype: 'container',
									height: 25,
									layout: {
										align: 'stretch',
										type: 'hbox'
									},
									dock: 'bottom',
									items: [{
										xtype: 'container',
										flex: 2
									},{
										xtype: 'button',
										text: _S('COMMON', 'OK'),
										flex: 1,
										handler: function() {
											doRemoveFileHostingSite();
											win.close();
										}
									},{
										xtype: 'button',
										text: _S('COMMON', 'CANCEL'),
										flex: 1,
										handler: function() {
											win.close();
										}
									}]
								}],
								items: [{
									xtype: 'container',
									height: 10
								},{
									xtype: 'container',
									height: 50,
									layout: {
										align: 'stretch',
										type: 'hbox'
									},
									items: [{
										xtype: 'image',
										height: 50,
										width: 50,
										src: '../apps/download-center/images/icon.png',
										flex: 0
									},{
										xtype: 'container',
										width: 10,
										flex: 0
									},{
										xtype: 'container',
										flex: 1,
										items: [{
											xtype: 'displayfield',
											value: _S('DOWNLOAD_CENTER', 'CONFIRM_REMOVE')
										},
										removeName
										]
									}]
								},{
									xtype: 'container',
									height: 10
								}],
								listeners: {
									render: function ( com, eOpts ) {
										winapp.PREFERENCE_REMOVE_HOSTING_SITE_WIN_NUMBER++;
									},
									beforeclose: function( panel, eOpts ) {
										winapp.PREFERENCE_REMOVE_HOSTING_SITE_WIN_NUMBER--;
									}
								}
							});

							win.show();
						}
					}
				};

				var updateFileHostingSite = function() {
					if (winapp.PREFERENCE_UPDATE_HOSTING_SITE_WIN_NUMBER < winapp.MAX_PREFERENCE_UPDATE_HOSTING_SITE_WIN) {
						//-------------------------------------- updateFileHostingSite UI---------------------------------------------------
						var pbar = Ext.create('Ext.ProgressBar', {
							margin: 10
						});
						pbar.wait({
							interval: 500, //bar will move fast!
							duration: 50000,
							increment: 5,
							text: _S('DOWNLOAD_CENTER', 'WAIT_UPDATE'),
							scope: this,
							fn: function(){
								p.updateText(_S('DOWNLOAD_CENTER', 'INFO_DONE'));
							}
						});
						//-------------------------------------- updateFileHostingSite window---------------------------------------------------
						var win = Ext.create('Ext.window.Window', {
							title: _S('DOWNLOAD_CENTER', 'TITLE_UPDATE_FILE_HOSTING_SITE'),
							cls: 'as-win-sub',
							bodyCls: 'as-win-subdow-body',
							width: 320,
							height: 160,
							border: false,
							resizable: false,
							items: [{
								xtype: 'container',
								height: 50,
								margin: 10,
								layout: {
									align: 'stretch',
									type: 'hbox'
								},
								items: [{
									xtype: 'image',
									height: 50,
									width: 50,
									src: '../apps/download-center/images/icon.png'
								},{
									xtype: 'container',
									width: 10,
									flex: 0
								},{
									xtype: 'displayfield',
									value: _S('DOWNLOAD_CENTER', 'INFO_UPDATING_FILE_HOSTING_SITE'),
									flex: 1
								}]
							},
							pbar
							],
							listeners: {
								render: function ( com, eOpts ) {
									winapp.PREFERENCE_UPDATE_HOSTING_SITE_WIN_NUMBER++;
								},
								beforeclose: function( panel, eOpts ) {
									winapp.PREFERENCE_UPDATE_HOSTING_SITE_WIN_NUMBER--;
								}
							}
						});

						win.show();
					}
				};

				//-------------------------------------- preference window UI ---------------------------------------------------
				//SCH
				var g_selectStartX =- 1;
				var g_selectStartY =- 1;
				var g_selectStopX =- 1;
				var g_selectStopY =- 1;
				var g_oldMouseUpFunc = null;
				var g_current_act = "continue";
				var g_TypeAct = ["erase", "continue", "external", "motion", "motion_external"];
				var g_isScheduleDirty = false;
				var g_CamScheduleMode = CAM_SCH_MODE_NORMAL;
				var g_IsMouseDown = false;

				var imgContRecording = new Ext.Panel({
					layout: 'hbox',
					id : "img_continuous",
					width: 325,
					bodyStyle:'border-style:hidden;',
					items: [{
						width : IMAGE_ICON_SIZE,
						xtype: 'component',
						html : "<span id='icon_continue' class='btn_continue_inactive'" +
								"onMouseOver=\"javascript:ScheduleMouseAction('over', 'continue');\"" +
								"onMouseOut=\"javascript:ScheduleMouseAction('out', 'continue');\"" +
								"onMousedown=\"javascript:ScheduleMouseAction('down', 'continue');\">" +
								"</span>"
					},{
						xtype: 'label',
						name: 'date-speed',
						text: _S('DOWNLOAD_CENTER', 'INFO_DEFAULT_DU_SPEED')
					}]
				});
				var imgMotionRecording = new Ext.Panel({
					layout: 'hbox',
					id : "img_motion",
					width: 325,
					bodyStyle:'border-style:hidden;',
					items: [{
						width : IMAGE_ICON_SIZE,
						xtype: 'component',
						html : "<span id='icon_motion' class='btn_motion_inactive'" +
								"onMouseOver=\"javascript:ScheduleMouseAction('over', 'motion');\"" +
								"onMouseOut=\"javascript:ScheduleMouseAction('out', 'motion');\"" +
								"onMousedown=\"javascript:ScheduleMouseAction('down', 'motion');\">" +
								"</span>"
					},{
						xtype: 'label',
						text: _S('DOWNLOAD_CENTER', 'INFO_STOP_DU'),
						name: 'date-speed',
						id: 'icon_motion_label'
					}]
				});
				var imgAlarmRecording = new Ext.Panel({
					layout: 'hbox',
					id : "img_external",
					width: 325,
					bodyStyle:'border-style:hidden;',
					items: [{
						width : IMAGE_ICON_SIZE,
						xtype: 'component',
						html : "<span id='icon_external' class='btn_external_inactive'" +
								"onMouseOver=\"javascript:ScheduleMouseAction('over', 'external');\"" +
								"onMouseOut=\"javascript:ScheduleMouseAction('out', 'external');\"" +
								"onMousedown=\"javascript:ScheduleMouseAction('down', 'external');\">" +
								"</span>"
					},{
						xtype: 'label',
						text: _S('DOWNLOAD_CENTER', 'INFO_LIMITED_SPEED'),
						name: 'date-speed',
						id: 'icon_external_label'
					}]
				});
				var imgBothRecording = new Ext.Panel({
					layout: 'hbox',
					id : "img_motion_external",
					width: 325,
					bodyStyle:'border-style:hidden;',
					items: [{
						width : IMAGE_ICON_SIZE,
						xtype: 'component',
						html : "<span id='icon_motion_external' class='btn_motion_external_inactive'" +
								"onMouseOver=\"javascript:ScheduleMouseAction('over', 'motion_external');\"" +
								"onMouseOut=\"javascript:ScheduleMouseAction('out', 'motion_external');\"" +
								"onMousedown=\"javascript:ScheduleMouseAction('down', 'motion_external');\">" +
								"</span>"
					},{
						xtype: 'label',
						text: _S('DOWNLOAD_CENTER', 'INFO_ONLY_SEEDING'),
						name: 'date-speed',
						id: 'icon_motion_external_label'
					}]
				});
				var timeprofile=Ext.create('Ext.panel.Panel', {
					width: 700,
					height:210,
					bodyStyle:'border-style:hidden; margin-left:25px',
					html: GetScheduler(),
					listeners: {
						render: function(com, eOpts) {
							Ext.fly(this.el).on('mouseup', function(e, t) {
								btnApply.setDisabled(false);
							});
						}
					}
				});

				var tabType = '';

				var generalTab = Ext.create('Ext.form.Panel', {
					//general
					itemId: 'general',
					cls: 'as-content as-content-top-10',
					title: _S('COMMON', 'GENERAL'),
					height: 480,
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth,
					},
					items: [{
						xtype: 'fieldset',
						title: _S('DOWNLOAD_CENTER', 'INFO_TASK'),
						items: [
							taskNumber,
							shareRatio,
							shareRatioText, {
								xtype: 'displayfield',
								style: 'display: inline-block; margin-left: 5px;',
								value: '%',
							},
							enableRemoveTask
						]
					},{
						xtype: 'fieldset',
						title: _S('COMMON', 'DIRECTORY'),
						items: [{
							xtype: 'asFlexbox',
							items: [
								preferenceDirectoryText,
								browser
							]
						}, {
							xtype: 'asFlexbox',
							cls: 'common-layout-horizontal-3-0',
							items: [
								tempFolderPath,
								tempBrowser,
							]
						}, {
							xtype: 'displayfield',
							value: _S('DOWNLOAD_CENTER', 'INFO_SMART_NOTE')
						},
							enableSmartDownload,
						{
							xtype: 'asFlexbox',
							cls: 'common-layout-horizontal-3-0',
							items: [
								watchDirectoryText,
								watchBrowser,
							]
						},
							enableIgnore
						]
					},
					{
						xtype: 'fieldset',
						title: _S('DOWNLOAD_CENTER', 'INFO_PUSH_NOTIFICATION'),
						items: [
						{
							xtype: 'displayfield',
							value: _S('DOWNLOAD_CENTER', 'INFO_PUSH_NOTIFY_NOTE')
						},
						enablePushNotification
						]
					}]
				});

				var connectionTab = Ext.create('Ext.form.Panel', {
					//connection
					cls: 'as-content as-content-top-10',
					itemId: 'connection',
					title: _S('COMMON', 'CONNECTION'),
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					items: [
					{
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('COMMON','PORT'),
						items: [TCPPort]
					}, {
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('DOWNLOAD_CENTER', 'INFO_PROTOCOL_ENCRYPTION'),
						items: [encryptionSettingsComboBox]
					}, {
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('DOWNLOAD_CENTER', 'INFO_DHT'),
						items: [
						enableDHTNetwork
						]
					}]
				});

				var bandwidthTab = Ext.create('Ext.form.Panel', {
					//bandwidth
					cls: 'as-content as-content-top-10',
					itemId: 'bandwidth',
					title: _S('DOWNLOAD_CENTER', 'INFO_BANDWIDTH'),
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					items: [
					{
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('DOWNLOAD_CENTER', 'INFO_TORRENT_SPEED'),
						items: [{
							xtype: 'asFlexbox',
							border: false,
							items: [
								maxDownloadRate,
								maxDownloadRateText,
								{
									xtype: 'displayfield',
									value: _S('DOWNLOAD_CENTER', 'INFO_KBS'),
									style: 'display: inline-block; margin-left: 5px;'
								}
							]
						}, {
							xtype: 'asFlexbox',
							cls: 'common-layout-horizontal-3-0',
							border: false,
							items: [
								maxUploadRate,
								maxUploadRateText,
								{
									xtype: 'displayfield',
									value: _S('DOWNLOAD_CENTER', 'INFO_KBS'),
									style: 'display: inline-block; margin-left: 5px;'
								}
							]
						}]
					},{
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('DOWNLOAD_CENTER', 'INFO_TORRENT_CONNECTION'),
						items: [
							maxConnectionNumberText,
							maxPeerTorrentText
						]
					},{
						xtype: 'fieldset',
						maintainFlex: true,
						title: _S('DOWNLOAD_CENTER', 'INFO_HTTP_FTP_SPEED'),
						items: [{
							xtype: 'asFlexbox',
							border: false,
							items: [
								maxDownloadRatePeerTask,
								maxDownloadRatePeerTaskText,
								{
									xtype: 'displayfield',
									value: _S('DOWNLOAD_CENTER', 'INFO_KBS'),
									style: 'display: inline-block; margin-left: 5px;'
								}
							]
						}]
					}]
				});

				var scheduleTab = Ext.create('Ext.form.Panel', {
					//download schedule
					cls: 'as-content as-content-top-10',
					title: _S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_SCHEDULE'),
					itemId: 'download-schedule',
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					autoScroll: true,
					items:[
						autoDownload,
						scheduleDownload,
						{
							xtype: 'container',
							height: 27,
							layout: {
								align: 'stretch',
								type: 'hbox'
							},
							items: [
								imgContRecording,
								imgMotionRecording
							]
						},{
							xtype: 'container',
							height: 27,
							layout: {
								align: 'stretch',
								type: 'hbox'
							},
							items: [
								imgAlarmRecording,
								imgBothRecording
							]
						},
						{
							layout: 'hbox',
							border: false,
							items: [
							maxLimitDownloadSpeedText,
							{
								xtype: 'displayfield',
								style: 'margin-left: 5px;',
								value: _S('DOWNLOAD_CENTER', 'INFO_KBS'),
								flex: 1
							}]
						},{
							layout: 'hbox',
							border: false,
							items: [
							maxLimitUploadSpeedText,
							{
								xtype: 'displayfield',
								style: 'margin-left: 5px;',
								value: _S('DOWNLOAD_CENTER', 'INFO_KBS'),
								flex: 1
							}]
						},
						timeprofile
					]
				});

				var searchsiteTab = Ext.create('Ext.form.Panel', {
					cls: 'as-content as-content-top-10',
					title: _S('DOWNLOAD_CENTER', 'INFO_TORRENT_SEARCH_SITE'),
					itemId: 'search-site',
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					autoScroll: true,
					items: [{
						xtype: 'asPanelToolbarTop',
						items:[{
							layout: 'hbox',
							items:[
								btnAddTSS,
								btnEditTSS,
								btnDeleteTSS
							]
						}]
					},
						torrentPanel
					]
				});

				var getAutoExtractSettingsData = function() {
					win.el.mask(_S('COMMON', 'LOADING'));

					var urlOpts = {
						act: 'extract-get'
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'get',
						success: function(json, opts) {
							isEnableAutoExtract = json.enable_auto_extract;
							isEnableAutoDeleteArchives = json.enable_auto_remove_after_complete;
							enableAutoExtract.setValue(isEnableAutoExtract);
							enableAutoDeleteArchiveFiles.setValue(isEnableAutoDeleteArchives);

							isEverSwitchToExtractTab = true;
							initApply = true;
							btnApply.setDisabled(initApply);
							win.el.unmask();
						},
						failure: function(json, opts) {
							isEverSwitchToExtractTab = true;

							win.el.unmask();

							winapp.showErrorMsgWin('extract-get', json, win);
						}
					});
				};

				var setAutoExtractSettings = function() {
					win.el.mask(_S('COMMON', 'APPLYING'));
					isEnableAutoExtract = enableAutoExtract.getValue();
					isEnableAutoDeleteArchives = enableAutoDeleteArchiveFiles.getValue();

					var urlOpts = {
						act: 'extract-set',
						enable_auto_extract: isEnableAutoExtract,
						enable_auto_remove_after_complete: isEnableAutoDeleteArchives
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function(json, opts) {
							if (typeof(win.el) !== 'undefined') {
								win.el.unmask();
							}

							isEverSwitchToExtractTab = false;
							btnApply.setDisabled(true);
						},
						failure: function(json, opts) {
							if (typeof(win.el) !== 'undefined') {
								win.el.unmask();
							}
							btnApply.setDisabled(false);
							winapp.showErrorMsgWin('extract-set', json, winapp.win);
						}
					});
				};

				var getAutoExtractPasswordListData = function() {
					var passwordList = [],
						passwordListTreeNodes = [],
						passwordListWin = winapp.passwordListTree.up().up().up(),
						urlOpts = {
							act: 'extract-get'
						};

					winapp.passwordListTree.el.mask(_S('COMMON', 'LOADING'));

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'get',
						success: function(json, opts) {
							if (json.passwords !== '') {
								passwordList = json.passwords.split(',');
								passwordListTreeNodes = passwordList.map(function(listItem) {
									return {
										id: listItem,
										text: '<span class="node-wrap"><span class="node-wrap__text">' + listItem + '</span><span class="node-wrap__remove-icon status-icon-16 clear"></span></span>',
										qtip: listItem,
										icon: Ext.BLANK_IMAGE_URL,
										leaf: true
									};
								});

								renderPasswordListData(passwordListTreeNodes);
							}

							winapp.passwordListTree.el.unmask();
						},
						failure: function(json, opts) {
							winapp.passwordListTree.el.unmask();

							winapp.showErrorMsgWin('extract-get', json, passwordListWin);
						}
					});
				};

				var renderPasswordListData = function(listTreeNodes) {
					winapp.passwordListTree.setRootNode({
						id: 'root',
						children: listTreeNodes
					});
				};

				var handleAutoExtractPasswords = function(passwordListWin) {
					var passwordList = [],
						passwordListResult = '',
						passwordListNodes = winapp.passwordListTree.getRootNode().childNodes;

					passwordListNodes.forEach(function(node) {
						passwordList.push(node.data.id);
					});

					passwordListResult = passwordList.join(',');

					setAutoExtractPasswordList(passwordListWin, passwordListResult);
				};

				var setAutoExtractPasswordList = function(passwordListWin, passwordList) {
					passwordListWin.el.mask(_S('COMMON', 'APPLYING'));

					var urlOpts = {
						act: 'extract-set',
						passwords: passwordList
					};

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function(json, opts) {
							passwordListWin.el.unmask();
							passwordListWin.close();
						},
						failure: function(json, opts) {
							passwordListWin.el.unmask();
							winapp.showErrorMsgWin('extract-set', json, passwordListWin);
						}
					});
				};

				var setPreferenceApplyButton = function() {
					if (initApply) {
						btnApply.setDisabled(false);
					}
				};

				var enableAutoExtract = Ext.create('Ext.form.field.Checkbox', {
					itemId: 'enableAutoExtract',
					boxLabel: _S('DOWNLOAD_CENTER', 'ENABLE_AUTO_EXTRACT'),
					anchor: '100%',
					style: 'margin: 8px 0px 0px 0px',
					listeners: {
						change: function(me, newValue, oldValue, eOpts) {
							if (newValue) {
								enableAutoDeleteArchiveFiles.setDisabled(false);
								extractPasswordListText.setDisabled(false);
								extractPasswordListButton.setDisabled(false);
							} else {
								enableAutoDeleteArchiveFiles.setDisabled(true);
								extractPasswordListText.setDisabled(true);
								extractPasswordListButton.setDisabled(true);
							}

							setPreferenceApplyButton();
						}
					}
				});

				var enableAutoDeleteArchiveFiles = Ext.create('Ext.form.field.Checkbox', {
					itemId: 'enableAutoDeleteArchiveFiles',
					boxLabel: _S('DOWNLOAD_CENTER', 'DELETE_ARCHIVE_FILES'),
					anchor: '100%',
					style: AS.layout.getIndentCss(1),
					disabled: true,
					listeners: {
						change: function(me, newValue, oldValue, eOpts) {
							setPreferenceApplyButton();
						}
					}
				});

				var extractPasswordListText = Ext.create('Ext.form.field.Display', {
					itemId: 'extractPasswordListText',
					disabled: true,
					style: AS.layout.getIndentCss(1),
					value: _S('DOWNLOAD_CENTER', 'BUILD_UP_PASSWORD_LIST')
				});

				var extractPasswordListButton = Ext.create('Ext.button.Button', {
					itemId: 'extractPasswordListButton',
					text: _S('DOWNLOAD_CENTER', 'PASSWORD_LIST'),
					disabled: true,
					style: 'margin: 0px 0px 0px 30px',
					scope: this,
					listeners: {
						click: function(){
							createPasswordListWindow();
						}
					}
				});

				var autoExtractTab = Ext.create('Ext.form.Panel', {
					cls: 'as-content as-content-top-10',
					title: _S('DOWNLOAD_CENTER', 'AUTO_EXTRACT'),
					itemId: 'autoExtractTab',
					defaults: {
						labelWidth: AS.ARC.config.layout.defaultLabelWidth
					},
					autoScroll: true,
					items: [
						{
							xtype: 'fieldset',
							title: _S('DOWNLOAD_CENTER', 'AUTO_EXTRACT'),
							items: [
								enableAutoExtract,
								enableAutoDeleteArchiveFiles,
								{
									xtype: 'asFlexbox',
									style: 'margin: 8px 0px 0px 0px;',
									items: [
										extractPasswordListText,
										extractPasswordListButton
									]
								}
							]
						}
					]
				});

				var createPasswordListWindow = function() {
					winapp.passwordListTree = Ext.create('Ext.tree.TreePanel', {
						viewConfig: {
							rootVisible: false
						},
						useArrows: true,
						height: 240,
						flex: 1,
						resizable: false,
						scope: this,
						margin: '20 0 0 0',
						listeners: {
							afterrender: function(tree) {
								getAutoExtractPasswordListData();
							},
							itemclick: function(view, record, item, index, e) {
								if (e.target.tagName === 'INPUT') return false;
								if (e.target.classList.contains('node-wrap__remove-icon')) {
									record.remove();
									Ps.update(winapp.passwordListTree.body.dom);
								}
							}
						}
					});

					var addExtractPassword = function(value) {
						if (value === '') return false;

        				winapp.passwordListTree.el.mask(_S('COMMON', 'LOADING'));

        				Ext.defer(function() {
            				winapp.passwordListTree.getRootNode().appendChild({
								id: value,
								text: '<span class="node-wrap"><span class="node-wrap__text">' + value + '</span><span class="node-wrap__remove-icon status-icon-16 clear"></span></span>',
								qtip: value,
								icon: Ext.BLANK_IMAGE_URL,
								leaf: true
            				});
																
            				winapp.passwordListTree.el.unmask();
            				winapp.passwordListTree.body.dom.scrollTop = winapp.passwordListTree.view.el.getHeight() - winapp.passwordListTree.body.getHeight();
        				}, 1000);
					};

					var extractPasswordListWin = Ext.create('AS.ARC.subWindow', {
						parentWin: win,
						title: _S('DOWNLOAD_CENTER', 'PASSWORD_LIST'),
						cls: 'download-center-password-list',
						width: 625,
						height: 480,
						fbar: [
							{
								xtype: 'button',
								text: _S('COMMON', 'OK'),
								handler: function() {
									handleAutoExtractPasswords(extractPasswordListWin);
								}
							}, {
								xtype: 'button',
								text: _S('COMMON', 'CANCEL'),
								handler: function() {
									extractPasswordListWin.close();
								}
							}
						],
						items: [
							{
								xtype: 'asPanelTop10',
								height: 400,
								items: [
									{
										xtype: 'panel',
										cls: 'as-file-extension-filter',
										items: [
											winapp.passwordListTree,
											{
												xtype: 'asFlexbox',
            									margin: '10 0 0 0',
            									height: 28,
            									layout: {
                									type: 'hbox',
                									align: 'stretch'
            									},
												items: [
													{
														xtype: 'textfield',
														itemId: 'passwordInputField',
														flex: 1,
														msgTarget: AS.ARC.config.msgTarget,
														margin: '0 0 0 0',
														maskRe: /[^,]/,
														validator: function(value) {
															if (value === '') {
																return true;
															} else if (value.search(/[,]/) !== -1) {
																return Ext.String.format(_S('MESSAGE', 'HF00028'), "','");
															} else {
																return true;
															}
														},
														listeners: {
															validitychange: function(texfield, isValid) {
																texfield.next().setDisabled(!isValid);
															}
														}
													}, {
														xtype: 'button',
														itemId: 'passwordAddButton',
														cls: 'image-btn',
														margin: '0 0 0 5',
														handler: function(btn) {
															var passwordInputField = btn.prev(),
																passwordInputValue = passwordInputField.getValue();

															passwordInputField.reset();

															addExtractPassword(passwordInputValue);
														}
													}
												]
											}
										]
									}
								]
							}
						]
					}).show();
				};

				var tabPanel = Ext.create('AS.ARC.tabPanel', {
					cls: 'dc-preference-win',
					items: [
						generalTab
					],
					listeners: {
						render: function( com, eOpts) {
							tabType = 'general';
						},
						afterrender: function(tabPanel) {
							if (AS.ARC.user.isAdmin) {
								tabPanel.add(connectionTab, bandwidthTab, scheduleTab, searchsiteTab, autoExtractTab);
							} else {
								tabPanel.add(searchsiteTab, autoExtractTab);
								tabPanel.items.items[0].items.items[0].items.items[0].hide();
								tabPanel.items.items[0].items.items[0].items.items[1].hide();
								tabPanel.items.items[0].items.items[0].items.items[2].hide();
								tabPanel.items.items[0].items.items[0].items.items[3].hide();
							}
						},
						tabchange: function( tabPanel, newCard, oldCard, eOpts ) {
							if (newCard.itemId == 'download-schedule') {
								initApply = false;
								if(SCH_CREATED){
									//getDateStore();
									//UpdateScheduleInfo();
									//ScheduleMouseAction('down', 'continue');
								}else{
									getScheduleData();
								}
							}
							//_D('tabchange:'+newCard.itemId);
							tabType = newCard.itemId;
							if (newCard.itemId != 'connection') {
								btnOk.setDisabled(false);
							} else {
								if (portError) {
									btnOk.setDisabled(true);
								} else {
									btnOk.setDisabled(false);
								}
							}

							if (newCard.itemId == 'search-site') {
								checkGroup.fireEvent('checkchange');
							}

							if (tabType === 'autoExtractTab' && !isEverSwitchToExtractTab) {
								getAutoExtractSettingsData();
							}

							btnApply.setDisabled(true);
						}
					}
				});

				var btnApply = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'APPLY'),
					disabled: true,
					handler: function () {
						doAppClose = false;
						btnApply.setDisabled(true);
						if (tabType == 'general') {
							setGeneral();
						} else if (tabType == 'connection') {
							setConnection();
						} else if (tabType == 'bandwidth') {
							setBandwidth();
						} else if (tabType == 'download-schedule') {
							setDownloadSchedule();
						} else if (tabType == 'search-site') {
							torrentPanel.checkEnableItemEnd = [];
							torrentPanel.setSearchSiteResult = [];
							setSearchSite();
						} else if (tabType === 'autoExtractTab') {
							setAutoExtractSettings();
						}
					}
				});

				var btnOk = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'OK'),
					handler: function () {
						doAppClose = false;
						if (tabType == 'general') {
							setGeneral();
						} else if (tabType == 'connection') {
							setConnection();
						} else if (tabType == 'bandwidth') {
							setBandwidth();
						} else if (tabType == 'download-schedule') {
							setDownloadSchedule();
						} else if (tabType == 'search-site') {
							torrentPanel.checkEnableItemEnd = [];
							torrentPanel.setSearchSiteResult = [];
							setSearchSite();
						} else if (tabType === 'autoExtractTab') {
							setAutoExtractSettings();
						}
						win.close();
					}
				});

				var win = Ext.create('AS.ARC.subWindow',{
					title: _S('DOWNLOAD_CENTER','INFO_PREFERENCES'),
					width: 770,
					height: 620,
					closable: false,
					parentWin: winapp.win,
					fbar: [
					btnApply,
					btnOk,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							if(doAppClose === true) {
								winapp.win.close();
							} else {
								win.close();
							}
						}
					}],
					items: [
					tabPanel
					],
					listeners: {
						render: function ( com, eOpts ) {
							winapp.PREFERENCE_WIN_NUMBER++;
							doActionWin = true;
						},
						beforeclose: function( panel, eOpts ) {
							winapp.PREFERENCE_WIN_NUMBER--;
							doActionWin = false;
						},
						afterrender: function(win, eOpts) {
							getPreferenceData();
						},
						show: function (win, eOpts) {
						    torrentPanel.getStore().load();
						}
					}
				});
				win.show();
			}
			return win;
		};

		//******************************************************** WIN UI ********************************************************************
		//========================================================= PNAEL RENDERER =========================================================
		var searchPanelColumnRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = '',
				name = record.data.query,
				showInfoCharacterCount = 10,
				image = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_history.png',
				iconSearchItemDisplay = '',
				iconSearchKeywordDisplay = '',
				isSearchActionFinish = record.data.finish === 1,
				iconSearchLoadingDisplay = '';

			if (name.length >= 30) {
				showfile = name.substring(0, showInfoCharacterCount)+'...'+name.substring(name.length-showInfoCharacterCount);
				show = showfile;
			} else {
				show = name;
			}

			iconSearchItemDisplay = '<div class="downloadPanelRender-img itemImg" style="background-image:url(' + image + ');"></div>';

			if (isSearchActionFinish) {
				iconSearchKeywordDisplay = '<span class="downloadPanelRender-name search-item-name-finish">' + name + ' (' + record.data.total + ')</span>';
				iconSearchLoadingDisplay = '<div class="search-loading-icon" style="display: none;"></div>';
			} else {
				iconSearchKeywordDisplay = '<span class="downloadPanelRender-name search-item-name">' + name + ' (' + record.data.total + ')</span>';
				iconSearchLoadingDisplay = '<div class="search-loading-icon"></div>';
			}

			result = '<div class="downloadPanelRender">' +
					 iconSearchItemDisplay + iconSearchKeywordDisplay + iconSearchLoadingDisplay +
					 '</div>';
                     
			metaData.tdAttr = 'data-qtip="' + name + ' (' + record.data.total + ')"';
			return result;
		};

		var downloadPanelRender = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = '';
			if (record.data.id === 'inactive') {
				result = '<div class="downloadPanelRender" >' +
						'<div class="downloadPanelRender-img" style="background-image:url('+record.data.icon+');"></div><span class="downloadPanelRender-name download-item-name">'+ value +'</span> <span id="test" class="downloadPanelRender-size-inactive">'+record.data.size+'</span>';
			} else {
				result = '<div class="downloadPanelRender" >' +
					 	'<div class="downloadPanelRender-img" style="background-image:url('+record.data.icon+');"></div><span class="downloadPanelRender-name download-item-name">'+ value +'</span> <span class="downloadPanelRender-size">'+record.data.size+'</span>';
			}
			
			metaData.tdAttr = 'data-qtip="' + value +' ('+record.data.size+') '+'"';
			return result;
		};

		var rssPanelRender = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = '';
			var name = value;
			if (value != 'RSS') {
			    var code = record.data['error-code'];
			    var img;
			    if (code < 0) {
			        img = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_rss.png';
			    } else {
			        img = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_rss.png';
			    }
			    result = '<div class="downloadPanelRender">' +
                         '<div class="downloadPanelRender-img rssitemImg" style="background-image:url('+ img +');"></div><span class="downloadPanelRender-name rss-item-name">'+ name +'</span></div>';
                         
				metaData.tdAttr = 'data-qtip="' + name + '"';
			} else {
				var img = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_rssfeed.png';
				result = '<div class="downloadPanelRender">' +
                         '<div class="downloadPanelRender-img rssitemImg" style="background-image:url(' + img + '); "> </div>' +
						 '<span class="downloadPanelRender-name rss-item-name">' + _S('DOWNLOAD_CENTER', 'INFO_ALL_RSS_FEEDS') + '</span>' +
						 '<div id="rssIcon" style="height:16px; width:16px;background-image:url(../apps/download-center/images/24X24_status_warning.png); display:none;background-size: contain;" ></div>' +
						 '</div>';
			}
			return result;
		};
		var ageRender = function(value, metaData, record, rowIndex, colIndex, store) {
			var year = 0;
			var yearSec = 365 * 24 * 60 * 60;
			var month = 0;
			var monthSec = 30 * 24 * 60 * 60;
			var week = 0;
			var weekSec = 7 * 24 * 60 * 60;
			var day = 0;
			var daySec = 24 * 60 * 60;
			var hour = 0;
			var hourSec = 60 * 60;
			var min = 0;
			var minSec = 60;
			var sec = 0;
			//console.info('value:'+value);
			processValue = value;
			//year
			var info = '';
			var yearInfo= '';
			var monthInfo = '';
			var weekInfo = '';
			var dayInfo = '';
			var hourInfo = '';
			var minInfo= '';
			var secInfo= '';
			if (processValue >= yearSec) {
				year = Math.floor(processValue/yearSec);
				year = year.toFixed(0);
				//_D('year:'+year);
				processValue = processValue - (year * yearSec);
				if (year > 1) {
					yearInfo = year+ ' '+_S('DOWNLOAD_CENTER', 'YEARS');
				} else {
					yearInfo = year + ' '+_S('DOWNLOAD_CENTER', 'YEAR_UNIT');
				}
				info = yearInfo;
			} else {
				//month
				if (processValue >= monthSec) {
					month = Math.floor(processValue/monthSec);
					month = month.toFixed(0);
					processValue = processValue - (month * monthSec);
					//_D('month:'+month);
					if (month > 1) {
						monthInfo = month + ' '+_S('DOWNLOAD_CENTER', 'MONTHS');
					} else {
						monthInfo = month+ ' '+_S('DOWNLOAD_CENTER', 'MONTH');
					}
					info = monthInfo;
				} else {
					//week
					if (processValue >= weekSec) {
						week = Math.floor(processValue/weekSec);
						week = week.toFixed(0);
						processValue = processValue - (week * weekSec);
						//_D('week:'+week);
						if (week > 1) {
							weekInfo = week + ' '+_S('DOWNLOAD_CENTER', 'WEEKS');
						} else {
							weekInfo = week+ ' '+_S('DOWNLOAD_CENTER', 'WEEK');
						}
						info = weekInfo;
					} else {
						//day
						if (processValue >= daySec) {
							day = Math.floor(processValue/daySec);
							day = day.toFixed(0);
							processValue = processValue - (day * daySec);
							//_D('day:'+day);
							if (day > 1) {
								dayInfo = day + ' '+_S('DOWNLOAD_CENTER', 'DAYS');
							} else {
								dayInfo = day+ ' '+_S('DOWNLOAD_CENTER', 'DAY');
							}
							info = dayInfo;
						} else {
							//hour
							if (processValue >= hourSec) {
								hour = Math.floor(processValue/hourSec);
								//_D('hour:'+hour);
								hour = hour.toFixed(0);
								processValue = processValue - (hour * hourSec);
								//_D('hour:'+hour);
								if (hour > 1) {
									hourInfo = hour + ' '+_S('DOWNLOAD_CENTER', 'HOURS');
								} else {
									hourInfo = hour + ' '+_S('DOWNLOAD_CENTER', 'HOUR');
								}
								info = hourInfo;
							} else {
								//min
								if (processValue >= minSec) {
									min = Math.floor(processValue/minSec);
									min = min.toFixed(0);
									processValue = processValue - (min * minSec);
									//_D('min:'+min);
									if (min > 1) {
										minInfo = min + ' '+_S('DOWNLOAD_CENTER', 'MINS');
									} else {
										minInfo = min + ' '+_S('DOWNLOAD_CENTER', 'MIN');
									}
									info = minInfo;
								}
							}
						}
					}
				}
			}
			//console.info('info:'+info);
			return info;
		};
		//========================================================= DOWNLOAD PANEL =========================================================
		var getDownloadStore = function() {
			var img_all = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_all.png';
			var img_downloading = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_download.png';
			var img_completed = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_complete.png';
			var img_active = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_activity.png';
			var img_inactive = '../apps/download-center/images/sidebar_icon/downloadcenter_icon_24x24_inactive.png';
			var myData = [
				[_S('COMMON','ALL'), img_all, 'all', 0],
				[_S('DOWNLOAD_CENTER', 'INFO_DOWNLOADING'), img_downloading, 'downloading', 0],
				[_S('DOWNLOAD_CENTER', 'INFO_COMPLETED'), img_completed, 'completed', 0],
				[_S('DOWNLOAD_CENTER', 'INFO_ACTIVE'), img_active, 'active', 0],
				[_S('DOWNLOAD_CENTER', 'INFO_INACTIVE'), img_inactive, 'inactive', 0]
			];

			var dataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'name'},
					{name: 'icon'},
					{name: 'id'},
					{name: 'size'}
				]
			});

			dataStore.loadData(myData);

			return dataStore;
		};

		var totalDownloadCount = 0;
		var totalCompleteCount = 0;
		var totalActiveCount = 0;
		var totalInactiveCount = 0;
		var totalRecordCount = 0;
		var reloadDownloadStore = function(records) {
			//_D('reloadDownloadStore');
			var img_all = '../apps/download-center/images/list/small_icon_list-01.png';
			var img_downloading = '../apps/download-center/images/list/small_icon_list-02.png';
			var img_completed = '../apps/download-center/images/list/small_icon_list-03.png';
			var img_active = '../apps/download-center/images/list/small_icon_list-04.png';
			var img_inactive = '../apps/download-center/images/list/small_icon_list-05.png';
			var donwloadCount = 0;
			var completeCount = 0;
			var activeCount = 0;
			var inactiveCount = 0;

			if (typeof(records) != 'undefined') {

				if (filterKey == '') {
				    totalDownloadCount = records.totalDownloadCount;
				    totalCompleteCount = records.totalCompleteCount;
				    totalActiveCount = records.totalActiveCount;
				    totalInactiveCount = records.totalInactiveCount;
				    totalRecordCount = records.totalRecordCount;
				}

				var store = downloadPanel.getStore();
				var datas = store.getRange();
				if (store.data !== null) {
					var length = datas.length;
					for(var i=0; i< length; i++) {
						switch(i) {
						    case 0:
						        if (totalRecordCount == 0) {
						            store.getAt(i).set('size', records.totalRecordCount);
						        } else {
						            store.getAt(i).set('size', totalRecordCount);
						        }
								store.getAt(i).commit();
							break;
						    case 1:
						        if (totalDownloadCount == 0) {
						            store.getAt(i).set('size', donwloadCount);
						        } else {
						            store.getAt(i).set('size', totalDownloadCount);
						        }
								store.getAt(i).commit();
							break;
						    case 2:
						        if (totalCompleteCount == 0) {
						            store.getAt(i).set('size', completeCount);
						        } else {
						            store.getAt(i).set('size', totalCompleteCount);
						        }
								store.getAt(i).commit();
							break;
						    case 3:
						        if (totalActiveCount == 0) {
						            store.getAt(i).set('size', activeCount);
						        } else {
						            store.getAt(i).set('size', totalActiveCount);
						        }
								store.getAt(i).commit();
							break;
						    case 4:
						        if (totalInactiveCount == 0) {
						            store.getAt(i).set('size', inactiveCount);
						        } else {
						            store.getAt(i).set('size', totalInactiveCount);
						        }
								store.getAt(i).commit();
							break;
						}
					}
				}


			}
		};

		var focus = winapp.FOCUS_DOWNLOAD;
		var changeFocusCls = function(value, selFocus) {
			if (focus != selFocus) {
				removeAllCls();
				switch(value) {
					case 'download':
					downloadPanel.addCls('focus');
					focus = winapp.FOCUS_DOWNLOAD;
					break;
					case 'search':
					searchPanel.addCls('focus');
					focus = winapp.FOCUS_SEARCH;
					break;
					case 'rss':
					rssPanel.addCls('focus');
					focus = winapp.FOCUS_RSS;
					break;
					case 'bt':
					btPanel.addCls('focus');
					focus = winapp.FOCUS_BT;
					break;
					case 'searchResult':
					searchResultPanel.addCls('focus');
					focus = winapp.FOCUS_SEARCHRESULT;
					break;
					case 'rssFeedGrid':
					rssFeedGridPanel.addCls('focus');
					focus = winapp.FOCUS_RSSFEEDGRID;
					break;
					case 'rssFeedItem':
					rssFeedItemGridPanel.addCls('focus');
					focus = winapp.FOCUS_RSSFEEDITEM;
					break;
				}
			}
		};

		var removeAllCls = function() {
			downloadPanel.removeCls('focus');
			searchPanel.removeCls('focus');
			rssPanel.removeCls('focus');
			btPanel.removeCls('focus');
			searchResultPanel.removeCls('focus');
			rssFeedGridPanel.removeCls('focus');
			rssFeedItemGridPanel.removeCls('focus');
		};
		var selDownloadPanelIndex = 0;
		var goDownloadTypeGrid = function (record, index) {

			selDownloadPanelIndex = index;

			if (typeof(record.data) !== 'undefined') {
				downloadPanelValue = record.data.id;
				settingDownloadStateFilter(downloadPanelValue);
			} else {
				settingDownloadStateFilter();
			}

			winapp.win.el.mask(_S('COMMON', 'LOADING'));
			winapp.selectedType = index;
			reloadBTStore();
			filterBTText.setValue('');
			isFirstOpen = false;

			var layout = mainPanel.getLayout();
			layout.setActiveItem(0);
			var tlayout = toolBarContainer.getLayout();
			tlayout.setActiveItem(winapp.TOOLBAR_INDEX_DOWNLOAD);

			totalDLInfo.show();
			tabPanel.show();

            downloadDeleteImg.addCls('download-disable');
            downloadUpImg.addCls('download-disable');
            downloadDownImg.addCls('download-disable');
            downloadStartImg.addCls('download-disable');
            downloadStopImg.addCls('download-disable');
			changeFocusCls('download', winapp.FOCUS_DOWNLOAD);
		};

		var clearAllTypePanelSelectedIndex = function(type) {
			switch (type) {
				case 'download':
				searchPanel.getSelectionModel().deselectAll();
				rssPanel.getSelectionModel().deselectAll();
				break;
				case 'search':
				downloadPanel.getSelectionModel().deselectAll();
				rssPanel.getSelectionModel().deselectAll();
				break;
				case 'rss':
				downloadPanel.getSelectionModel().deselectAll();
				searchPanel.getSelectionModel().deselectAll();
				break;
			}

		};
		var downloadPanel = Ext.create('Ext.grid.GridPanel', {
			itemId: 'download-grid',
		    cls: 'download',
			hideHeaders: true,
			width: winapp.WESTPANEL_WIDTH,
			height: 170,
			border: false,
			split: true,
			region: 'north',
			store: getDownloadStore(),
			buffered: true,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'auto'}
			},
			scope: this,
			columns: [{
				dataIndex: 'name',
				renderer: downloadPanelRender,
				flex: 1
			}],
			listeners: {
				select: function( view, record, index, eOpts ) {
					if(record.data.size === 0) {
						clearInfoData();
					}
				    clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
				    winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);
					goDownloadTypeGrid(record, index);
					clearAllTypePanelSelectedIndex('download');

					winapp.isNeedToShowSearchResult = false;
					searchIndex = -1;
				},
				afterrender: function(Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				},
				scope: this
			}
		});

		//========================================================= SEARCH PANEL =========================================================
		var searchStore = null;
		var searchIndex = -1;
		var searchRecord;
		var defRecord;
		//run delete search result action
		var doRemoveSearch = function() {
			//console.info('doRemoveSearch');
			winapp.win.el.mask(_S('COMMON', 'APPLYING'));
			var select = searchPanel.getStore().getRange();
			var urlOpts = {
				act: 'torrent-search-delete',
				query: searchRecord.data.query
			};

			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					searchResultPanel.getStore().removeAll();

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, {act: 'torrent-search-index'}),
						method: 'get',
						success: function(json, opts) {
							var isSearchListEmpty = json.items.length === 0;

							if (!isSearchListEmpty) {
								searchIndex = 0;
								winapp.isRemoveToSelectFirstItem = true;
								searchStoreFilter = null;
								searchfilterKey = '';
								createSearchType = true;
								winapp.isChangeSearchKeywordResult = true;
								filterSearchText.setValue('');
								winapp.isChangeSearchKeywordResult = false;
								changeFocusCls('search', winapp.FOCUS_SEARCH);
							} else if (isSearchListEmpty) {
								searchIndex = -1;
								jumpDownlaodAllPanel();
							} else {
								console.error('unexpected action');
							}
		
							updateSearchKeyList();
							removeSearchData(searchRecord.data.query);
							Ps.update(searchResultPanel.body.dom);
						},
						failure: function(json, opts) {
							winapp.showErrorMsgWin('torrent-search-index', json, winapp.win);
						}
					});
				},
				failure: function (json, opts) {
				    if (typeof(winapp.win) != 'undefined') {
				        if (typeof(winapp.win.el) != 'undefined') {
				            winapp.win.el.unmask();
				        }
				    }
					winapp.showErrorMsgWin('torrent-search-delete', json, winapp.win);
				}
			});
		};

		//create search panel context menu
		var searchPanelContextMenu = Ext.create('Ext.menu.Menu', {
			scope: this,
			items: [{
				text: _S('COMMON','DELETE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'delete.png'),
				handler: function() {
					openDeleteConfirmWin(winapp.CONFIRM_TYPE_SEARCH_PANEL);
				}
			}]
		});

		var createSearchStore = function() {
			var urlOpts = {
				act: 'torrent-search-index'
			};

			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
                autoLoad: false,
				fields: [
					'query', 'finish', 'search_id', 'total'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items'
					}
				},
				listeners: {
					load: function( store, records, successful, operation, eOpts ) {
						if (typeof(records) != 'undefined') {
							if (records.length != 0) {
								defRecord = records[0];
							}

							var initData = function(records) {
								var length = records.length;
								HistoryData = [];
								for (var i=0; i< length; i++) {
									var item = {
										query: records[i].data.query,
										sort: searchSort,
										order: searchOrder
									};
									HistoryData.push(item);
								}
							};
							initData(records);

							updateSearchKeyList(undefined, function() {
								var TEN_SECOND = 10 * 1000;
								setTimeout(function startPolling() {
									if (winapp.app.win.isDestroyed) {
										return false;
									}
									records.forEach(function(item, index) {
										if (item.data.finish === 0) {
											reloadSearchResultStore(item.data.search_id, item.data.query);
										}
									});
								}, TEN_SECOND);
							});
						}

						Ps.update(searchPanel.body.dom);
					}
				}
			});
			return listStore;
		};

		var reCreateSearchType = function() {
			searchType = Ext.create(Ext.form.ComboBox, {
				width: 200,
				queryMode: 'local',

				margin: '2, 10, 0, 0',
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						[_S('COMMON', 'ALL_CATEGORIES'), 'all']
					]
				}),
				displayField: 'display',
				valueField: 'value',
				editable: false,
				scope: this,
				listeners: {
					render: function (combo, eOpts) {
						this.select('all');
					},
					change: function(field, newValue, oldValue, eOpts) {
						winapp.isInitSearchTypeComboBox = false;

						if (typeof(oldValue) !== 'undefined') {
							if (field.getValue() === 'all') {
								winapp.isRefreshResultPanel = true;
								winapp.isNeedToReloadSearchResultPagingBar = true;
								reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
							} else {
								winapp.isRefreshResultPanel = true;
								winapp.isNeedToReloadSearchResultPagingBar = true;
								reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
							}
						}
					}
				}
			});
			searchCategoryContainer.removeAll();
			searchCategoryContainer.add(searchType);
		};
		var updateSearchKeyList = function(searchKeyword, callback, updateSearchId) {
			var urlOpts = {
				act: 'torrent-search-index'
			};

			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
			    autoLoad: false,
				fields: [
					'query', 'finish', 'search_id', 'total'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items'
					}
				},
				listeners: {
					load: function(store, records, successful, operation, eOpts) {
						searchPanel.bindStore(store);
						if (!Ext.isEmpty(searchKeyword)) {
							insertSearchRecord(searchKeyword);
							(function adjustSearchIndex() {
								searchIndex = HistoryData.length - 1;
							})();
						}

						if (!Ext.isEmpty(updateSearchId)) {
							winapp.currentUpdateSearchId = updateSearchId;
						}

						if (records.length !== 0) {
							if (searchIndex !== -1 && searchIndex < records.length) {
								searchPanel.getSelectionModel().select(searchIndex);
							}
						}
					}
				}
			});
			listStore.load({
				callback: function(records, operation, success) {
					Ext.callback(callback);
					Ps.update(searchPanel.body.dom);
					if (records.length === 0) {
						searchResultPanel.getStore().removeAll();
					}
					var selectedRecord = searchPanel.store.findRecord('query', searchKeyword, 0, false, true, true);
					(function scrollToSearchRecord() {
						if (!Ext.isEmpty(selectedRecord)) {
							var node = searchPanel.view.getNode(selectedRecord);
							if (!Ext.isEmpty(node)) {
								searchPanel.el.dom.querySelector('.x-panel-body').scrollTop = node.offsetTop;
							}
						} else if (searchIndex === 0) {
							searchPanel.el.dom.querySelector('.x-panel-body').scrollTop = 0;
						}
						Ps.update(searchPanel.body.dom);
					})();
				}
			});
		}

		var useGridIndexToMoveScrollBar = function (index, targetPanel) {
		    targetPanel.view.getEl().dom.scrollTop = winapp.scrollTop;
		};
		var showSearchResultPanel = function(search_id, key) {
			winapp.isRefreshResultPanel = true;
			// winapp.isNeedToReloadSearchResultPagingBar = true;
			reloadSearchResultStore(search_id, key);

			searchDownloadImg.addCls('download-disable');
			searchOpenImg.addCls('download-disable');

			var tlayout = toolBarContainer.getLayout();
			tlayout.setActiveItem(winapp.TOOLBAR_INDEX_SEARCH);
			var layout = mainPanel.getLayout();
			layout.setActiveItem(winapp.INDEX_SEARCH_RESULT);
		};
		var createSearchType = false;
		var doChangflow = false;
		//create west middle search result panel
		var searchPanel = Ext.create('DownloadCenter.gridPanel', {
		    itemId: 'search-grid',
            cls: 'download download-center-search-grid',
			autoScroll: true,
			border: false,
			split: true,
			minHeight: 138,
			store: createSearchStore(),
			buffered: true,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			hideHeaders: true,
			columns: [{
				dataIndex: 'query',
				renderer: searchPanelColumnRenderer,
				flex: 1
			}],
			listeners: {
				selectionchange: function(model, selected, eOpts)	{
					if (selected.length === 0) {
						return false;
					}

					winapp.isNeedToShowSearchResult = false;
					searchStoreFilter = null;
					searchfilterKey = '';
					changeFocusCls('search', winapp.FOCUS_SEARCH);
				},
				itemcontextmenu : function(grid, record, item, index, event) {
					event.stopEvent();
					x = event.browserEvent.clientX;
					y = event.browserEvent.clientY;
					searchPanelContextMenu.showAt([x, y]);
					searchIndex = index;
					searchRecord = record;

					winapp.isRefreshResultPanel = true;
					winapp.isNeedToReloadSearchResultPagingBar = true;
					winapp.isInitSearchTypeComboBox = true;

					grid.getSelectionModel().select(record);
					showSearchResultPanel(record.data.search_id, record.data.query);

					changeFocusCls('search', winapp.FOCUS_SEARCH);
				},
				select: function (view, record, index, eOpts) {
					if (searchIndex !== index) {
						winapp.isNeedToReloadSearchResultPagingBar = true;
						searchResultPanel.el.unmask();
						winapp.win.el.mask(_S('COMMON', 'LOADING'));

						winapp.isRefreshResultPanel = true;
						winapp.isInitSearchTypeComboBox = true;

						winapp.isChangeSearchKeywordResult = true;
						filterSearchText.setValue('');
						winapp.isChangeSearchKeywordResult = false;

						showSearchResultPanel(record.data.search_id, record.data.query);
					} else {
						if (winapp.isRemoveToSelectFirstItem === true) {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							winapp.isInitSearchTypeComboBox = true;
							showSearchResultPanel(record.data.search_id, record.data.query);

							searchRecord = record;
							winapp.isRemoveToSelectFirstItem = false;
							return true;
						}

						if (record.data.total === 0) {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							winapp.isInitSearchTypeComboBox = true;
							showSearchResultPanel(record.data.search_id, record.data.query);
						} else {
							if (record.data.search_id === winapp.currentUpdateSearchId) {
								winapp.isRefreshResultPanel = true;
								winapp.isNeedToReloadSearchResultPagingBar = true;
								winapp.isInitSearchTypeComboBox = true;

								winapp.isChangeSearchKeywordResult = true;
								filterSearchText.setValue('');
								winapp.isChangeSearchKeywordResult = false;

								showSearchResultPanel(record.data.search_id, record.data.query);
							}
						}
					}
					clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
				
					searchRecord = record;
					searchIndex = index;
					clearAllTypePanelSelectedIndex('search');

					winapp.delayWindowUnmask(0.8);
				},
				beforeshow: function (com, eOpts) {
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});

		var myData = [];
		var myDataSearchIds = [];
		var canSearch = false;
		var searchKey = Ext.create('Ext.form.field.Text', {
            cls: 'searchKey',
			vtype: 'downloadText',
			msgTarget: AS.ARC.config.msgTarget,
			emptyText : _S('DOWNLOAD_CENTER','INFO_TORRENT_SEARCH'),
			listeners: {
                focus: function(field, eOpts) {
                    searchImg.el.dom.classList.add('search-focused');

					searchImg.el.dom.classList.remove('search-keyword-empty');
					searchImg.el.dom.classList.remove('search-keyword-not-empty');
				},
                blur: function(field){
                    searchImg.el.dom.classList.remove('search-focused');

					if (searchKey.getValue() !== '') {
						searchImg.el.dom.classList.add('search-keyword-not-empty');
						searchImg.el.dom.classList.remove('search-keyword-empty');
					} else {
						searchImg.el.dom.classList.add('search-keyword-empty');
						searchImg.el.dom.classList.remove('search-keyword-not-empty');
					}
                },
			    validitychange: function (field, isValid, eOpts) {
			        if (isValid) {
			            canSearch = true;
			        } else {
			            canSearch = false;
			        }
			    },
                specialkey: function(field, e){
                    // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                    // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                    if (e.getKey() == e.ENTER) {
						if (canSearch) {
						    goSearch();
						}
                    }
                }
			}
		});

		var numberRender = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = AS.ARC.datas.defaultValue;

			if (value >= 0) {
				result = value;
			}

			return result;
		};

		var sizeRender = function(value, metaData, record, rowIndex, colIndex, store) {
			var BTSize = value;

			if (BTSize === '-1') {
				BTSize = AS.ARC.datas.defaultValue;
			}

			return BTSize;
		};
		var rssSizeRender = function (value, metaData, record, rowIndex, colIndex, store) {
		    return record.data.isize;
		};
		var sizeUnitRender = function(value, metaData, record, rowIndex, colIndex, store) {
			return AS.ARC.util.convertSizeUnit(record.data.file_isize);
			// return value;
		}
		//define use click search result's data row
		var searchRecord;
	    //use search data url to add torrent
		var doAddUrl = false;
		var addUrlToOpenTorrentInfo = function(url, title, magnet) {
			if (url != null) {
			    doAddUrl = true;

				winapp.win.el.mask(_S('DOWNLOAD_CENTER', 'WAIT_GET_FILES'));
				var urlOpts = {
					act: 'torrent-add-url',
					url: url,
					title: title
				};

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						if (winapp.isAddRSSItemUrlAction) {
							winapp.isAddRSSItemUrlAction = false;
						}

						if (json.files) {
							openAddTorrentInfoWindow(json);
						} else {
							openAddTorrentInfoNoFileDataWindow(json);
						}
					},
					failure: function (json, opts) {
						if (winapp.isAddRSSItemUrlAction) {
							winapp.isAddRSSItemUrlAction = false;
						}
						
					    if(json.error_code === 5040) {
							openAddTorrentInfoWindow(json, '', magnet);
						} else {
							if (typeof(winapp.win) != 'undefined') {
								if (typeof(winapp.win.el) != 'undefined') {
									winapp.win.el.unmask();
								}
							}
							doAddUrl = false;
							createErrorMsgWin(json, winapp.win);
						}
					}
				});
			}
		};
		var tempMultiSearchTorrentSelect = null;
		var doMultiSearchTorrentIndex = 0;
		var doMultiSelectAction = false;
		var doMultiSearchType = '';
		var checkRunAddUrlOpenTorrentInfo = function(type) {
			if (doMultiSearchTorrentIndex <= (tempMultiSearchTorrentSelect.length-1)) {
				var item = tempMultiSearchTorrentSelect[doMultiSearchTorrentIndex];
				if (type == 'search') {
					addUrlToOpenTorrentInfo(item.data.torrent, item.data.title);
				} else {
					addUrlToOpenTorrentInfo(item.data.url, item.data.title);
				}
			} else {
			    doMultiSelectAction = false;
				if (winapp.isAddMultiRSSItemUrlAction) {
					winapp.isAddMultiRSSItemUrlAction = false;
				}

			    if (typeof(winapp.win) != 'undefined') {
			        if (typeof(winapp.win.el) != 'undefined') {
			            winapp.win.el.unmask();
			        }
			    }
			}
		};
		var checkRunOpenWindow = function(panel) {
			var select = panel.getSelectionModel().getSelection();
			var length = select.length;
			if (length == 1) {
				openWindow(select[0].data.link, select[0].data.title);
			} else {
				for (var i=0; i< length; i++) {
					var item = select[i];
					openWindow(item.data.link, item.data.title);
				}
			}
		};
		var checkRunSelectOpenTorrentInfo = function(panel, type, record) {
			var select = panel.getSelectionModel().getSelection();
			var length = select.length;
			doMultiSearchType = type;
			if (length == 1) {
				doMultiSelectAction = false;
				if (type == 'search') {
					addUrlToOpenTorrentInfo(record.data.torrent, record.data.title, record.data.magnet);
				} else {
					addUrlToOpenTorrentInfo(record.data.url, record.data.title);
				}
			} else {
				tempMultiSearchTorrentSelect = select;
				doMultiSearchTorrentIndex = 0;
				doMultiSelectAction = true;
				checkRunAddUrlOpenTorrentInfo(type);
			}
		}
		var checkStatusFromDoMultiSelectAction = function () {
		    if (doMultiSelectAction) {
		        doMultiSearchTorrentIndex++;
		        checkRunAddUrlOpenTorrentInfo(doMultiSearchType);
		    }
		};
		var searchResultContextMenu = Ext.create('Ext.menu.Menu', {
			scope: this,
			items: [{
				text: _S('COMMON','DOWNLOAD'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'download.png'),
				handler: function() {
					checkRunSelectOpenTorrentInfo(searchResultPanel, 'search', searchResultRecord);
				}
			},{
				text: _S('DOWNLOAD_CENTER','MENU_OPEN'),
				itemId: 'menuOpenInSearchResult',
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'open_window.png'),
				handler: function() {
					checkRunOpenWindow(searchResultPanel);
				}
			}],
			listeners: {
				beforeshow: function() {
					var isMagnetTypeLink = searchResultRecord.data.link.indexOf('magnet:') !== -1;
					
					if (isMagnetTypeLink) {
						searchResultContextMenu.down('#menuOpenInSearchResult').hide();
					} else {
						searchResultContextMenu.down('#menuOpenInSearchResult').show();
					}
				}
			}
		});

		var colTitle = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'title',
			text: _S('COMMON','NAME'),
			width: 250,
			renderer: fileOfTorrentRenderer
		});
		var colCategory = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'category',
			text: _S('DOWNLOAD_CENTER','COLUMN_CATEGORY'),
			//flex: 0,
			width: 70
		});
		var colSize = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'size',
			text: _S('COMMON','SIZE'),
			//flex: 0,
			width: 70,
			renderer: sizeRender
		});
		var colSeed = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'seeds',
			text: _S('COMMON','SEED'),
			//flex: 0,
			width: 50,
			renderer: numberRender
		});
		var colPeer = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'peers',
			text: _S('COMMON','PEER'),
			//flex: 0,
			width: 50,
			renderer: numberRender
		});
		var colAge = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'age',
			text: _S('DOWNLOAD_CENTER','COLUMN_AGE'),
			//flex: 0,
			width: 70,
			renderer: ageRender
		});
		var colSite = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'site',
			text: _S('DOWNLOAD_CENTER','COLUMN_SEARCH_SITE'),
			//flex: 0,
			width:150
		});
		var colLink = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'link',
			text: _S('COMMON','LINK'),
			//flex: 1,
			hidden: true
		});
		var colHash = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'hash',
			text: _S('DOWNLOAD_CENTER','COLUMN_HASH'),
			//flex: 1,
			hidden: true
		});
		var colTorrent = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'torrent',
			text: _S('DOWNLOAD_CENTER','COLUMN_TORRENT'),
			//flex: 1,
			hidden: true
		});

		var searchResultRecord = null;
		var searchResultPanel = Ext.create('DownloadCenter.gridPanel', {
			itemId: 'search-content',
            cls: 'center-grid',
			autoScroll: true,
			buffered: true,
			multiSelect: true,
			flex:2,
			border: false,
			scope: this,
			forceFit: true,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			columns: [
				colTitle,
				colCategory,
				colSize,
				colSeed,
				colPeer,
				colAge,
				colSite,
				colLink,
				colHash,
				colTorrent
			],
			bbar: Ext.create('AS.ARC.pagingToolbar', {
				border: false,
				listeners: {
					beforechange: function() {
						winapp.isRefreshResultPanel = true;

						winapp.win.el.mask(_S('COMMON', 'LOADING'));
						
					},
					change: function(pagingbar, pageData, eOpts) {
						winapp.delayWindowUnmask(0.1);
						Ps.update(searchResultPanel.body.dom);
					}
				}
			}),
			listeners: {
				itemcontextmenu : function(grid, record, item, index, event) {
					event.stopEvent();
					x = event.browserEvent.clientX;
					y = event.browserEvent.clientY;
					searchResultRecord = record;
					searchResultContextMenu.showAt([x, y]);
					changeFocusCls('searchResult', winapp.FOCUS_SEARCHRESULT);
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					searchResultPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					searchResultPanel.setSpecialKey(false);
				},
				select: function( view, record, index, eOpts ) {
					searchResultRecord = record;
					searchOpenImg.removeCls('download-disable');
					searchDownloadImg.removeCls('download-disable');
					changeFocusCls('searchResult', winapp.FOCUS_SEARCHRESULT);

				},
				itemdblclick: function ( view, record, item, index,  e, eOpts ) {
					searchResultRecord = record;

					addUrlToOpenTorrentInfo(searchResultRecord.data.torrent, searchResultRecord.data.title, searchResultRecord.data.magnet);

					changeFocusCls('searchResult', winapp.FOCUS_SEARCHRESULT);

				},
				sortchange: function ( ct, column, direction, eOpts ) {

					searchSort = column.dataIndex;
					if (direction == null) {

					} else {
						searchOrder = direction.toLowerCase();
						changeSearchData(searchSort, searchOrder);

						if (searchType.getValue() != 'all') {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						} else {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						}
					}
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});

		winapp.btSearchResultShowCountButton = Ext.create('Ext.button.Button', {
			text: winapp.btSearchResultShowCount,
			menu: [
				{
					text: '10',
					checked: false,
					group: 'btSearchResultShowSize',
					handler: function() {
						winapp.isRefreshResultPanel = true;
						winapp.btSearchResultShowCount = 10;
						searchResultPanel.store.pageSize = 10;
						searchResultPanel.store.loadPage(1);
					},
					listeners: {
						click: function(button, event) {
							winapp.btSearchResultShowCountButton.setText(winapp.btSearchResultShowCount);
						}
					}
				}, {
					text: '30',
					checked: true,
					group: 'btSearchResultShowSize',
					handler: function() {
						winapp.isRefreshResultPanel = true;
						winapp.btSearchResultShowCount = 30;
						searchResultPanel.store.pageSize = 30;
						searchResultPanel.store.loadPage(1);
					},
					listeners: {
						click: function(button, event) {
							winapp.btSearchResultShowCountButton.setText(winapp.btSearchResultShowCount);
						}
					}
				}, {
					text: '50',
					checked: false,
					group: 'btSearchResultShowSize',
					handler: function() {
						winapp.isRefreshResultPanel = true;
						winapp.btSearchResultShowCount = 50;
						searchResultPanel.store.pageSize = 50;
						searchResultPanel.store.loadPage(1);
					},
					listeners: {
						click: function(button, event) {
							winapp.btSearchResultShowCountButton.setText(winapp.btSearchResultShowCount);
						}
					}
				}, {
					text: '100',
					checked: false,
					group: 'btSearchResultShowSize',
					handler: function() {
						winapp.isRefreshResultPanel = true;
						winapp.btSearchResultShowCount = 100;
						searchResultPanel.store.pageSize = 100;
						searchResultPanel.store.loadPage(1);
					},
					listeners: {
						click: function(button, event) {
							winapp.btSearchResultShowCountButton.setText(winapp.btSearchResultShowCount);
						}
					}
				}
			]
		});

		searchResultPanel.dockedItems.getAt(1).add(
			'-',
			{
				xtype: 'tbtext',
				text: _S('COMMON', 'SHOW'),
				margin: '0 0 0 2',
			},
			winapp.btSearchResultShowCountButton,
			{
				xtype: 'tbtext',
				text: _S('COMMON', 'LOW_ITEMS'),
				margin: '0 10 0 2',
			}
		);

		var testKey = '';
		var searchSort= 'seeds';
		var searchOrder = 'desc';
		var doSearchSite = false;
		var reloadSearchResultStore = function(search_id, key, categoryValue, filterValue) {
			if (winapp.app.win.isDestroyed) {
				return false;
			}
			if (Ext.isEmpty(searchPanel.store.data)) {
				return false;
			}
			var isKeyExist = false;
			searchPanel.store.data.items.forEach(function(item, index) {
				if (item.data.query === key) {
					isKeyExist = true;
				}
			});
			if (isKeyExist === false) {
				console.error('search key not found');
				updateSearchKeyList();
				return false;
			}

			var urlOpts = {
				act: 'torrent-search-response',
				query: key,
				search_id: search_id,
				sortby: searchSort,
				orderby: 'desc'
			};
			urlOpts = getSearchData(urlOpts, key);

			if (typeof categoryValue !== 'undefined') {
				var option = {
					category: categoryValue
				};

				urlOpts = Ext.apply(urlOpts, option);
			}

			if (typeof filterValue !== 'undefined') {
				var option = {
					filter: filterValue
				};
				
				urlOpts = Ext.apply(urlOpts, option);
			}

			// JN: torrent search panel
			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoLoad: false,
				pageSize: winapp.btSearchResultShowCount,
				fields: ['category', 'date', 'hash', 'link', 'peers', 'seeds', 'site', 'size', 'title', 'torrent', 'age', 'magnet'],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items'
					}
				},
				listeners: {
					load: function( store, records, successful, operation, eOpts ) {
						if (winapp.app.win.isDestroyed) {
							return false;
						}

						var json = store.getProxy().reader.jsonData;


						if (!json.success) {
							winapp.isRefreshResultPanel = false;
							searchResultPanel.store.removeAll();
							winapp.win.el.unmask();
							var isShowErrorMsgWindowOpen = Ext.isEmpty(winapp.errorMsgWindow) || !winapp.errorMsgWindow.isVisible()
							if (isShowErrorMsgWindowOpen) {
								winapp.showErrorMsgWin('torrent-search-response', json, winapp.win, 'warning', function() {
									searchIndex = -1;
									searchResultPanel.store.removeAll();
									searchPanel.store.removeAll();
									updateSearchKeyList(undefined, function() {
										var TEN_SECOND = 10 * 1000;
										setTimeout(function startPolling() {
											if (winapp.app.win.isDestroyed) {
												return false;
											}
											searchPanel.store.data.items.forEach(function(item, index) {
												if (item.data.finish === 0) {
													reloadSearchResultStore(item.data.search_id, item.data.query);
												}
											});
										}, TEN_SECOND);
									});
								});
							}
						
							return;
						}

						if (winapp.isMainWindowClosed) {
							return;
						}

						if (!winapp.isRefreshResultPanel) {
						    if (store.getProxy().reader.jsonData.finish) {
								updateSearchKeyList(undefined, function() {

								}, search_id);

								if (typeof(searchRecord) !== 'undefined') {
									if (key === searchRecord.data.query) {
										initSearchType(key);
									}
								}

								doSearchSite = false;
								searchKey.setDisabled(false);
							} else {
								if (winapp.isNeedToShowSearchResult) {
									var tlayout = toolBarContainer.getLayout();
									tlayout.setActiveItem(winapp.TOOLBAR_INDEX_SEARCH);
									var layout = mainPanel.getLayout();
									layout.setActiveItem(winapp.INDEX_SEARCH_RESULT);
								}

								var pollingRecord = searchPanel.store.findRecord('query', json.query, 0, false, true, true);
								if (!Ext.isEmpty(pollingRecord)) {
									if (pollingRecord.data.total !== json.total) {
										updateSearchKeyList(undefined, function() {

										}, pollingRecord.data.search_id);
									}
								}

								setTimeout(function() {
									reloadSearchResultStore(search_id, key);
								}, winapp.BT_SEARCH_TIME_INTERVAL);
							}
						} else {
							winapp.isRefreshResultPanel = false;
							searchResultPanel.bindStore(store);
							if (winapp.isInitSearchTypeComboBox === true) {
								initSearchType(key);
							}
						}

						if (doChangflow) {
							doChangflow = false;
						}
					}
				}
			});

			if (searchStoreFilter != null) {
				listStore.filter(searchStoreFilter);
			}

			if (winapp.isNeedToReloadSearchResultPagingBar) {
				searchResultPanel.dockedItems.getAt(1).bindStore(listStore);
			}

			listStore.load({
				callback: function() {
					Ps.update(searchResultPanel.body.dom);

					var json = searchResultPanel.store.getProxy().reader.jsonData;
					if (Ext.isEmpty(json)) {
						return false;
					}
					var pollingRecord = searchPanel.store.findRecord('query', json.query, 0, false, true, true);
					if (!Ext.isEmpty(pollingRecord)) {
						if (json.total !== 0 || json.finish) {
							winapp.isNeedToReloadSearchResultPagingBar = false;
							searchResultPanel.el.unmask();
						}
					}
				}
			});
		};

		var goSearch = function() {
			winapp.isNeedToReloadSearchResultStore = true;
			winapp.isNeedToReloadSearchResultPagingBar = true;
			var keyword = searchKey.getValue().trim();

			winapp.isChangeSearchKeywordResult = true;
			filterSearchText.setValue('');
			winapp.isChangeSearchKeywordResult = false;

			var searchExistKeyword = function() {
				//refresh search
				var urlOpts = {
					act: 'torrent-search-delete',
					query: keyword
				};

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						searchStoreFilter = null;
						searchfilterKey = '';
						createSearchType = true;

						doSearchSite = true;
						var urlOpts = {
							act: 'torrent-search-request',
							query: keyword
						};

						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								updateSearchKeyList(keyword, function() {
									searchResultPanel.getStore().removeAll();
									showSearchResultPanel(json.search_id, keyword);
									searchResultPanel.el.mask(_S('DOWNLOAD_CENTER', 'INFO_SEARCHING'));
								});
							},
							failure: function (json, opts) {
								searchKey.setDisabled(false);
								if (typeof(winapp.win) != 'undefined') {
									if (typeof(winapp.win.el) != 'undefined') {
										winapp.win.el.unmask();
									}
								}
								winapp.showErrorMsgWin('torrent-search-request', json, winapp.win);
							}
						});
						searchKey.setValue('');
					},
					failure: function (json, opts) {

						if (typeof(winapp.win) != 'undefined') {
							if (typeof(winapp.win.el) != 'undefined') {
								winapp.win.el.unmask();
							}
						}
						winapp.showErrorMsgWin('torrent-search-delete', json, winapp.win);
					}
				});
			};

			var searchNewKeyword = function() {
				doSearchSite = true;
				var urlOpts = {
					act: 'torrent-search-request',
					query: keyword
				};

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						updateSearchKeyList(keyword, function() {
							searchResultPanel.getStore().removeAll();
							showSearchResultPanel(json.search_id, keyword);
							searchResultPanel.el.mask(_S('DOWNLOAD_CENTER', 'INFO_SEARCHING'));
						});
					},
					failure: function (json, opts) {
						searchKey.setDisabled(false);
						if (typeof(winapp.win) != 'undefined') {
							if (typeof(winapp.win.el) != 'undefined') {
								winapp.win.el.unmask();
							}
						}
						winapp.showErrorMsgWin('torrent-search-request', json, winapp.win);
					}
				});
				searchKey.setValue('');
			};
			
			if (keyword !== '') {
				console.info(_S('DOWNLOAD_CENTER', 'INFO_SEARCHING'));
			    //check HistoryData
			    var findInCurrentSearchGrid = false;
			    for (var i = 0; i < HistoryData.length; i++) {
			        var data = HistoryData[i];
			        if (keyword == data.query) {
			            findInCurrentSearchGrid = true;
			            break;
			        }
			    }
			    if (findInCurrentSearchGrid) {
					searchExistKeyword();
			    } else {
					searchNewKeyword();
				}
				searchKey.blur();
			} else {
				console.error('keyword not found')
			}
		};

		var getImgBtn = function(imgfile) {
			var title = Ext.String.format('<div style="float:left;border:0;margin:0;padding:0;position:absolute;left:0px;top:0px;width:27px;height:27px;background-image:url({0}{1});"></div>', '../apps/download-center/images/', imgfile);

			return title;
		};

		var searchBtn = Ext.create('Ext.button.Button', {
			text: getImgBtn('search.jpg'),
			itemId: 'search-btn',
			width: 32,
			height:32,
			scope: this,
			listeners: {
				click: function( btn, e, eOpts ) {
					goSearch();
				},
				mouseover: function( btn, e, eOpts ) {

				},
				mouseout: function( btn, e, eOpts ) {

				}
			}
		});

		//========================================================= RSS PANEL =========================================================
		var rssRecord;
		var rssIndex = 0;
		var rssImg = '../apps/download-center/images/feed_add.png';
		var rssData = [
				['RSS', rssImg, rssImg]
			];

		var getRSSStore = function() {

			var dataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'name'},
					{name: 'url'},
					{name: 'icon'}
				]
			});

			dataStore.loadData(rssData);

			return dataStore;
		}
		var isInitrssPanel = false;
		var rssFeedItemGridPanel;
		var createRSSFeedStore = function(flag) {
			var urlOpts = {
				act: 'rss-feed-list'
			};

			//grid store
			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
                autoLoad: false,
				fields: [
					'id', 'title', 'url', 'username', 'last_update', 'is_updating', 'error-code', 'update_interval'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items',
                        idProperty: 'dip'
					}
				}
			});

			if (flag) {
				//use filter
				var filters = [
					new Ext.util.Filter({
						filterFn: function(item){
							return item.get('id') != -1;
					  }
					})
				];
				listStore.filter(filters);
			} else {
				//not use filter
			}

			return listStore;
		};

		var jumpDownlaodAllPanel = function () {

			settingDownloadStateFilter();

			winapp.win.el.mask(_S('COMMON', 'LOADING'));
			reloadBTStore();
			filterBTText.setValue('');

			var layout = mainPanel.getLayout();
			layout.setActiveItem(0);
			var tlayout = toolBarContainer.getLayout();
			tlayout.setActiveItem(winapp.TOOLBAR_INDEX_DOWNLOAD);
			totalDLInfo.show();
			tabPanel.show();

			downloadPanel.getSelectionModel().select(0);
            
            downloadDeleteImg.addCls('download-disable');
            downloadUpImg.addCls('download-disable');
            downloadDownImg.addCls('download-disable');
            downloadStartImg.addCls('download-disable');
            downloadStopImg.addCls('download-disable');
		};
		var reloadRSSFeedStore = function() {
			var urlOpts = {
				act: 'rss-feed-list'
			};

			//grid store
			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
			    autoLoad: false,
				fields: [
					'id', 'title', 'url', 'username', 'last_update', 'is_updating', 'error-code', 'update_interval'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items'
					}
				},
				listeners: {
					load: function( store, records, successful, operation, eOpts ) {
					    var isCorrectTitle = false;
						for(var i = 1; i < records.length; i++) {
							if(records[i].data.title.indexOf('http') !== -1) {
								isCorrectTitle = true;
							}
						}
						rssPanel.bindStore(store);
					    if (records.length != 1) {
					        if (rssIndex < records.length) {
					            rssPanel.getSelectionModel().select(rssIndex);
					        } else {
					            rssPanel.getSelectionModel().select(0);
					        }

					        if (runRssRemoveAction) {
							    rssPanel.getSelectionModel().select(0);
								var layout = mainPanel.getLayout();
								layout.setActiveItem(winapp.INDEX_RSS_FEEDGRID_PANEL);
								reloadRssItemGridStore();
								runRssRemoveAction = false;
							} else {
							    reloadRssItemGridStore();
							}
						} else {
							jumpDownlaodAllPanel();
						}
					}
				}
			});
			listStore.load();
		};

		var reloadRSSFeedGridtStore = function() {
			var urlOpts = {
				act: 'rss-feed-list'
			};

			//grid store
			var listStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
			    autoLoad: false,
				fields: [
					'id', 'title', 'url', 'username', 'last_update', 'is_updating', 'error-code', 'update_interval'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items'
					}
				},
				listeners: {
					load: function( store, records, successful, operation, eOpts ) {
					    var titleArray = [],
							isCorrectTitle = false;
						for(var i = 1; i < records.length; i++) {
							titleArray = records[i].data.title;
							if(records[i].data.title.indexOf('http') !== -1) {
								isCorrectTitle = true;
							}
						}
						rssFeedGridPanel.bindStore(store);
						
					    if (typeof(rssFeedGridPanel) != 'undefined') {
					        if (typeof(rssFeedGridPanel.el) != 'undefined') {
					            rssFeedGridPanel.el.unmask();
					        }
					    }
						if(document.getElementById('rssIcon').style.display === 'inline-block') {
							winapp.win.el.mask();
							var win = new AS.ARC.msgWindow({
								title: _S('COMMON','ERROR'),
								parentWin: winapp.win,
								scope: this,
								iconType: 'warning',
								fbar: [{
									text: _S('COMMON', 'OK'),
									handler: function(){
										win.close();
									}
								}],
								asItems: [{
									xtype: 'displayfield',
									value: Ext.String.format(_S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_RSS_SETTING'), _S('DOWNLOAD_CENTER', 'TITLE_FILTER_MANAGER'))
								}]
							});
							win.show();
						}
					}
				}
			});
		    //use filter
			var filters = [
				new Ext.util.Filter({
				    filterFn: function (item) {
				        return item.get('id') != -1;
				    }
				})
			];
			listStore.filter(filters);
			listStore.load();

		};

		var rssItemSort = 'age';
		var rssItemOrder = 'asc';
		var doRssLoading = false;
		var createRssItemStore = function() {
			var urlOpts = {
			    act: 'rss-item-list',
			    sortby: rssItemSort,
			    orderby: rssItemOrder
			};

			//grid store
			winapp.rssItemStore = Ext.create('Ext.data.JsonStore', {
				pageSize: 0,
			    autoDestroy: true,
			    autoLoad: false,
			    buffered: true,
                //remoteStore: true,
				fields: [
					'id', 'feed_id', 'title', 'link', 'url', 'size', 'age', 'isize'
				],
                proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					reader: {
						type: 'json',
						root: 'items',
                        idProperty: 'dip'
					}
				},
                listeners: {
				    load: function (store, records, successful, operation, eOpts) {
				        rssFeedItemGridPanel.bindStore(store);
				        if (typeof (records) != 'undefined') {
				            if (records.size() != 0) {
				                var sm = rssFeedItemGridPanel.getSelectionModel(),
                                       select = [];
				                if (typeof (winapp.reloadRssSelections) != 'undefined') {
				                    winapp.reloadRssSelections.forEach(function (element) {
				                        store.each(function (record) {
				                            if (record.data.title == element.data.title) {
				                                select.push(record);
				                            }
				                        });
				                    });
				                    sm.select(select);
				                    select.length = 0;
				                }


				                if (!doActionWin && !winapp.isShowMsg && !winapp.isAddRSSItemUrlAction && !winapp.isAddMultiRSSItemUrlAction) {
				                    if (typeof (winapp.win) != 'undefined') {
				                        if (typeof (winapp.win.el) != 'undefined') {
				                            winapp.win.el.unmask();
				                        }
				                    }
				                }
				            }
				        }

				        if (typeof(rssFeedItemGridPanel) != 'undefined') {
				            if (typeof (rssFeedItemGridPanel.el) != 'undefined') {
				                rssFeedItemGridPanel.el.unmask();
				            }
				        }
				        doRssLoading = false;

				        clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
				        winapp.RSS_REFRESH_TIMEOUT_ID = setTimeout(reloadRssItemGridStore, winapp.RSS_REFRESH_TIME_INTERVAL);
				    }
				}
			});

			return winapp.rssItemStore;
		};

		var sortRssItemGridStore = function () {
		    var urlOpts = {
		        act: 'rss-item-list',
		        feed_id: rssRecord.data.id,
		        sortby: rssItemSort,
		        orderby: rssItemOrder
		    };

		    winapp.rssItemStore = Ext.create('Ext.data.JsonStore', {
		    	pageSize: 0,
		        autoDestroy: true,
		        autoLoad: false,
		        buffered: true,
                remoteSort: true,
		        fields: [
					'id', 'feed_id', 'title', 'link', 'url', 'size', 'age', 'isize'
		        ],
		        proxy: {
		            type: 'ajax',
		            url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
		            reader: {
		                type: 'json',
		                root: 'items',
		                idProperty: 'dip'
		            }
		        },
		        listeners: {
		            load: function (store, records, successful, operation, eOpts) {
		                rssFeedItemGridPanel.bindStore(store);

		                if (records.size() != 0) {
		                    var sm = rssFeedItemGridPanel.getSelectionModel(),
                                   select = [];
		                    if (typeof (winapp.reloadRssSelections) != 'undefined') {
		                        winapp.reloadRssSelections.forEach(function (element) {
		                            store.each(function (record) {
		                                if (record.data.title == element.data.title) {
		                                    select.push(record);
		                                }
		                            });
		                        });
		                        sm.select(select);
		                        select.length = 0;
		                    }


		                    if (!doActionWin && !winapp.isShowMsg && !winapp.isAddRSSItemUrlAction && !winapp.isAddMultiRSSItemUrlAction) {
		                        if (typeof(winapp.win) != 'undefined') {
		                            if (typeof(winapp.win.el) != 'undefined') {
		                                winapp.win.el.unmask();
		                            }
		                        }
		                    }
		                }
		                if (typeof(rssFeedItemGridPanel) != 'undefined') {
		                    if (typeof (rssFeedItemGridPanel.el) != 'undefined') {
		                        rssFeedItemGridPanel.el.unmask();
		                    }
		                }
		                doRssLoading = false;

		                clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
		                winapp.RSS_REFRESH_TIMEOUT_ID = setTimeout(reloadRssItemGridStore, winapp.RSS_REFRESH_TIME_INTERVAL);
		            }
		        }
		    });


		    winapp.rssItemStore.load();
		}

		var reloadRssItemGridStore = function () {
		    if (!doRssLoading) {
		        if (typeof (rssRecord) != 'undefined') {
		            doRssLoading = true;
		            if (rssIndex != 0) {
		                var urlOpts = {
		                    act: 'rss-item-list',
		                    feed_id: rssRecord.data.id,
		                    sortby: rssItemSort,
		                    orderby: rssItemOrder
		                };
		                var proxyUrl = AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts);
		                winapp.rssItemStore.proxy.url = proxyUrl;
		                winapp.rssItemStore.load();

		            } else {
		                clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
		                doRssLoading = false;
		            }

		        }
		    }
		};

		var rssFeedRecord;
		var runRssRemoveAction = false;
		var doRemoveRss = function(type) {

			winapp.win.el.mask(_S('COMMON', 'APPLYING'));
			setTimeout(function(){
			    if (typeof(winapp.win) != 'undefined') {
			        if (typeof(winapp.win.el) != 'undefined') {
			            winapp.win.el.unmask();
			        }
			    }
			}, 30000);

			var id;
			if (type == winapp.CONFIRM_TYPE_RSS_PANEL) {
				id = rssRecord.data.id;
			} else if (type == winapp.CONFIRM_TYPE_RSS_FEED_PANEL) {
				id = rssFeedRecord.data.id;
			}
			var urlOpts = {
				act: 'rss-feed-delete',
				id: id
			};
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
				    if (typeof(winapp.win) != 'undefined') {
				        if (typeof(winapp.win.el) != 'undefined') {
				            winapp.win.el.unmask();
				        }
				    }
					if (type == winapp.CONFIRM_TYPE_RSS_PANEL) {
						var checkid = 'rss-'+rssRecord.data.title;
						var find = false;
						var removeItem;
						var findex = 0;
						for (var i=0; i< mainPanel.items.length; i++) {
							var item = mainPanel.items.items[i];
							if (checkid == item.itemId) {
								find = true;
								removeItem = item;
								findex = i;
								break;
							}
						}
						if (find) {
						    mainPanel.remove(removeItem);

						    var layout = mainPanel.getLayout();
						    if (findex != 1) {
						        //change mainPanel findex-1 data
						        layout.setActiveItem(findex - 1);

						    } else {
						        layout.setActiveItem(0);
						        totalDLInfo.show();
						        tabPanel.show();
						        var tlayout = toolBarContainer.getLayout();
						        tlayout.setActiveItem(winapp.TOOLBAR_INDEX_DOWNLOAD);
						    }

						} else {
						    var tlayout = toolBarContainer.getLayout();
						    tlayout.setActiveItem(winapp.TOOLBAR_INDEX_RSS);

						}
						reloadRSSFeedStore();

					} else {
						var tlayout = toolBarContainer.getLayout();
						tlayout.setActiveItem(winapp.TOOLBAR_INDEX_RSS);
						var records = rssPanel.getStore().getRange();
						if (rssIndex < records.length) {
						    rssPanel.getSelectionModel().select(rssIndex);
						}
						reloadRSSFeedStore();
						reloadRSSFeedGridtStore();
					}
					runRssRemoveAction = true;
				},
				failure: function (json, opts) {
				    if (typeof(winapp.win) != 'undefined') {
				        if (typeof(winapp.win.el) != 'undefined') {
				            winapp.win.el.unmask();
				        }
				    }
					winapp.showErrorMsgWin('rss-feed-delete', json, winapp.win);
				}
			});

		};

		//create edit Rss window
		var openEditRss = function() {
			if (winapp.RSS_ADD_WIN_NUMBER < winapp.MAX_RSS_ADD_WIN) {
				//-------------------------------------- openAddRss UI---------------------------------------------------
				var rssUrlValue = '';
			    var rssInterval;
			    if (typeof (rssRecord) != 'undefined') {
			        if (rssIndex != 0) {
			            rssUrlValue = rssRecord.data.url;
			            rssInterval = rssRecord.data.update_interval;
			        } else {
			            rssUrlValue = rssFeedRecord.data.url;
			            rssInterval = rssFeedRecord.data.update_interval;
			        }
			    } else {
			        var select = rssFeedGridPanel.getSelectionModel().getSelection();
			        rssUrlValue = select[0].data.url;
					rssInterval = select[0].data.update_interval;
			    }

				var rssUrl = Ext.create('Ext.form.field.Text', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_URL'),
					allowBlank: false,
					labelWidth: 188,
					blankText: _S('MESSAGE', 'HF00011'),
					msgTarget: AS.ARC.config.msgTarget,
					value: rssUrlValue,
					listeners: {
						validitychange: function( field, isValid, eOpts) {
							if (isValid) {
								btnOk.setDisabled(false);
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});

				var rssUpdateInterval = Ext.create('Ext.form.ComboBox', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_CHECKING_INTERVAL'),
					labelWidth: 188,
					flex: 0,
					store: new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: [
							['3 hours', 0],
							['6 hours', 1],
							['12 hours', 2],
							['1 day', 3],
							['3 days', 4],
							['1 week', 5],
							['2 weeks', 6],
							['3 weeks', 7],
							['1 month', 8]
						]
					}),
					displayField: 'display',
					valueField: 'value',
					editable: false,
					scope: this,
					listeners: {
						render: function( combo, eOpts ) {
							this.select(0);
						},
						change: function( field, newValue, oldValue, eOpts ) {

						}
					}
				});
				//-------------------------------------- openEditRss action---------------------------------------------------
				var doEditRss = function () {
					//check find rss name
					var find = false;
					var addUrl = rssUrl.getValue().trim();
					var records = rssPanel.getStore().getRange();
					if (rssIndex != 0) {
						if (typeof (rssRecord) != 'undefined') {
							var urlOpts = {
								act: 'rss-feed-edit',
								url: rssUrl.getValue(),
								update_interval: rssUpdateInterval.getValue(),
								id: rssRecord.data.id
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									reloadRSSFeedStore();
									rssFeedItemGridPanel.el.mask(_S('COMMON', 'LOADING'));
									reloadRssItemGridStore();
								},
								failure: function (json, opts) {
									winapp.showErrorMsgWin('rss-feed-edit', json, win);
								}
							});
						}
					} else {
						if (typeof (rssFeedRecord) != 'undefined') {
							var urlOpts = {
								act: 'rss-feed-edit',
								url: rssUrl.getValue(),
								update_interval: rssUpdateInterval.getValue(),
								id: rssFeedRecord.data.id
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									reloadRSSFeedStore();
									rssFeedItemGridPanel.el.mask(_S('COMMON', 'LOADING'));
									reloadRssItemGridStore();
								},
								failure: function (json, opts) {
									winapp.showErrorMsgWin('rss-feed-edit', json, win);
								}
							});
						}
					}
				};
				var btnOk = Ext.create(Ext.button.Button, {
					text: _S('COMMON', 'OK'),
					handler: function () {
						win.close();
						doEditRss();
					}
				});
				//-------------------------------------- openEditRss window---------------------------------------------------
				var win = Ext.create('AS.ARC.subWindow', {
					layout: 'fit',
					title: _S('DOWNLOAD_CENTER', 'TITLE_EDIT_RSS'),
					width: 450,
					height: 200,
					parentWin: winapp.win,
					fbar: [
					btnOk,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						}
					}],
					items: [
					{
						xtype: 'asPanelTop10',
						buttonApply: btnOk,
						items: [
							rssUrl,
							rssUpdateInterval
						]
					}],
					listeners: {
						render: function ( com, eOpts ) {
							winapp.RSS_EDIT_WIN_NUMBER++;
							doActionWin = true;
						},
						beforeclose: function() {
							winapp.RSS_EDIT_WIN_NUMBER--;
							doActionWin = false;
						}
					}
				});
				win.show();
			}
		};

		//create Add Rss window
		var openAddRss = function() {
			if (winapp.RSS_ADD_WIN_NUMBER < winapp.MAX_RSS_ADD_WIN) {
				//-------------------------------------- openAddRss UI---------------------------------------------------

				var rssUrl = Ext.create('Ext.form.field.Text', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_URL'),
					allowBlank: false,
					labelWidth: 188,
					blankText: _S('MESSAGE', 'HF00011'),
					msgTarget: AS.ARC.config.msgTarget,
					validator: function(value) {
						if (value !== '') {
							var rssFeedUrlRegExp = /^[A-Za-z]+\:\/\/[A-Za-z0-9-_]+\.[\w\W]+$/;
							if (!rssFeedUrlRegExp.test(value)) {
								return _S('MESSAGE', 'HF00032');
							}
						}
						return true;
					},
					listeners: {
						validitychange: function( field, isValid, eOpts) {
							if (isValid) {
								btnOk.setDisabled(false);
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});

				var rssUpdateInterval = Ext.create('Ext.form.ComboBox', {
					fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_CHECKING_INTERVAL'),
					labelWidth: 188,
					flex: 0,
					store: new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: [
							['3 hours', 0],
							['6 hours', 1],
							['12 hours', 2],
							['1 day', 3],
							['3 days', 4],
							['1 week', 5],
							['2 weeks', 6],
							['3 weeks', 7],
							['1 month', 8]
						]
					}),
					displayField: 'display',
					valueField: 'value',
					editable: false,
					scope: this,
					listeners: {
						render: function( combo, eOpts ) {
							this.select(0);
						},
						change: function( field, newValue, oldValue, eOpts ) {

						}
					}
				});
				//-------------------------------------- openAddRss action---------------------------------------------------
				var doAddRss = function () {
				    //check rss link name
				    var find = false;
				    var addUrl = rssUrl.getValue().trim();
				    var records = rssPanel.getStore().getRange();
				    var findName = '';
				    if (records.length != 0) {
				        for (var i = 0; i < records.length; i++) {
				            var checkUrl = records[i].data.url;
				            if (checkUrl == addUrl) {
				                find = true;
				                findName = records[i].data.title;
				                break;
				            }
				        }
				    }
				    if (!find) {
				        var urlOpts = {
				            act: 'rss-feed-add',
				            url: rssUrl.getValue(),
				            update_interval: rssUpdateInterval.getValue()
				        };
				        AS.ARC.ajax({
				            url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
				            method: 'post',
				            success: function (json, opts) {
				                reloadRSSFeedStore();
				            },
				            failure: function (json, opts) {
				                winapp.showErrorMsgWin('rss-feed-add', json, winapp.win);
				            }
				        });
				    } else {
				        //find the same rss url

				        winapp.showMsgWin(Ext.String.format(_S('DOWNLOAD_CENTER', 'RSS_KEYWORD_EXIST'), findName));
				    }
				};
				var btnOk = Ext.create(Ext.button.Button, {
					text: _S('COMMON', 'OK'),
					handler: function () {
					    win.close();
					    doAddRss();

					}
				});
				//-------------------------------------- openAddRss window---------------------------------------------------
				var win = Ext.create('AS.ARC.subWindow', {
					layout: 'fit',
					title: _S('DOWNLOAD_CENTER', 'TITLE_ADD_RSS'),
					width: 450,
					height: 200,
					parentWin: winapp.win,
					fbar: [
					btnOk,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						}
					}],
					items: [
					{
						xtype: 'asPanelTop10',
						buttonApply: btnOk,
						items: [
							rssUrl,
							rssUpdateInterval
						]
					}],
					listeners: {
						render: function ( com, eOpts ) {
						    winapp.RSS_ADD_WIN_NUMBER++;
						    doActionWin = true;
						},
						beforeclose: function() {
						    winapp.RSS_ADD_WIN_NUMBER--;
						    doActionWin = false;
						}
					}
				});
				win.show();
			}
		};

		var updateRss = function() {
			var urlOpts = {
				act: 'rss-feed-update',
				id: rssRecord.data.id
			};
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
				    rssFeedItemGridPanel.el.mask(_S('COMMON', 'LOADING'));
				    reloadRssItemGridStore();
				},
				failure: function (json, opts) {
					winapp.showErrorMsgWin('rss-feed-update', json, winapp.win);
				}
			});
		};
        //========================================================= FILTER MANAGER FUNCTION =========================================================

		var openFilterManager = function(json) {
			var filterRecord;
			var season_start = 0;
			var season_end = 0;
			var episode_start = 0;
			var episode_end = 0;
			var doCreate = false;
			var filterSelectedIndex = 0;
			//========================================================= TOOLBAR BTN FUNCTION =========================================================
			var btnCreate = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'CREATE'),
				handler: function() {
					filterPanel.getPlugin('cellplugin').completeEdit();
					openCreateFilterWin();
				}
			});

			var btnDelete = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'REMOVE'),
				disabled: true,
				handler: function() {
					filterPanel.getPlugin('cellplugin').completeEdit();
					openDelFilterWin();
				}
			});
            
            var btnRefresh = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'REFRESH'),
				handler: function() {
					
                    filterWin.el.mask(_S('COMMON','LOADING'));
                    reloadFilterStore();
				}
			});
			//========================================================= AUTO REFRESH =========================================================
			var reloadFilterStore = function () {
			    //console.info('reloadFilterStore');
				var urlOpts = {
					act: 'rss-filter-list'
				};

				//grid store
				var listStore = Ext.create('Ext.data.JsonStore', {
				    autoDestroy: true,
				    autoLoad: false,
					fields: [ 'id', 'feed_id', 'name', 'last_check', 'save_as' ],
					proxy: {
						type: 'ajax',
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						reader: {
							type: 'json',
							root: 'items'
						}
					},
					listeners: {
						load: function( store, records, successful, operation, eOpts ) {
							if(winapp.RSS_ROWINDEX.length !== 0) {
								document.getElementById('rssIcon').style.display = 'inline-block';
							} else {
								document.getElementById('rssIcon').style.display = 'none';
							}
							filterPanel.bindStore(store);
							if (records.length != 0) {
								btnOk.setDisabled(false);
								setUpdateUiDisabled(false);
								setTimeout(function(){
                                
									if (doCreate) {
										filterPanel.getSelectionModel().select(records.length-1);
										filterSelectedIndex = records.length-1;
										doCreate = false;
									} else {
										filterPanel.getSelectionModel().select(filterSelectedIndex);
									}
									if (typeof(filterWin) != 'undefined') {
									    if (typeof(filterWin.el) != 'undefined') {
									        filterWin.el.unmask();
									    }
									}
								}, 1000);
								btnDelete.setDisabled(false);
							}else{

								btnDelete.setDisabled(true);
								btnOk.setDisabled(true);
								setUpdateUiDisabled(true);
								if (typeof(filterWin) != 'undefined') {
								    if (typeof(filterWin.el) != 'undefined') {
								        filterWin.el.unmask();
								    }
								}
							}

						}
					}
				});

				//_D('reloadFilterStore ok');
				listStore.load();
			};

			var reloadTVStore = function(season_start, season_end, episode_start, episode_end) {
				season_start = (season_start<=0)?1:season_start;
				episode_start = (episode_start<=0)?1:episode_start;
				season_end = (season_end<=0)?1:season_end;
				episode_end = (episode_end<=0)?1:episode_end;
				var myData = [
					[_S('COMMON', 'START'), season_start, episode_start],
					[_S('COMMON', 'END'), season_end, episode_end]
				];

				var dataStore = new Ext.data.ArrayStore({
					fields: [
					{name: 'title'},
					{name: 'season'},
					{name: 'episode'}
					]
				});

				dataStore.loadData(myData);

				tvPanel.bindStore(dataStore);
			};
			//========================================================= ACTION FUNCTION =========================================================
			var openCreateFilterWin = function() {
				var cname = Ext.create(Ext.form.field.Text, {
					fieldLabel: AS.layout.getIndent(1, _S('COMMON', 'NEW_NAME')),
					itemId: 'name',
					labelWidth: 150,
					width: 350,
					vtype: 'filterName',
					msgTarget: AS.ARC.config.msgTarget,
					allowBlank: false,
					blankText: _S('MESSAGE','HF00011'),
					listeners: {
						specialkey: function(field, e)	{
							if (e.getKey() == e.ENTER) {
								createFilter();
							}
						},
						validitychange: function( field, isValid, eOpts ) {
							if (isValid) {
								btnOk.setDisabled(false);
							} else {
								btnOk.setDisabled(true);
							}
						}
					}
				});

				var createFilter = function() {
					if (cname.getValue() != '') {
						//create folder use ajax
						filterWin.el.mask(_S('COMMON','APPLYING'));
						doCreate = true;

						var urlOpts = {
							act: 'rss-filter-add',
							feed_id: 0,
							name: cname.getValue(),
							include: '',
							exclude: '',
							enable_exactly_match: 0,
							"1080p": false,
							"1080i": false,
							"720p": false,
							WebRip: false,
							TVRip: false,
							SVCD: false,
							SatRip: false,
							PDTV: false,
							HR_PDTV: false,
							HR_HDTV: false,
							HDTV: false,
							DVDScr: false,
							DVDRip: false,
							DVDR: false,
							DVBRip: false,
							DSRip: false,
							tv_series_enabled: false,
							season_start: 0,
							season_end: 0,
							episode_start: 0,
							episode_end: 0,
							update_interval_enabled: false,
							update_interval: 0,
							save_as_enabled: true,
							save_as: defaultDir,
							"time-limit": 0
						};

						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								win.close();
								filterWin.el.mask(_S('COMMON','APPLYING'));
								reloadFilterStore();
                                
								clearData();
							},
							failure: function (json, opts) {
							    if (typeof(filterWin) != 'undefined') {
							        if (typeof(filterWin.el) != 'undefined') {
							            filterWin.el.unmask();
							        }
							    }
								winapp.showErrorMsgWin('rss-filter-add', json, filterWin);
								win.close();
							}
						});
					}
				};

				var btnOk = Ext.create(Ext.button.Button, {
					text: _S('COMMON', 'OK'),
					handler: function() {
						createFilter();
					}
				});
				var win = Ext.create('AS.ARC.subWindow', {
					title: _S('DOWNLOAD_CENTER','TITLE_CREATE_FILTER_MANAGER'),
					width: 400,
					height: 150,
					parentWin: filterWin,
					fbar: [
					btnOk,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						}
					}],
					items:[{
						xtype: 'asPanelTop10',
						itemId: 'panel-group',
						height: 50,
						items: [cname]
					}],
					listeners: {
						beforeshow: function( com, eOpts) {
							cname.focus(true, 500);
						}
					}
				});

				win.show();

			};
            
            /** set rss filter time period value. The number's is sec**/
            var noLimitation = 0,
                threeHour = 10800,   // 3*60*60
                sixHour = 21600,     // 6*60*60
                twHour = 43200,      // 12*60*60
                oneDay = 86400,      // 24*60*60
                threeDay = 259200,   // 3*24*60*60
                oneWeek = 604800,    // 7*24*60*60
                twoWeek = 1209600,   // 2*7*24*60*60
                threeWeek = 1814400, // 3*7*24*60*60
                aMonth = 2419200;    // 4*7*24*60*60
                
			var setUpdateUiDisabled = function(value) {
				feedType.setDisabled(value);
				includeText.setDisabled(value);
				excludeText.setDisabled(value);
				exactlyMatchCheckbox.setDisabled(value);
				qualityType.setDisabled(value);
                timeType.setDisabled(value);
				checkTV.setDisabled(value);
				checkInterval.setDisabled(value);
				downloadPath.setDisabled(value);
				downloadBrowse.setDisabled(value);
			}
			var getDatas = function () {
				if (typeof(filterRecord) != 'undefined'){
					var urlOpts = {
						act: 'rss-filter-list',
						id: filterRecord.data.id
					};
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							if (json.total != 0) {
							    setUpdateUiDisabled(false);
							    var records = feedType.getStore().getRange();
							    var find = false;
							    var check = json.items[0].feed_id;
							    for (var i=0; i<records.length; i++) {
							        var getId = records[i].data.value;

							        if (getId == check) {
							            find = true;
							            break;
							        }
							    }

							    if (find) {
							        feedType.select(json.items[0].feed_id);
							    } else {
							    	feedType.clearValue();
							    }

								includeText.setValue(json.items[0].include);

								var isEnableExactlyMatchValue = json.items[0].enable_exactly_match === 1 ? true : false;
								exactlyMatchCheckbox.setValue(isEnableExactlyMatchValue);

								excludeText.setValue(json.items[0].exclude);
								if (json.items[0].tv_series.enabled) {
									checkTV.setValue(true);
									tvPanel.setDisabled(false);
								} else {
									checkTV.setValue(false);
									tvPanel.setDisabled(true);
								}


								reloadTVStore(json.items[0].tv_series.season_start, json.items[0].tv_series.season_end, json.items[0].tv_series.episode_start, json.items[0].tv_series.episode_end);
								checkInterval.setValue(json.items[0].check_interval.enabled);
								intervalType.select(json.items[0].check_interval.update_interval);

								checkAutoDownload.setValue(json.items[0].save_as.enabled);
								var path = (json.items[0].save_as.download_dir=='')?defaultDir:json.items[0].save_as.download_dir;
								path = changeToHome(path);
								DownloadCenter.changeValueUseEllipsis(path, downloadPath);
								var i = 0;

								var selectData = [];
								Ext.iterate(json.items[0].quality, function(key, value) {
									if (value == true) {
										selectData.push(i);
									}
									i++;
								});
								var noSelectionQualityType = selectData.length === 0;
								if (noSelectionQualityType) {
									qualityType.setValue(_S('FTP_SERVER', 'NO_LIMITATION'));
								} else {
									qualityType.setValue(selectData);
								}
                                timeType.setValue(json.items[0]['time-limit']);
							} else {
								setUpdateUiDisabled(true);
							}
						},
						failure: function (json, opts) {
							winapp.showErrorMsgWin('rss-filter-list', json, filterWin);

						}
					});
				}
			};
            
            /** get qualityType's value and transfor boolean. When the value is exist, set true else set false **/
            var getQualityValue = function() {
                var value = qualityType.getValue();
                var num = [];
                if(value.length === 0) {
                    for(var i = 0; i < 16; i++){
                        num[i] = false;
                    }
                } else {
                    for(var i = 0; i < value.length; i++) {
                        for(var j = 0; j < 16; j++) {
                            if(value[i] === j){
                                num[j] = true;                        
                            } else {
                                if(num[j] !== true) {
                                    num[j] = false;
                                }                            
                            }
                        }
                    }
                }
                return num;
            };
            
			var runSetFilterDatas = function() {
				var store = tvPanel.getStore();

				var items = store.data.items;
				season_start=items[0].data.season;
				season_end=items[1].data.season;
				episode_start=items[0].data.episode;
				episode_end=items[1].data.episode;

				var record = filterPanel.getSelectionModel().getSelection()[0];

				if (typeof(record) != 'undefined') {
					var includeValue = includeText.getValue();
					var excludeValue = excludeText.getValue();
					excludeValue = excludeValue.replace(/\,/g,' ');
                    var quality = getQualityValue();
					var downloadDir = changeHomeFolder(downloadPath.getValue());
					var isEnableExactlyMatch = exactlyMatchCheckbox.getValue() ? 1 : 0;
					if (exactlyMatchCheckbox.getValue() === false) {
						includeValue = includeValue.replace(/\,/g,' ');
					}
                    
					var urlOpts = {
						act: 'rss-filter-edit',
						id: filterRecord.data.id,
						feed_id: feedType.getValue(),
						name: record.data.name,
						include: includeValue,
						enable_exactly_match: isEnableExactlyMatch,
						exclude: excludeValue,
						"1080p": quality[0],
						"1080i": quality[1],
						"720p": quality[2],
						WebRip: quality[3],
						TVRip: quality[4],
						SVCD: quality[5],
						SatRip: quality[6],
						PDTV: quality[7],
						HR_PDTV: quality[8],
						HR_HDTV: quality[9],
						HDTV: quality[10],
						DVDScr: quality[11],
						DVDRip: quality[12],
						DVDR: quality[13],
						DVBRip: quality[14],
						DSRip: quality[15],
						tv_series_enabled: checkTV.getValue(),
						season_start: season_start,
						season_end: season_end,
						episode_start: episode_start,
						episode_end: episode_end,
						update_interval_enabled: checkInterval.getValue(),
						update_interval: intervalType.getValue(),
						save_as_enabled: true,
						save_as: downloadDir,
						"time-limit": timeType.getValue()
					};
					//set quality options
					var QUALITYTYPE_LIST = ['1080p', "1080i", "720p", 'WebRip', 'TVRip', 'SVCD', 'SatRip', 'PDTV', 'HR_PDTV', 'HR_HDTV', 'HDTV', 'DVDScr', 'DVDRip', 'DVDR', 'DVBRip', 'DSRip'];

					var option = {};
					var qData = qualityType.getValue();
					for(var i = 0 ;i < QUALITYTYPE_LIST.length; i++)
						if(qData.indexOf(i) >= 0)
							option[QUALITYTYPE_LIST[i]] = true;
					urlOpts = Ext.apply(urlOpts, option);
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							setTimeout(function() {
							    reloadFilterStore();
							    reloadBTStore();
							}, 1000);


						},
						failure: function (json, opts) {
							winapp.showErrorMsgWin('rss-filter-edit', json, filterWin);

						}
					});

				}
			};

			var clearData = function() {
			    feedType.setValue('');
				includeText.setValue('');
				excludeText.setValue('');
				exactlyMatchCheckbox.setValue(false);
				qualityType.setValue(_S('FTP_SERVER', 'NO_LIMITATION'));
                timeType.setValue(noLimitation);
				reloadTVStore(1, 1, 1, 1);
				checkTV.setValue(false);
				checkInterval.setValue(false);
				intervalType.select(0);
				var rssFilterDefaultDownloadPath = changeToHome(defaultDir);
				DownloadCenter.changeValueUseEllipsis(rssFilterDefaultDownloadPath, downloadPath);
			}
			var openDelFilterWin = function() {
				var win = new AS.ARC.msgWindow({
					title: _S('COMMON','REMOVE'),
					parentWin: filterWin,
					scope: this,
					iconType: 'question',
					fbar: [{
						text: _S('COMMON', 'OK'),
						handler: function(){
							filterWin.el.mask(_S('COMMON','APPLYING'));
							var urlOpts = {
								act: 'rss-filter-delete',
								id: filterRecord.data.id
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									win.close();
									filterSelectedIndex = 0;
									reloadFilterStore();
									clearData();
									if (typeof(filterWin) != 'undefined') {
									    if (typeof(filterWin.el) != 'undefined') {
									        filterWin.el.unmask();
									    }
									}
								},
								failure: function (json, opts) {

								    if (typeof(filterWin) != 'undefined') {
								        if (typeof(filterWin.el) != 'undefined') {
								            filterWin.el.unmask();
								        }
								    }
									winapp.showErrorMsgWin('rss-filter-delete', json, filterWin);
								}
							});
						}
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function() {
							win.close();
						}
					}],
					asItems: [{
						xtype: 'displayfield',
						value: _S('COMMON', 'REMOVE_SELECTED_ITEMS')
					}
					]
				});

				win.show();
			};

			var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {
				clicksToEdit: 1,
				pluginId: 'cellplugin'
			});

			var filterPanel = Ext.create(Ext.grid.GridPanel, {
				border: false,
				width: 250,
				height: 350,
				title: '',
				autoScroll: true,
				flex: 0,
				buffered: true,
				viewConfig:{
					onStoreLoad: Ext.emptyFn,
					focusRow: Ext.emptyFn,
					loadMask: false,
					style: {overflow: 'auto', overflowX: 'auto'}
				},
				plugins: [cellEditing],
				columns: [
					{
						xtype: 'gridcolumn',
						dataIndex: 'name',
						text: _S('COMMON', 'NAME'),
						flex: 1,
						renderer: fileOfTorrentRenderer,
						editor: {
							xtype: 'textfield',
							typeAhead: true,
							triggerAction: 'all',
							selectOnTab: true,
							lazyRender: true,
							vtype: 'filterName',
							msgTarget: AS.ARC.config.msgTarget,
							allowBlank: false,
							blankText: _S('MESSAGE','HF00011')

						}
					},
					{
						xtype: 'gridcolumn',
						dataIndex: 'last_check',
						width: 154,
						renderer: fileOfTorrentRenderer,
						text: _S('DOWNLOAD_CENTER', 'COLUMN_LAST_CHECK')
					}
				],
				listeners: {
					itemclick: function(view, record, item , index, e, eOpts) {
						filterRecord = record;
						filterSelectedIndex = index;
						getDatas();
					},
					select: function( model, record, index, eOpts ) {
						filterRecord = record;
						filterSelectedIndex = index;
						getDatas();
					}
				}
			});

			var createFeedStore = function() {
			    var urlOpts = {
			        act: 'rss-feed-list'
			    };

			    AS.ARC.ajax({
			        url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
			        method: 'post',
			        success: function (json, opts) {
			            var myData = [];
			            var records = json.items;
			            for (var i = 0; i < records.length; i++) {
			                var item = records[i];
			                if (item.id != -1) {
			                    var data = [item.title, item.id];
			                    myData.push(data);
			                }
			            }
			            var dataStore = new Ext.data.ArrayStore({
			                fields: ['display', 'value'],
                            data: myData
			            });
			            dataStore.load();
			            feedType.bindStore(dataStore);
			            reloadFilterStore();
			        },
			        failure: function (json, opts) {
			            winapp.showErrorMsgWin('rss-feed-list', json, filterWin);

			        }
			    });
			};

			var feedType = Ext.create('Ext.form.ComboBox', {
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_FEED'),
                labelWidth: 150,
				width: 480,
				style: AS.layout.getIndentCss(1),
				store: createFeedStore(),
				displayField: 'display',
				valueField: 'value',
				editable: false,
                allowBlank: false,
				queryMode: 'remote',
				scope: this
			});

			var includeText = Ext.create(Ext.form.field.Text, {
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_INCLUDE'),
                labelWidth: 150,
				width: 480,
				style: AS.layout.getIndentCss(1)
			});

			var excludeText = Ext.create(Ext.form.field.Text, {
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_EXCLUDE'),
                labelWidth: 150,
				width: 480,
				style: AS.layout.getIndentCss(1)
			});

			var exactlyMatchCheckbox = Ext.create(Ext.form.field.Checkbox, {
				itemId: 'exactlyMacthIncludeText',
				fieldLabel: '',
				boxLabel: _TS_ING('DOWNLOAD_CENTER', 'EXACTLY_MATCH'),
				style: 'margin-left: 180px',
				width: 325
			});

			var qualityType = Ext.create('Ext.form.ComboBox', {
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_QUALITY'),
                labelWidth: 150,
				width: 480,
				style: AS.layout.getIndentCss(1),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						['1080p', 0],
						['1080i', 1],
						['720p', 2],
						['WebRip', 3],
						['TVRip', 4],
						['SVCD', 5],
						['SatRip', 6],
						['PDTV', 7],
						['HR_PDTV', 8],
						['HR_HDTV', 9],
						['HDTV', 10],
						['DVDScr', 11],
						['DVDRip', 12],
						['DVDR', 13],
						['DVBRip', 14],
						['DSRip', 15]
					]
				}),
				multiSelect: true,
				queryMode: 'local',
				triggerAction: 'all',
				displayField: 'display',
				valueField: 'value',
				value: _S('FTP_SERVER', 'NO_LIMITATION'),
				editable: false,
				scope: this,
				listeners: {
					change: function(combo, newValue, oldValue, eOpts) {
						if (newValue.length === 0) {
							combo.setValue(_S('FTP_SERVER', 'NO_LIMITATION'));
						}
					}
				}
			});
            
            var timeType = Ext.create('Ext.form.ComboBox', {
                fieldLabel: _S('DEFENDER', 'TIME_PERIOD'),
                labelWidth: 150,
				width: 480,
				style: AS.layout.getIndentCss(1),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						[_S('FTP_SERVER', 'NO_LIMITATION'), noLimitation],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTHOUR'), 3), threeHour],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTHOUR'), 6), sixHour],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTHOUR'), 12), twHour],
                        [_S('DOWNLOAD_CENTER', 'PAST_ONE_DAY'), oneDay],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTDAY'), 3), threeDay],
                        [_S('DOWNLOAD_CENTER', 'PAST_ONE_WEEK'), oneWeek],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTWEEKS'), 2), twoWeek],
                        [Ext.String.format(_S('DOWNLOAD_CENTER', 'PASTWEEKS'), 3), threeWeek],
						[_S('DOWNLOAD_CENTER', 'PASTMONTH'), aMonth]
					]
				}),
				mode: 'local',
				triggerAction: 'all',
                displayField: 'display',
				valueField: 'value',
				editable: false,
				scope: this
            });

			var checkTV = Ext.create(Ext.form.field.Checkbox, {
				width: 155,
				fieldLabel: '',
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_TV_SERIES'),
				style: AS.layout.getIndentCss(1),
				listeners: {
					change: function(com, newValue, oldValue, eOpts) {
						if (newValue) {
							tvPanel.setDisabled(false);
						} else {
							tvPanel.setDisabled(true);
						}
					}
				}
			});

			var getTVStore = function() {
				var myData = [
					[_S('COMMON', 'START'), 1, 1],
					[_S('COMMON', 'END'), 1, 1]
				];

				var dataStore = new Ext.data.ArrayStore({
					fields: [
					{name: 'title'},
					{name: 'season'},
					{name: 'episode'}
					]
				});

				dataStore.loadData(myData);

				return dataStore;
			};
			var cellTVEditing = Ext.create('Ext.grid.plugin.CellEditing', {
				clicksToEdit: 1,
				renderer : function(value){
					return (value==0)?1:value;
				}
			});

			var tvPanel = Ext.create(Ext.grid.GridPanel, {
				title: '',
				border: false,
				disabled: true,
				height: 100,
				width: 325,
				autoScroll: true,
				selType: 'cellmodel',
				plugins: [cellTVEditing],
				store: getTVStore(),
				buffered: true,
				viewConfig:{
					onStoreLoad: Ext.emptyFn,
					focusRow: Ext.emptyFn,
					loadMask: false,
					style: {overflow: 'auto', overflowX: 'auto'}
				},
				columns: [
					{
						xtype: 'gridcolumn',
						dataIndex: 'title',
						flex: 1,
						text: ''
					},
					{
						xtype: 'gridcolumn',
						flex: 1,
						dataIndex: 'season',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_SEASON'),
						editor: {
							xtype: 'numberfield',
							typeAhead: true,
							triggerAction: 'all',
							maxValue: 99,
							minValue: 1,
							selectOnTab: true,
							lazyRender: true
						},
						renderer : function(value){
							return (value==0)?1:value;
						}
					},
					{
						xtype: 'gridcolumn',
						flex: 1,
						dataIndex: 'episode',
						text: _S('DOWNLOAD_CENTER', 'COLUMN_EPISODE'),
						editor: {
							xtype: 'numberfield',
							typeAhead: true,
							triggerAction: 'all',
							maxValue: 99,
							minValue: 1,
							selectOnTab: true,
							lazyRender: true
						},
						renderer : function(value){
							return (value==0)?1:value;
						}
					}
				]
			});

			function onTVEdit(e) {
				var store = tvPanel.getStore();
				var items = e.grid.store.data.items;
				//only two record
				season_start=items[0].data.season;
				season_end=items[1].data.season;
				episode_start=items[0].data.episode;
				episode_end=items[1].data.episode;
			};
			tvPanel.on('edit', onTVEdit, this);

			var checkInterval = Ext.create(Ext.form.field.Checkbox, {
				fieldLabel: '',
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_CHECKING_INTERVAL'),
				style: AS.layout.getIndentCss(1),
				width: 305,
				listeners: {
					change: function(com, newValue, oldValue, eOpts) {
						if (newValue) {
							intervalType.setDisabled(false);
						} else {
							intervalType.setDisabled(true);
						}
					}
				}
			});

			var intervalType = Ext.create('Ext.form.ComboBox', {
				fieldLabel: '',
				flex: 0,
				disabled: true,
				style: AS.layout.getIndentCss(1),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						['3 ' + _S('COMMON', 'HOURS'), 0],
						['6 ' + _S('COMMON', 'HOURS'), 1],
						['12 ' + _S('COMMON', 'HOURS'), 2],
						[_S('DOWNLOAD_CENTER', 'ONE_DAY'), 3],
						[_S('DOWNLOAD_CENTER', 'THREE_DAYS'), 4],
						[_S('DOWNLOAD_CENTER', 'ONE_WEEK'), 5],
						[_S('DOWNLOAD_CENTER', 'TWO_WEEKS'), 6],
						[_S('DOWNLOAD_CENTER', 'THREE_WEEKS'), 7],
						[_S('DOWNLOAD_CENTER', 'ONE_MONTH'), 8]
					]
				}),
				displayField: 'display',
				valueField: 'value',
				editable: false,
				scope: this,
				listeners: {
					render: function( combo, eOpts ) {
						this.select(0);
					},
					change: function( field, newValue, oldValue, eOpts ) {

					}
				}
			});

			var checkAutoDownload = Ext.create(Ext.form.field.Checkbox, {
				fieldLabel: '',
				style: AS.layout.getIndentCss(1),
				boxLabel: _S('DOWNLOAD_CENTER', 'INFO_AUTOMATIC_ITEM')
			});

			var downloadPath = Ext.create('Ext.form.field.Text',{
				fieldLabel: _S('DOWNLOAD_CENTER', 'INFO_SAVE_FILE_IN'),
				labelWidth: 150,
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				width: 325,
				msgTarget : 'side',
				style: AS.layout.getIndentCss(1),
				validator: function(value){
					if(winapp.RSS_ROWINDEX.indexOf(filterSelectedIndex) !== -1) {
						btnOk.setDisabled(true);
						if(AS.ARC.user.isAdmin) {
							return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_ADMIN');
						} else {
							return _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR') +'. '+ _S('DOWNLOAD_CENTER', 'NO_ACCESS_DIR_FOR_USER');
						}
					}
					return true;
				},
				listeners: {
					change: function(field, newValue, oldValue, eOpts ) {
						if(oldValue !== undefined) {
							if(newValue !== oldValue) {
								delete winapp.RSS_ROWINDEX[winapp.RSS_ROWINDEX.indexOf(filterSelectedIndex)];
								btnOk.setDisabled(false);
							}
						}
					}
				}
			});

			var downloadBrowse = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'BROWSE'),
				style: 'margin-left: 5px;',
				handler: function() {
					var fs = Ext.create('DownloadCenter.treeSelector', {
						parentWin: filterWin,
						useEllipsis: true,
						showMaxLength: winapp.MAX_DISPLAY_LEHGTH_OF_PATH,
						objectPath: downloadPath
					});
					fs.win.show();
				}
			});

			var btnOk = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'OK'),
				handler: function() {
				filterWin.el.mask(_S('COMMON', 'LOADING'));
					runSetFilterDatas();
				}
			});

			if (winapp.RSS_FILTER_WIN_NUMBER < winapp.MAX_RSS_FILTER_WIN) {
				var filterWin = Ext.create('AS.ARC.subWindow', {
					title: _S('DOWNLOAD_CENTER', 'TITLE_FILTER_MANAGER'),
					parentWin: winapp.win,
					width: 800,
					height: 550,
					fbar: [
					btnOk,
					{
						text: _S('COMMON', 'CLOSE'),
						handler: function () {
							filterWin.close();
						}
					}],
					items: [
						{
							xtype: 'panel',
							height: 450,
							items: [
								{
									xtype: 'asPanelTop10',
									items: [
									{
										xtype: 'asPanelToolbarTop',
										items: [
										btnCreate,
										btnDelete,
										btnRefresh
										]
									},
									{
										xtype: 'panel',
										layout: {
											type: 'hbox'
										},
										items: [
											filterPanel,
											{
												xtype: 'panel',
												cls: 'dc-rss-manage-right-side',
												title: '',
												flex: 1,
												items: [
													feedType,
													includeText,
													exactlyMatchCheckbox,
													excludeText,
													qualityType,
													timeType,
													{
														xtype: 'asFlexbox',
														border: false,
														cls: 'common-layout-horizontal-3-0',
														items: [
															checkTV,
															tvPanel
														]
													},
													{
														xtype: 'asFlexbox',
														border: false,
														cls: 'common-layout-horizontal-3-0',
														items: [
															checkInterval,
															intervalType
														]
													},
													{
														xtype: 'asFlexbox',
														border: false,
														cls: 'common-layout-horizontal-3-0',
														items: [
															downloadPath,
															downloadBrowse
														]
													}
												]
											}
										]
									}
									]
								}
							]
						}
					],
					listeners: {
						afterrender: function(){
							filterWin.el.mask(_S('COMMON', 'LOADING'));
							downloadPath.inputEl.applyStyles({'border': 'none', 'background-image': 'none', 'word-break': 'break-all', 'text-overflow': 'ellipsis'});
						},
						render: function(com, eOpts) {
							//reloadFilterStore();
							winapp.RSS_FILTER_WIN_NUMBER++;
							doActionWin = true;
						},
						beforeclose: function() {
						    winapp.RSS_FILTER_WIN_NUMBER--;
						    doActionWin = false;
						}
					}
				});

				filterWin.show();
			}
		};

		//create search panel context menu
		var rssPanelContextMenu = Ext.create('Ext.menu.Menu', {
			scope: this,
			items: [{
				text: _S('COMMON','ADD'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'add.png'),
				handler: openAddRss
			},{
				text: _S('COMMON','EDIT'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'edit.png'),
				handler: openEditRss
			},{
				text: _S('COMMON','REMOVE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'clear.png'),
				handler: function() {
					openDeleteConfirmWin(winapp.CONFIRM_TYPE_RSS_PANEL);
				}
			}]
		});
		var checkLoadRssGridData = function (record) {
			var layout = mainPanel.getLayout();
			if (record.data.title == 'RSS') {
				layout.setActiveItem(winapp.INDEX_RSS_FEEDGRID_PANEL);
				rssFeedGridPanel.el.mask(_S('COMMON', 'LOADING'));

				var tlayout = toolBarContainer.getLayout();
				tlayout.setActiveItem(winapp.TOOLBAR_INDEX_RSS);
				reloadRSSFeedGridtStore();
			} else {
				layout.setActiveItem(winapp.INDEX_RSS_ITEMGRID_PANEL);
				rssFeedItemGridPanel.el.mask(_S('COMMON', 'LOADING'));

				var tlayout = toolBarContainer.getLayout();
				tlayout.setActiveItem(winapp.TOOLBAR_INDEX_ITEM_RSS);
				clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
				winapp.RSS_REFRESH_TIMEOUT_ID = setTimeout(reloadRssItemGridStore, winapp.RSS_REFRESH_TIME_INTERVAL);
				reloadRssItemGridStore();
			}
            rssEditImg.addCls('download-disable');
            rssDeleteImg.addCls('download-disable');

            rssDownloadImg.addCls('download-disable');
            rssOpenImg.addCls('download-disable');

			totalDLInfo.hide();
			tabPanel.hide();

			changeFocusCls('rss', winapp.FOCUS_RSS);
		};

		var rssPanel = Ext.create('DownloadCenter.gridPanel', {
			itemId: 'rss-grid',
            cls: 'download rsspanel',
			hideHeaders: true,
			width: winapp.WESTPANEL_WIDTH,
			minHeight: 160,
			autoScroll: true,
			border: false,
			split: true,
			region: 'south',
			store: createRSSFeedStore(false),
			scope: this,
			buffered: true,
			flex: 1,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			columns: [{
				dataIndex: 'title',
				renderer: rssPanelRender,
				flex: 1
			}],
			listeners: {
				itemcontextmenu : function(grid, record, item, index, event) {
					if (index != 0) {
						event.stopEvent();
						x = event.browserEvent.clientX;
						y = event.browserEvent.clientY;
						rssPanelContextMenu.showAt([x, y]);
						rssRecord = record;
						rssIndex = index;

						changeFocusCls('rss', winapp.FOCUS_RSS);
					}
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					rssPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					//console.info('itemmouseup');
					rssPanel.setSpecialKey(false);
				},
				select: function (view, record, index, eOpts) {
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
				    var code = record.data['error-code'];
				    rssIndex = index;

				    if (index == 0) {
				        clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
				        checkLoadRssGridData(record);
				        clearAllTypePanelSelectedIndex('rss');
				    } else {
				        if (code < 0) {
				            clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
				            if (!winapp.isShowMsg) {
				                winapp.showMsgWin(_S('DOWNLOAD_CENTER', 'RSS_FIND_ERROR'));

				            }
				        } else {
				            rssRecord = record;
				            checkLoadRssGridData(record);
				            clearAllTypePanelSelectedIndex('rss');
				        }
					}
					
					winapp.isNeedToShowSearchResult = false;
					searchIndex = -1;
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});

		//AS.ARC.util.captureEvents(rssPanel);
		//========================================================= rssFeedGridPanel PANEL =========================================================
		var rssFeedRecord;
		var lastUpdateRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
				var result = '';
				if (value != 0) {
				    var code = record.data['error-code'];
				    if (code < 0) {
				        result = '<font color="#FF0000">' + value + '</font>';
				    } else {
				        result = value;
				    }
				} else {
					result = AS.ARC.datas.defaultValue;
				}
				return result;
		};
		var rssFeedGridPanel = Ext.create('DownloadCenter.gridPanel', {
			itemId: 'rss-RSS',
            cls: 'center-grid',
			autoScroll: true,
			forceFit: true,
			flex: 2,
			loadMask: {msg: _S('DOWNLOAD_CENTER', 'WAIT_SEARCH')},
			viewConfig: {
				emptyText: _S('COMMON','EMPTY_NO_RECORDS')
			},
			//height: 200,
			border: false,
			store: createRSSFeedStore(true),
			buffered: true,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			scope: this,
			columns: [{
				dataIndex: 'title',
				text: _S('COMMON','NAME'),
				flex: 1,
				renderer: rssFeedGridRenderer
			},{
				dataIndex: 'url',
				text: _S('DOWNLOAD_CENTER', 'COLUMN_URL'),
				flex: 1,
				renderer: rssFeedGridRenderer
			}, {
				dataIndex: 'last_update',
				text: _S('DOWNLOAD_CENTER', 'COLUMN_LAST_UPDATE'),
				flex: 1,
				renderer: lastUpdateRenderer
			}
			],
			listeners: {
				itemcontextmenu : function(grid, record, item, index, event) {
					event.stopEvent();
					rssFeedRecord = record;

					changeFocusCls('rssFeedGrid', winapp.FOCUS_RSSFEEDGRID);
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					rssFeedGridPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					rssFeedGridPanel.setSpecialKey(false);
				},
				select: function( view, record, index, eOpts ) {
                    rssEditImg.removeCls('download-disable');
                    rssDeleteImg.removeCls('download-disable');
					rssFeedRecord = record;
					changeFocusCls('rssFeedGrid', winapp.FOCUS_RSSFEEDGRID);
				},
				itemdblclick: function ( view, record, item, index,  e, eOpts ) {
					rssFeedRecord = record;

					changeFocusCls('rssFeedGrid', winapp.FOCUS_RSSFEEDGRID);
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				},
				scope: this
			}
		});
		//========================================================= rssFeedItemGridPanel PANEL =========================================================
		var nameColumn = Ext.create(Ext.grid.column.Column, {
			dataIndex: 'title',
			text: _S('COMMON','NAME'),
			flex: 1,
			sortable:true,
			renderer: fileOfTorrentRenderer
		});
		var rssFeedSort;
		var rssFeedContextMenu = Ext.create('Ext.menu.Menu', {
			scope: this,
			items: [{
				text: _S('COMMON','DOWNLOAD'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'download.png'),
				handler: function() {
					var isMultiSelection = rssFeedItemGridPanel.getSelectionModel().getSelection().length > 1;

					if (isMultiSelection) {
						winapp.isAddMultiRSSItemUrlAction = true;
					} else {
						winapp.isAddRSSItemUrlAction = true;
					}

					checkRunSelectOpenTorrentInfo(rssFeedItemGridPanel, 'rss', rssFeedItemRecord);
				}
			},{
				text: _S('DOWNLOAD_CENTER','MENU_OPEN'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'open_window.png'),
				handler: function() {
					checkRunOpenWindow(rssFeedItemGridPanel);
				}
			}]
		});

		// winapp.rssPagingBar = Ext.create('AS.ARC.pagingToolbar');

		var rssFeedItemRecord;
		var rssFeedItemRecordIndex = -1;
		var rssItemStore = createRssItemStore();
		var rssFeedItemGridPanel = Ext.create('DownloadCenter.gridPanel', {
			itemId: 'rss-item',
            cls: 'center-grid',
			autoScroll: true,
            forceFit: true,
			flex:1,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			border: false,
			store: rssItemStore,
			scope: this,
			multiSelect: true,
			//buffered: true,
			columns: [
			nameColumn,
			{
                dataIndex: 'size',
				text: _S('COMMON','SIZE'),
				width: 100,
				renderer: sizeRender,
				sortable:true
			},{
				dataIndex: 'age',
				text: _S('DOWNLOAD_CENTER', 'COLUMN_AGE'),
				width: 100,
				renderer: ageRender,
				sortable:true
			},{
				dataIndex: 'url',
				text: _S('COMMON','DOWNLOAD'),
				flex: 1,
				renderer: fileOfTorrentRenderer,
				sortable:true
			}
			],
			// bbar: winapp.rssPagingBar,
			listeners: {
				itemcontextmenu : function(grid, record, item, index, event) {
					event.stopEvent();
					x = event.browserEvent.clientX;
					y = event.browserEvent.clientY;
					rssFeedContextMenu.showAt([x, y]);

					changeFocusCls('rssFeedItem', winapp.FOCUS_RSSFEEDITEM);
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					rssFeedItemGridPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					rssFeedItemGridPanel.setSpecialKey(false);
				},
				selectionchange: function () {
				    var sm = rssFeedItemGridPanel.getSelectionModel(),
						selections = sm.getSelection();

				    // for reload
				    if (selections.length > 0) {
				        winapp.reloadRssSelections = selections;
				    }
				},
				select: function( view, record, index, eOpts ) {
                    rssDownloadImg.removeCls('download-disable');
                    rssOpenImg.addCls('download-disable');
					rssFeedItemRecord = record;
					rssFeedItemRecordIndex = index;
					changeFocusCls('rssFeedItem', winapp.FOCUS_RSSFEEDITEM);

					if (rssFeedItemRecord.data.link.indexOf('magnet:') === -1) {
						rssOpenImg.removeCls('download-disable');
					}
				},
				itemdblclick: function ( view, record, item, index,  e, eOpts ) {
					changeFocusCls('rssFeedItem', winapp.FOCUS_RSSFEEDITEM);

					winapp.isAddRSSItemUrlAction = true;
					addUrlToOpenTorrentInfo(record.data.url, record.data.title);
				},
				sortchange: function ( ct, column, direction, eOpts ) {

					if (column.text == 'Name') {
						rssItemSort = 'title';
					} else {
						rssItemSort = column.dataIndex.toLowerCase();
					}

					if (direction == null) {

					} else {
						rssItemOrder = direction.toLowerCase();
						rssFeedItemGridPanel.el.mask(_S('COMMON', 'LOADING'));
						sortRssItemGridStore();
					}

				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});

		//========================================================= BTPANEL PANEL =========================================================
        //create bt grid data store
		var doBtLoading = false;
		var createBTStore = function() {
		    var urlOpts = {
		        act: 'torrent-list',
		        sortby: gridSort,
		        orderby: gridDir,
		        filter: filterKey
		    };

			//grid store
		    winapp.BTStore = Ext.create('Ext.data.JsonStore', {
		        autoDestroy: true,
		        pageSize: winapp.GRIDPANEL_PAGESIZE,
                autoLoad: false,
		        remoteSort: true,
		        fields: [
					'id', 'name', 'size', 'percent', 'download', 'upload', 'eta', 'queuePosition_active', 'complete_time', 'status', 'owner', 'type', 'position', 'error'
		        ],
		        proxy: {
		            type: 'ajax',
		            url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
		            params: {
		                start: 0,
		                limit: -1
		            },
		            reader: {
		                type: 'json',
		                root: 'files',
		                idProperty: 'dip'
		                //totalProperty: 'All'
		            }
		        },
		        listeners: {
		            load: function (store, records, successful, operation, eOpts) {

						winapp.currentTaskCount = store.proxy.reader.rawData.all;	//sync total download task count

		                var activeItem = toolBarContainer.getLayout().getActiveItem();
		                var activeIndex = toolBarContainer.items.indexOf(activeItem);
		                var getProxy = store.getProxy();

		                if (activeIndex == winapp.INDEX_DOWNLOAD_RESULT) {
                            
                            downloadDeleteImg.addCls('download-disable');
                            downloadUpImg.addCls('download-disable');
                            downloadDownImg.addCls('download-disable');
                            downloadStartImg.addCls('download-disable');
                            downloadStopImg.addCls('download-disable');

		                    var info = Ext.String.format(_S('DOWNLOAD_CENTER', 'INFO_DUL'), getProxy.reader.jsonData.total_download_speed, '&nbsp;&nbsp;&nbsp;', getProxy.reader.jsonData.total_upload_speed);
		                    totalDLInfo.setValue(info);

		                    var sm = btPanel.getSelectionModel(),
                                    select = [];
		                    winapp.reloadSelections.forEach(function (element) {
		                        store.each(function (record) {
		                            if (record.data.name === element.data.name && record.data.id === element.data.id) {
		                                select.push(record);
		                            }
		                        });
		                    });
							if(select.length === 0) {
								clearInfoData();
							}
		                    sm.select(select);
		                    select.length = 0;
		                }
		                var new_records = {
		                	totalDownloadCount: getProxy.reader.jsonData.downloading,
						    totalCompleteCount: getProxy.reader.jsonData.completed,
						    totalActiveCount: getProxy.reader.jsonData.active,
						    totalInactiveCount: getProxy.reader.jsonData.inactive,
						    totalRecordCount: getProxy.reader.jsonData.all
		                };
		                reloadDownloadStore(new_records);
		                doBtLoading = false;
		                clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
		                winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);
		                if (records.size() == 0) {
		                    clearInfoData();
		                }
		                if (isFirstOpen === false) {
							if (!doActionWin && !doAddUrl && !winapp.isShowMsg) {
			                    if (typeof(winapp.win) != 'undefined') {
			                        if (typeof(winapp.win.el) != 'undefined') {
			                            winapp.win.el.unmask();
			                        }
			                    }
			                }

			                if (typeof(btPanel) != 'undefined') {
			                    if (typeof(btPanel.el) != 'undefined') {
			                        btPanel.el.unmask();
			                    }
			                }
		                }
					},
					exception: function (proxy, response, operation, opts) {

					}
				}
			});

			return winapp.BTStore;
		};

	    //refresh btStore
		var reloadBTStore = function () {
		    if (!doBtLoading) {
		        doBtLoading = true;
		        clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
		        var layout = mainPanel.getLayout();
		        var activeItem = layout.activeItem;
		        var activeIndex = mainPanel.items.indexOf(activeItem);

		        var urlOpts = {
		            act: 'torrent-list',
		            sortby: gridSort,
		            orderby: gridDir,
		            filter: filterKey,
		            type: winapp.selectedType
		        };

		        var proxyUrl = AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts);

		        winapp.BTStore.proxy.url = proxyUrl;
		        winapp.BTStore.clearFilter(true);

		        if (BTStoreFilter != null) {
		            winapp.BTStore.filter(BTStoreFilter);
		        }

		        winapp.BTStore.load();
		    }

		};

        //create torrent info grid data store
		var doInfoLoading = false;
		var createInfoStore = function() {
			var urlOpts = {
				act: 'torrent-info',
				id: showTorrentInfoId,
				sortby: infoSort,
				orderby: infoOrder
			};

			//grid store
			winapp.infoStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
                autoLoad: false,
				fields: [
					'file_wanted', 'file_name', 'file_size', 'file_downloaded', 'file_percent', 'remaining_time', 'file_isize'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
					params: {
					    start: 0,
					    limit: -1
					},
					reader: {
						type: 'json',
						root: 'files'
						//totalProperty: 'All'
					}
				},
				listeners: {
					load: function( store, records, successful, operation, eOpts ) {
					    if (records.length != 0) {
					        infoPanel.bindStore(infoStore);
							if (tabSelectedRecord != null) {
								var length = records.length;
								for (var i=0; i< length; i++) {
									var item = records[i];
									if (item.data.file_name == tabSelectedRecord.data.file_name) {
										infoPanel.getSelectionModel().select(i);
									}
								}
							}
					    }
					    if (typeof(infoPanel) != 'undefined') {
					        if (typeof(infoPanel.el) != 'undefined') {
					            infoPanel.el.unmask();
					        }
					    }
						doInfoLoading = false;
					}
				}
			});
			winapp.infoStore.load();

			return winapp.infoStore;
		};

		var reloadInfoStore = function () {
		    if (!doInfoLoading) {
		        doInfoLoading = true;
		        var urlOpts = {
		            act: 'torrent-info',
		            id: showTorrentInfoId,
		            sortby: infoSort,
		            orderby: infoOrder
		        };
		        var proxyUrl = AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts);

		        winapp.infoStore.proxy.url = proxyUrl;

		        winapp.infoStore.load();
		    }
		};

		var listStore = createBTStore();
		var totalDLInfo = Ext.create('Ext.form.field.Display', {
            height: 30,
			fieldLabel: ''
		});

		var totalContainer = Ext.create('Ext.container.Container', {
			dock: 'bottom',
            height: 30,
			flex: 0,
            cls: 'totalContainer',
			layout: {
				align: 'stretch',
				type: 'hbox'
			},
			items: [
				totalDLInfo
			]
		});

        var doTrackerLoading = false;
        var createTrackerStore = function() {
            var urlOpts = {
                act: 'torrent-info',
                id: showTorrentInfoId
            };

            //grid store
            winapp.trackerStore = Ext.create('Ext.data.JsonStore', {
                autoDestroy: true,
                autoLoad: false,
				sorters: {
					property: trackerSort,
					direction: trackerOrder
				},
                fields: [
                    'tracker_name', 'tracker_stats', 'tracker_next_update', 'seeds', 'peers'
                ],
                proxy: {
                    type: 'ajax',
                    url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
                    params: {
                        start: 0,
                        limit: -1
                    },
                    reader: {
                        type: 'json',
                        root: 'tracker'
                    }
                },
                listeners: {
                    load: function( store, records, successful, operation, eOpts ) {
						if (typeof(trackerGridPanel) != 'undefined') {
                            if (typeof(trackerGridPanel.el) != 'undefined') {
                                trackerGridPanel.el.unmask();
                            }
                        }
                        if (store.data.items.length !== 0) {
                            trackerGridPanel.bindStore(trackerStore);
                        }
                        
                        doTrackerLoading = false;
                        
                        var sm = trackerGridPanel.getSelectionModel(),
                            select = [];
                        winapp.trackerSelections.forEach(function (element) {
							store.each(function (record) {
								if (record.data.tracker_name === element.data.tracker_name && record.data.id === element.data.id) {
									select.push(record);
								}
							});
						});
                        sm.select(select);
                        select.length = 0;
                    }
                }
            });
            winapp.trackerStore.load();

            return winapp.trackerStore;
        };

        var reloadTrackerStore = function () {
            if (!doTrackerLoading) {
                doTrackerLoading = true;
                var urlOpts = {
                    act: 'torrent-info',
                    id: showTorrentInfoId
                };
                
                var proxyUrl = AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts);
        
                winapp.trackerStore.proxy.url = proxyUrl;
                winapp.trackerStore.load();
            }
        };
        
		//create pagingtoolbar
		var pagingBar = Ext.create('Ext.toolbar.Paging', {
			store: listStore,
			pageSize: 15,
			emptyMsg: _S('COMMON','EMPTY_NO_DATA'),
			dock: 'bottom',
			displayInfo: true
		});
		var downEditMenuItem = Ext.create(Ext.menu.Item, {
			text: _S('COMMON','EDIT'),
			icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'edit.png'),
			handler: function() {
				openEditTorrentInfoWindow(winapp.win);
			}
		});
		var downloadContextMenu = Ext.create('Ext.menu.Menu', {
			scope: this,
			items:[
			downEditMenuItem,
			{
				text: _S('COMMON','DELETE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'delete.png'),
				handler: function() {
					openDeleteConfirmWin(winapp.CONFIRM_TYPE_DOWNLOAD_RESULT);
				}
			},
			'-',
			{
				text: _S('COMMON','START'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'play.png'),
				handler: doStart
			},{
				text: _S('DOWNLOAD_CENTER', 'MENU_PAUSE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'pause.png'),
				handler: doStop
			},
			'-',
			{
				text: _S('DOWNLOAD_CENTER', 'MENU_UP'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'pageup.png'),
				itemId: 'up_direction',
				handler: function() {
					doDirection('up');
				}
			},{
				text: _S('DOWNLOAD_CENTER', 'MENU_DOWN'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'pagedown.png'),
				itemId: 'down_direction',
				handler: function() {
					doDirection('down');
				}
			},
			'-',
			{
				text: _S('DOWNLOAD_CENTER', 'OPEN_FILE_PLACE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'open.png'),
				itemId: 'open_file_place'
			}]
		});

		//define user click downpanel row
		var downloadRecord;
		var columnName = Ext.create('Ext.grid.column.Column',{
			dataIndex: 'name',
			minWidth: 100,
			flex: 5,
			text: _S('COMMON','NAME'),
			renderer: fileOfTorrentRenderer,
			listeners: {
				'mouseout': function() {
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
					winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);
				}
			}
		});
		//AS.ARC.util.captureEvents(columnName);
		var setDownloadPanelIndex = function(index) {
			if (downloadPanelValue == 'downloading') {
				downloadingIndex = index;
			} else if (downloadPanelValue == 'completed') {
				completedIndex = index;
			} else if (downloadPanelValue == 'active') {
				activeIndex = index;
			} else if (downloadPanelValue == 'inactive') {
				inactiveIndex = index;
			} else if (downloadPanelValue == 'all') {
				allIndex = index;
			}
		};

		var sortFileData = function(sort, dir) {
			gridSort = sort;
			gridDir = dir;

			var urlOpts = {
			    act: 'torrent-list',
			    sortby: gridSort,
			    orderby: gridDir,
			    filter: filterKey
			};
            
		    //grid store
			winapp.BTStore = Ext.create('Ext.data.JsonStore', {
			    autoDestroy: true,
			    autoLoad: false,
			    pageSize: winapp.GRIDPANEL_PAGESIZE,
			    remoteSort: true,
			    fields: [
					'id', 'name', 'size', 'percent', 'download', 'upload', 'eta', 'queuePosition_active', 'complete_time', 'status', 'owner', 'type', 'position'
			    ],
			    proxy: {
			        type: 'ajax',
			        url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
			        params: {
			            start: 0,
			            limit: -1
			        },
			        reader: {
			            type: 'json',
			            root: 'files',
			            idProperty: 'dip'
			        }
			    },
			    listeners: {
			        load: function (store, records, successful, operation, eOpts) {
			            var activeItem = toolBarContainer.getLayout().getActiveItem();
			            var activeIndex = toolBarContainer.items.indexOf(activeItem);
			            if (activeIndex == winapp.INDEX_DOWNLOAD_RESULT) {
                            
                            downloadDeleteImg.addCls('download-disable');
                            downloadUpImg.addCls('download-disable');
                            downloadDownImg.addCls('download-disable');
                            downloadStartImg.addCls('download-disable');
                            downloadStopImg.addCls('download-disable');

			                var getProxy = store.getProxy();

			                var info = AS.ARC.util.fontToBold(Ext.String.format(_S('DOWNLOAD_CENTER', 'INFO_DUL'), getProxy.reader.jsonData.total_download_speed, '&nbsp;&nbsp;&nbsp;', getProxy.reader.jsonData.total_upload_speed));
			                totalDLInfo.setValue(info);

			                var sm = btPanel.getSelectionModel(),
                                    select = [];
			                winapp.reloadSelections.forEach(function (element) {
			                    store.each(function (record) {
			                        if (record.data.name == element.data.name) {
			                            select.push(record);
			                        }
			                    });
			                });

			                sm.select(select);
			                select.length = 0;
			            }

			            var new_records = {
		                	totalDownloadCount: getProxy.reader.jsonData.downloading,
						    totalCompleteCount: getProxy.reader.jsonData.completed,
						    totalActiveCount: getProxy.reader.jsonData.active,
						    totalInactiveCount: getProxy.reader.jsonData.inactive,
						    totalRecordCount: getProxy.reader.jsonData.all
		                };
			            reloadDownloadStore(new_records);
			            doBtLoading = false;
			            btPanel.bindStore(store);
			            clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
			            winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);

			            if (!doSearchSite && !doActionWin &&
                            !doAddUrl && !winapp.isShowMsg) {
			                if (typeof (winapp.win) != 'undefined') {
			                    if (typeof (winapp.win.el) != 'undefined') {
			                        winapp.win.el.unmask();
			                    }
			                }
			            }
			            btPanel.el.unmask();
			        }
			    }
			});

			winapp.BTStore.load();

		};
		var changeSortStatus = function() {
			if (doSort) {
				doSort = false;
			}
		}

		var getBTPanelColumns = function() {
			var btPanelColumns = [
				{
					xtype: 'gridcolumn',
					dataIndex: 'position',
					flex: 1,
					align: 'left',
					text: _S('DOWNLOAD_CENTER','COLUMN_SYMBOL')
				},
				columnName,
				{
					xtype: 'gridcolumn',
					dataIndex: 'size',
					flex: 1,
					align: 'left',
					text: _S('COMMON','SIZE'),
					renderer: function(value, metaData, record, rowIndex, colIndex, store) {
						if (record.data.status === 'Downloading' && record.data.error === 5009) {
							value = _S('COMMON','UNKNOWN');
						}
						return value;
					}
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'percent',
					flex: 1,
					align: 'left',
					text: '%'
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'download',
					flex: 1,
					align: 'left',
					text: _S('COMMON','DOWNLOAD')
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'upload',
					flex: 1,
					align: 'left',
					text: _S('COMMON','UPLOAD')
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'eta',
					flex: 1,
					align: 'left',
					text: _S('DOWNLOAD_CENTER', 'COLUMN_ETA')
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'queuePosition_active',
					flex: 1,
					align: 'left',
					text: _S('DOWNLOAD_CENTER', 'QUEUE'),
					renderer: function(value) {
						if (value === -1) {
							value = '';
							return value;
						} else {
							return value;
						}
					}
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'complete_time',
					flex: 3,
					align: 'left',
					text: _S('REGIONAL', 'END_TIME'),
					renderer: function(value) {
						if (value === 0) {
							value = '';
							return value;
						} else {
							var result = AS.ARC.util.toSystemTime(
								AS.ARC.config.dateFormat.DateFormat, 
								AS.ARC.config.dateFormat.TimeFormat,
								value
							);
							return result;
						}
					}
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'status',
					flex: 2,
					text: _S('COMMON','STATUS'),
					renderer: function(value, metaData, record, rowIndex, colIndex, store) {
						var getErrMsg = function(errCode) {
							var msg;

							switch (errCode) {
								case 5001:
									msg = _S('ERROR', 'INCORRECT_USER');
								break;
								case 5028:
									msg = _S('ERROR', 'INEXISTENT_PATH');
								break;
								case 5051:
									msg = _S('ERROR', 'DISK_FULL');
								break;
								case 5608:
									msg = _S('ERROR', 'CONNECTION_TIMEOUT');
								break;
								case 5607:
									msg = _S('DOWNLOAD_CENTER', 'BROKEN_LINK');
								break;
								case 5611:
									msg = _S('DOWNLOAD_CENTER', 'BROKEN_LINK');
								break;
							}

							return msg;
						};
	
						if (value === 'Error') {
							metaData.tdAttr = 'data-qtip="' + getErrMsg(record.data.error) + '"';
							return '<span style="color:red">' + value + '</span>';
						} else {
							return value;
						}
					}
				}, {
					xtype: 'gridcolumn',
					dataIndex: 'owner',
					flex: 1,
					text: _S('COMMON','OWNER')
				}, {
					xtype: 'gridcolumn',
					flex: 1,
					dataIndex: 'type',
					text: _S('COMMON','TYPE')
				}
			];

			if (!AS.ARC.user.isAdmin) {
				btPanelColumns.each(function(column, index) {
					if (column.dataIndex === 'owner') {
						btPanelColumns.splice(index, 1);
					}
				});
			}

			return btPanelColumns;
		};

		var selectTimeoutID = '';
		var canDoSelectEvent = true;
		var doSort = true;
        var setActTab = false;
		var btPanel = Ext.create('DownloadCenter.gridPanel', {
			region: 'center',
            cls: 'center-grid',
			itemId: 'bt-grid',
			autoScroll: true,
			border: false,
			//resizable: false,
			store: listStore,
			multiSelect: true,
			scope: this,
			//buffered: true,
			forceFit: true,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: { overflow: 'auto', overflowX: 'hidden' }
			},
			columns: getBTPanelColumns(),
			listeners: {
				sortchange: function( ct, column, direction, eOpts ) {
					if (direction != null) {
						if (direction == 'DESC')
							direction = 'desc';
						if (direction == 'ASC')
						    direction = 'asc';

						btPanel.el.mask(_S('COMMON', 'LOADING'));
						sortFileData(column.dataIndex, direction);
					}
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					btPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					btPanel.setSpecialKey(false);
				},
				selectionchange: function () {
				    winapp.scrollTop = btPanel.view.getEl().dom.scrollTop;
				    var sm = btPanel.getSelectionModel(),
						selections = sm.getSelection();
                        
				    // for reload
				    if (selections.length > 0) {
				        winapp.reloadSelections = selections;
				    }
				},
				select: function (grid, record, index, eOpts) {
					if (canDoSelectEvent) {
						downloadRecord = record;
						setDownloadPanelIndex(index);
						winapp.infoRecords = record;
                        
                        var trackTab = tabPanel.child('#trackPanel');
                        
                        if (record.data.status === 'Downloading') {
                            trackTab.tab.show();
                            setActTab = false;
                        } else {
                            trackTab.tab.hide();
                            
                            if(setActTab === false){
                                var transInfo = tabPanel.child('#transInfo');
                                tabPanel.setActiveTab(transInfo);
                                setActTab = true;
                            }
                        }
                        
                        
						if (record.data.status === 'Queued') {
							if (record.data.type === 'BT') {
								downloadUpImg.removeCls('download-disable');
								downloadDownImg.removeCls('download-disable');
							}
							else {
								downloadUpImg.addCls('download-disable');
								downloadDownImg.addCls('download-disable');
							}
						} else {
							downloadUpImg.addCls('download-disable');
							downloadDownImg.addCls('download-disable');
						}
						
						downloadDeleteImg.removeCls('download-disable');
                        downloadStartImg.removeCls('download-disable');
                        downloadStopImg.removeCls('download-disable');
						changeFocusCls('bt', winapp.FOCUS_BT);
						clearTimeout(selectTimeoutID);
						selectTimeoutID = setTimeout(function() {
							if (canShowPanelInfo) {
								showTabPanelInfo(record);
							}
						}, 500);
					}
				},
				columnhide: function( ct, column, eOpts ) { 
				},
				itemcontextmenu : function(grid, record, item, index, event) {
				    event.stopEvent();

				    downloadRecord = record;
				    setDownloadPanelIndex(index);
				    winapp.infoRecords = record;

				    changeFocusCls('bt', winapp.FOCUS_BT);

					x = event.browserEvent.clientX;
					y = event.browserEvent.clientY;
					downloadContextMenu.showAt([x, y]);

					var open_file_place_item = downloadContextMenu.getComponent('open_file_place'),
						upDirection = downloadContextMenu.getComponent('up_direction'),
						downDirection = downloadContextMenu.getComponent('down_direction');

					if (record.data.percent === '100%') {
						open_file_place_item.setDisabled(false);
						Ext.apply(open_file_place_item, {
							handler: function() {
								AS.ARC.core.openApp('app-fileExplorer', record.raw.download_dir);
							}
						});
					}
					else
						open_file_place_item.setDisabled(true);

                    downloadDeleteImg.removeCls('download-disable');
                    
                    downloadStartImg.removeCls('download-disable');
                    downloadStopImg.removeCls('download-disable');

					if (record.data.type === 'BT') {
						if (record.data.status === 'Queued') {
							downloadUpImg.removeCls('download-disable');
                    		downloadDownImg.removeCls('download-disable');
						} else {
							downloadUpImg.addCls('download-disable');
                    		downloadDownImg.addCls('download-disable');
						}
					} else {
						downloadUpImg.addCls('download-disable');
                    	downloadDownImg.addCls('download-disable');
					}
					if (canShowPanelInfo) {
						showTabPanelInfo(record);
					}

					if (record.data.status !== 'Queued') {
						upDirection.setDisabled(true);
						downDirection.setDisabled(true);
					} else {
						upDirection.setDisabled(false);
						downDirection.setDisabled(false);
					}

					if (record.data.type != 'BT') {
						downEditMenuItem.setDisabled(true);
					} else {
					    var select = btPanel.getSelectionModel().getSelection();
					    if (select.length == 1) {
					        downEditMenuItem.setDisabled(false);
					    } else {
					        downEditMenuItem.setDisabled(true);
					    }
					}
				},
				itemdblclick: function ( view, record, item, index, e, eOpts ) {
					downloadRecord = record;
					setDownloadPanelIndex(index);
					winapp.infoRecords = record;

					changeFocusCls('bt', winapp.FOCUS_BT);
                    
                    downloadDeleteImg.removeCls('download-disable');
                    downloadUpImg.removeCls('download-disable');
                    downloadDownImg.removeCls('download-disable');
                    downloadStartImg.removeCls('download-disable');
                    downloadStopImg.removeCls('download-disable');
					if (canShowPanelInfo) {
						showTabPanelInfo(record);
					}
				},
				beforeshow: function (com, eOpts) {
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
					winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});

		var clearInfoData = function() {
			downloadRecord = null;
			winapp.infoRecords = null;
			showTorrentInfoId = 0;
			infoStore = createInfoStore();
			infoPanel.bindStore(infoStore);
            trackerStore = createTrackerStore();
            trackerGridPanel.bindStore(trackerStore);
			downloadDirectory.setValue(AS.ARC.datas.defaultValue);
			totalSize.setValue(AS.ARC.datas.defaultValue);
			createDate.setValue(AS.ARC.datas.defaultValue);
			timeElapsed.setValue(AS.ARC.datas.defaultValue);
			remainingTime.setValue(AS.ARC.datas.defaultValue);
			downloaded.setValue(AS.ARC.datas.defaultValue);
			uploaded.setValue(AS.ARC.datas.defaultValue);
			seeds.setValue(AS.ARC.datas.defaultValue);
			peers.setValue(AS.ARC.datas.defaultValue);
			shareRatio.setValue(AS.ARC.datas.defaultValue);
			downloadSpeed.setValue(AS.ARC.datas.defaultValue);
			uploadSpeed.setValue(AS.ARC.datas.defaultValue);
			originTorrent.hide();
		};

		var setHttpInfo = function(record) {
			downloadDirectory.setValue(AS.ARC.datas.defaultValue);
			totalSize.setValue(AS.ARC.datas.defaultValue);
			createDate.setValue(AS.ARC.datas.defaultValue);
			timeElapsed.setValue(AS.ARC.datas.defaultValue);
			remainingTime.setValue(AS.ARC.datas.defaultValue);
			downloaded.setValue(AS.ARC.datas.defaultValue);
			uploaded.setValue(AS.ARC.datas.defaultValue);
			seeds.setValue(AS.ARC.datas.defaultValue);
			peers.setValue(AS.ARC.datas.defaultValue);
			shareRatio.setValue(AS.ARC.datas.defaultValue);
			downloadSpeed.setValue(AS.ARC.datas.defaultValue);
			uploadSpeed.setValue(AS.ARC.datas.defaultValue);
			originTorrent.hide();

			var myData = [
				['0', true, record.data.name, record.data.size, record.data.download, record.data.percent, record.data.size]
			];

			var dataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'file_id'},
					{name: 'file_wanted'},
					{name: 'file_name'},
					{name: 'file_size'},
					{name: 'file_downloaded'},
					{name: 'file_percent'},
					{name: 'file_isize'}
				]
			});

			dataStore.loadData(myData);
			infoPanel.bindStore(dataStore);
            
            var trackerData = [];

			var trackerdataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'tracker_name'},
					{name: 'tracker_stats'},
					{name: 'tracker_next_update'},
					{name: 'seeds'},
					{name: 'peers'}
				]
			});
            trackerdataStore.loadData(trackerData);
			trackerGridPanel.bindStore(trackerdataStore);
            
			downloadSpeed.setValue(record.data.download);
			uploadSpeed.setValue(record.data.upload);
			timeElapsed.setValue(record.data.eta);
			var showDir = Ext.util.Format.ellipsis(defaultDir, 25);
            showDir = changeToHome(showDir);
			downloadDirectory.setValue(showDir);
		};

		var canShowPanelInfo = true;
		var showTorrentInfoId = 0;
		var showTabPanelInfo = function(record) {
			if (record != null) {
				var id = record.data.id;
				var type = record.data.type;
				if (typeof(id) != winapp.TYPEOF_UNDEFINE) {
					if (type == 'BT') {

						var urlOpts = {
							act: 'torrent-info',
							id: id
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								var showDir = Ext.util.Format.ellipsis(json.download_dir, 25);
								showDir = changeToHome(showDir);
								downloadDirectory.setValue(showDir);
								totalSize.setValue(json.total_size);
								createDate.setValue(json.create_date);
								timeElapsed.setValue(json.time_elapsed);
								remainingTime.setValue(json.remaining_time);
								downloaded.setValue(json.downloaded);
								uploaded.setValue(json.uploaded);
								seeds.setValue(json.seeds);
								peers.setValue(json.peers);
								shareRatio.setValue(json.share_ratio);

								winapp.name = json.name;
								winapp.torrentFile = json.torrentFile;
								originTorrent.show();


								downloadSpeed.setValue(record.data.download);
								uploadSpeed.setValue(record.data.upload);
								var length = json.files.length;

								if (length != 0) {
								    showTorrentInfoId = id;
								    infoStore = createInfoStore();
									infoPanel.store = infoStore;
                                    trackerStore = createTrackerStore();
                                    trackerGridPanel.store = trackerStore;
								} else {
								    showTorrentInfoId = 0;
								    infoStore = createInfoStore();
									infoPanel.bindStore(infoStore);
                                    trackerStore = createTrackerStore();
                                    trackerGridPanel.store = trackerStore;
								}
								if (!canShowPanelInfo) {
									canShowPanelInfo = true;
								}
							},
							failure: function (json, opts) {
							    if (typeof (winapp.win) != 'undefined') {
							        if (typeof (winapp.win.el) != 'undefined') {
							            winapp.win.el.unmask();
							        }
							    }
								winapp.showErrorMsgWin('torrent-info', json, winapp.win);
								if (!canShowPanelInfo) {
									canShowPanelInfo = true;
								}
							}
						});
					} else {
						var urlOpts = {
							act: 'torrent-list',
							id: id
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								var index = record.index,
									indexJson = json.files[index],
									showDir = changeToHome(showDir);

								downloadDirectory.setValue(showDir);
								totalSize.setValue(indexJson.total_size);
								createDate.setValue(indexJson.create_date);
								timeElapsed.setValue(AS.ARC.datas.defaultValue);
								remainingTime.setValue(indexJson.remaining_time);
								downloaded.setValue(AS.ARC.datas.defaultValue);
								uploaded.setValue(AS.ARC.datas.defaultValue);
								seeds.setValue(AS.ARC.datas.defaultValue);
								peers.setValue(AS.ARC.datas.defaultValue);
								shareRatio.setValue(AS.ARC.datas.defaultValue);
								downloadSpeed.setValue(record.data.download);
								uploadSpeed.setValue(AS.ARC.datas.defaultValue);
								originTorrent.hide();


								if (!canShowPanelInfo) {
									canShowPanelInfo = true;
								}
							},
							failure: function (json, opts) {
							    if (typeof (winapp.win) != 'undefined') {
							        if (typeof (winapp.win.el) != 'undefined') {
							            winapp.win.el.unmask();
							        }
							    }
								winapp.showErrorMsgWin('torrent-list', json, winapp.win);
								if (!canShowPanelInfo) {
									canShowPanelInfo = true;
								}
							}
						});
					}
				} else {
					setHttpInfo(record);
				}
			} else {
				setHttpInfo(record);
			}
			if (!canShowPanelInfo) {
				canShowPanelInfo = true;
			}
		};
		//-------------------------------------- tab panel: general UI ---------------------------------------------------
		var downloadDirectory = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_DIRECTORY')),
			labelWidth: 150,
			width: 350,
			maxHeight : 25,
			flex: 1
		});

		var totalSize = Ext.create('Ext.form.field.Display', {
			value: '',
			fieldLabel: AS.layout.getIndent(1, _S('DOWNLOAD_CENTER', 'INFO_TOTAL_SIZE')),
			labelWidth: 150,
			width: 500
		});

		var createDate = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.layout.getIndent(1, _S('DOWNLOAD_CENTER', 'INFO_CREATE_DATE')),
			labelWidth: 150,
			width: 500
		});
		//-------------------------------------- tab panel: information UI ---------------------------------------------------
		var timeElapsed = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_TIME_ELAPSED')),
			style: AS.layout.getIndentCss(1),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var remainingTime = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_REMAINING_TIME')),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var downloaded = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('COMMON', 'DOWNLOADED')),
			style: AS.layout.getIndentCss(1),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var uploaded = Ext.create('Ext.form.field.Display', {
			fieldLabel:  AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_UPLOADED')),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var seeds = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('COMMON', 'SEEDS')),
			style: AS.layout.getIndentCss(1),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var peers = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_PEERS')),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var shareRatio = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_SHARE_RATIO')),
			style: AS.layout.getIndentCss(1),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var originTorrent = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_ORIGIN_TORRENT')),
			labelWidth: 150,
			width: 350,
			value: _S('COMMON', 'DOWNLOAD'),
			fieldStyle: 'cursor: pointer; text-decoration: underline;',
			fieldCls: 'hyperlink-string',
			flex: 1,
			hidden: true,
			listeners: {
                afterrender: function (me) {
                	var link = me.inputEl;

                    link.on('click', function () {
						var downloadform = Ext.create('Ext.form.FormPanel', {
							title: '',
							hidden: true,
							items: [{
								xtype: 'filefield'
							}]
						});

						downloadform.form.submit({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, {
								act: 'torrent-get',
								name: winapp.name,
								torrentFile: winapp.torrentFile
							}),
							success: function (f, e) {

							},
							failure: function(form, action){
								var json = Ext.decode(action.response.responseText);

								AS.ARC.util.showMsgWindow({
									5011: _S('DOWNLOAD_CENTER', 'FILE_DOWNLOAD_ERROR'),
									5028: _S('ERROR', 'SPECIFIED_FILE_ID_NOT_FOUND'),
									5303: _S('ERROR', 'INCORRECT_PARAMETER')
								}, json, page.fn.app.win);
							}
						});

						delete downloadform;
                    });
                }
            }
		});

		//-------------------------------------- tab panel: seed UI ---------------------------------------------------
		var downloadSpeed = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_DOWNLOAD_SPEED')),
			style: AS.layout.getIndentCss(1),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});

		var uploadSpeed = Ext.create('Ext.form.field.Display', {
			fieldLabel: AS.ARC.util.fontToBold(_S('DOWNLOAD_CENTER', 'INFO_UPLOAD_SPEED')),
			labelWidth: 150,
			width: 350,
			value: winapp.defaultValue,
			flex: 1
		});
		//-------------------------------------- tab panel: content UI ---------------------------------------------------
		var infoStore;
		var tabInfoSelectIndex = -1;
		var tabSelectedRecord = null;
		var infoSort = 'file_name';
		var infoOrder = 'asc';
		var wantedRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = '';
			var img = '../apps/download-center/images/check.png';
			if (value) {
				result = '<div class="files-wanted-column"><img src="' + img + '" class="files-wanted-icon"></div>';
			}
			return result;
		};

		var sizeRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
			var result = value;
			return result;
		};
		var showFileItemInfoPanel = false;
		var fileNameColumn = Ext.create('Ext.grid.column.Column', {
			dataIndex: 'file_name',
			text: _S('COMMON','NAME'),
			flex: 1,
			minWidth: 200,
			renderer: fileOfTorrentRenderer
		});

		var infoPanel = Ext.create('DownloadCenter.gridPanel', {
            cls: 'center-grid tabpanel-grid',
			itemId: 'bt-grid',
			autoScroll: true,
			border: false,
			resizable: false,
			store: infoStore,
			multiSelect: true,
			scope: this,
			buffered: true,
			height: 150,
			flex: 1,
			//width: 500,
			viewConfig:{
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'}
			},
			columns: [{
				xtype: 'gridcolumn',
				dataIndex: 'file_wanted',
				flex: 0,
				width: 30,
				renderer: wantedRenderer
			},
			fileNameColumn,
			{
				xtype: 'gridcolumn',
				dataIndex: 'file_size',
				text: _S('COMMON','SIZE'),
				flex: 0,
				width: 90,
				renderer: sizeRenderer
			},{
				xtype: 'gridcolumn',
				dataIndex: 'file_downloaded',
				text: _S('COMMON','DOWNLOADED'),
				flex: 0,
				width: 140
			},{
				xtype: 'gridcolumn',
				dataIndex: 'file_percent',
				text: '%',
				flex: 0,
				width: 60
			}],
			listeners: {
				sortchange: function ( ct, column, direction, eOpts ) {
					if (direction !== null) {
						infoSort = column.dataIndex;
						infoOrder = direction.toLowerCase();
					    infoPanel.el.mask(_S('COMMON', 'LOADING'));
						reloadInfoStore();
					}
				},
				itemmousedown: function ( view, record, item, index, e, eOpts ) {
					infoPanel.setSpecialKey(true);
				},
				itemmouseup: function ( view, record, item, index, e, eOpts ) {
					//console.info('itemmouseup');
					infoPanel.setSpecialKey(false);
				},
				select: function( view, record, index, eOpts ) {
					tabInfoSelectIndex = index;
					tabSelectedRecord = record;
				},
				itemdblclick: function ( view, record, item, index, e, eOpts ) {
					tabInfoSelectIndex = index;
					tabSelectedRecord = record;
				},
				itemclick: function ( view, record, item, index, e, eOpts ) {
					tabInfoSelectIndex = index;
					tabSelectedRecord = record;
				},
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
			}
		});
		//-------------------------------------- speed UI ---------------------------------------------------
		var speedStore;
		//create speed chart data store
		initTotal = false;
		var reloadSpeedStore = function(download, upload) {
			var findex = download.indexOf('K');
			var dvalue=0;
			if (findex != -1) {
				dvalue = download.substring(0, findex);
				dvalue = parseInt(trim(dvalue));
			}
			var uvalue = 0;
			if (findex != -1) {
				uvalue = upload.substring(0, findex);
				uvalue = parseInt(trim(uvalue));
			}
			var now = new Date();
			var showDate = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds();
			var totalData = [dvalue, uvalue,  showDate];
			if (totalDLData.length != 0) {
					if (!initTotal) {
						initTotal = true;
						totalDLData.pop();
					}
					var check = totalDLData[totalDLData.length-1][2];
					if (check == showDate) {
						//_D('==');
						//totalDLData.push(totalData);
					} else {
						//_D('!=');
						if (totalDLData.length > 5) {
							//move data
							totalDLData.reverse();
							totalDLData.pop();
							totalDLData.reverse();
						}
						totalDLData.push(totalData);
					}

			} else {
				totalDLData.push(totalData);
				totalDLData.push(totalData);
			}
			var myData = totalDLData;
			var dataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'download'},
					{name: 'upload'},
					{name: 'value'}
				]
			});

			dataStore.loadData(myData);
			speedChart.bindStore(dataStore);
		};
		var createSpeedStore= function() {
			var myData = [
				[0, 0, '0:0:0'],
				[0, 0, '0:0:0']
			];
			var dataStore = new Ext.data.ArrayStore({
				fields: [
					{name: 'download'},
					{name: 'upload'},
					{name: 'value'}
				]
			});

			dataStore.loadData(myData);
			return dataStore;
		};
		speedStore = createSpeedStore();

        var speedChart = Ext.create('Ext.chart.Chart', {
            width: 625,
            height: 200,
            flex: 1,
            animate: true,
            shadow: true,
            theme: 'Category1',
            store: speedStore,
            axes: [{
                title: 'Speed',
                type: 'Numeric',
                position: 'left',
                minimum: 0,
                maximum: 100,
                minorTickSteps: 1,
                grid: {
                    odd: {
                        opacity: 1,
                        fill: '#ddd',
                        stroke: '#bbb',
                        'stroke-width': 0.5
                    }
                }
            }, {
                title: 'Time',
                type: 'Category',
                position: 'bottom',
                fields: ['value']

                //dateFormat: 'H:i:s'
            }],
            series: [

                    {
                        type: 'line',
                        xField: 'value',
                        yField: 'download',
                        highlight: {
                            size: 7,
                            radius: 7
                        },
                        markerConfig: {
                            type: 'cross',
                            size: 4,
                            radius: 4,
                            'stroke-width': 0
                        }
                    }, {
                        type: 'line',
                        xField: 'value',
                        yField: 'upload',
                        highlight: {
                            size: 7,
                            radius: 7
                        },
                        markerConfig: {
                            type: 'cross',
                            size: 4,
                            radius: 4,
                            'stroke-width': 0
                        }
                    }
                ]
                //theme: 'Green'
        });
        
        //---------------------------------------------Tracker UI-------------------------------------------
        var trackerStore;
        var tabTrackSelectIndex = -1;
		var tabSelectedRecord = null;

        var trackerSort = 'tracker_name';
		var trackerOrder = 'ASC';

        var updateTimeRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
			if(value === 0) {
                value = '';
                return value;
            } else {
                var time = new Date(value*1000); 
                result = time.toLocaleString();
    			return result;
            }
		};
        
        var trackerNameRenderer = function(value, metaData, record, rowIndex, colIndex, store) {
            var result = value;
            metaData.tdAttr = 'data-qtip="' + value + '"';
            return result;
        };

        var btnAddTrack = Ext.create(Ext.button.Button, {
            text: _S('COMMON', 'ADD'),
            handler: function() {
                isFirstOpen = true; //set 'true' to stop unmask action
                trackAdd();
            }
        });
        
        var trackAdd = function() {
            
            var addTrackwin = Ext.create(Ext.form.field.TextArea, {
                height: 120,
                width: 450,
				cls: 'dc-add-tracker-win-text',
                autoScroll: true,
                fieldLabel: _S('DOWNLOAD_CENTER','INFO_URLS'),
                labelWidth: 50,
                listeners: {
                    change: function( addTrackwin, newValue, oldValue, eOpts ) {
                        var urlList = [];
                        var errorCount = 0;
                        if (newValue != '') {
                            var temp = newValue.split('\n');
                            var checkIndex= -1;
                            for (var i=0; i< temp.length; i++) {
                                var tempItem = temp[i];
                                if (tempItem != '') {
                                    checkIndex = tempItem.indexOf(':');
                                    if (checkIndex != -1) {
                                        var check = tempItem.substring(0, checkIndex);
                                        check = check.toLowerCase().trim();
                                        if (check === 'http' || check === 'https' || check === 'udp') {
                                            urlList.push(tempItem);
                                        } else {
                                            errorCount++;
                                        }
                                    } else {
                                        errorCount++;
                                    }
                                }
                            }
                            if (errorCount != 0) {
                                btnAddOk.setDisabled(true);
                            } else {
                                btnAddOk.setDisabled(false);
                            }
                        } else {
                            btnAddOk.setDisabled(true);
                        }
                    }
                }
            });
                        
            var btnAddOk = Ext.create(Ext.button.Button, {
                text: _S('COMMON', 'OK'),
                disabled: true,
                handler: function() {
					var trackerAddedWinUrls = addTrackwin.value.split('\n').join(','),
                    	urlOpts = {
                        	act: 'tracker-add',
                        	id: showTorrentInfoId,
                        	tracker: trackerAddedWinUrls
                    	};
                    
                    AS.ARC.ajax({
                        url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
                        method: 'post',
                        success: function (json, opts) {
                            isFirstOpen = false;
                            win.close();
                        },
                        failure: function (json, opts) {
                            if (typeof(win) != 'undefined') {
                                if (typeof(win.el) != 'undefined') {
                                    win.el.unmask();
                                }
                            }
                            winapp.showErrorMsgWin('tracker-add', json, winapp.addTrackwin);
                        }
                    });
                }
            });
            
            var win = Ext.create('AS.ARC.subWindow', {
                title: _S('DOWNLOAD_CENTER', 'ADD_TRACKER'),
                width: 500,
                height: 250,
                parentWin: winapp.win,
                fbar: [
                    btnAddOk,
                    {
                        text: _S('COMMON', 'CANCEL'),
                        handler: function() {
                            isFirstOpen = false;
                            win.close();
                        }
                }],
                items: [{
                    xtype: 'asPanelTop20',
                    height: 200,
                    items: [{
                        xtype: 'container',
                        margin: '0, 0, 5, 0',
                        items: [addTrackwin]
                    }]
                }],
                listeners: {
                    beforerender: function() {
                        addTrackwin.setValue('');
                    }
                }
            }).show();
        };
        
        var btnDeleteTrack = Ext.create(Ext.button.Button, {
            text: _S('COMMON', 'REMOVE'),
            disabled: true,
            handler: function() {
                trackDelete();
            }
        });

        var trackDelete = function() {
            var select = [];
            
            for(var i = 0; i < trackerGridPanel.getSelectionModel().selected.items.length; i++) {
                select[i] = trackerGridPanel.getSelectionModel().selected.items[i].raw.tracker_id;
            }
            
            var recordId = select.toString();
            trackerGridPanel.el.mask(_S('COMMON', 'LOADING'));
            var urlOpts = {
                act: 'tracker-remove',
                id: showTorrentInfoId,
                tracker_id: recordId
            };
            
            AS.ARC.ajax({
                url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
                method: 'post',
                success: function (json, opts) {
                    reloadTrackerStore();
                    trackerGridPanel.el.unmask();
                    btnDeleteTrack.setDisabled(true);
                },
                failure: function (json, opts) {
                    winapp.showErrorMsgWin('tracker-remove', json, winapp.win);
                    trackerGridPanel.el.unmask();
                    isFirstOpen = 1;
                }
            });
        };
        
        var trackerGridPanel = Ext.create('DownloadCenter.gridPanel', {
            itemId: 'track-grid',
            cls: 'center-grid tabpanel-grid dc-tracker-grid',
            autoScroll: true,
			border: false,
			resizable: false,
			store: winapp.trackerStore,
			multiSelect: true,
			scope: this,
			buffered: true,
			// height: tavbPanelHeight - 93,
			flex: 1,
            viewConfig: {
                onStoreLoad: Ext.emptyFn,
                focusRow: Ext.emptyFn,
                loadMask: false,
                style: {
                    overflow: 'auto',
                    overflowX: 'hidden'
                }
            },
            columns: [{
                xtype: 'gridcolumn',
                dataIndex: 'tracker_name',
                text: _S('DOWNLOAD_CENTER', 'INFO_URLS'),
                flex: 3,
                renderer: trackerNameRenderer
            }, {
                xtype: 'gridcolumn',
                dataIndex: 'tracker_stats',
                text: _S('COMMON', 'STATUS'),
                flex: 1
            }, {
                xtype: 'gridcolumn',
                dataIndex: 'tracker_next_update',
                text: _S('DOWNLOAD_CENTER', 'NEXT_UPDATE'),
                flex: 2,
                renderer: updateTimeRenderer
            }, {
                xtype: 'gridcolumn',
                dataIndex: 'seeds',
                text: _S('COMMON', 'SEEDS'),
                flex: 1
            }, {
                xtype: 'gridcolumn',
                dataIndex: 'peers',
                text: _S('COMMON', 'PEER'),
                flex: 1
            }],
            listeners: {
                sortchange: function ( ct, column, direction, eOpts ) {
                    trackerSort = column.dataIndex;
					trackerOrder = direction;
                },
                selectionchange: function () {
                    winapp.scrollTop = trackerGridPanel.view.getEl().dom.scrollTop;
                    var sm = trackerGridPanel.getSelectionModel(),
                        selections = sm.getSelection();
                
                    // for reload
                    if (selections.length > 0) {
                        winapp.trackerSelections = selections;
                    }
                },
                select: function( view, record, index, eOpts ) {
                    btnDeleteTrack.setDisabled(false);
                    tabTrackSelectIndex = index;
                    tabSelectedRecord = record;
                },
                itemclick: function( trackerGridPanel, record, item, index, e, eOpts ) {
                    tabTrackSelectIndex = index;
                    tabSelectedRecord = record;
                },
                itemcontextmenu: function(grid, record, item, index, event) {
                    event.stopEvent();
                    x = event.browserEvent.clientX;
                    y = event.browserEvent.clientY;
                    trackerMenu.showAt([x, y]);
                    tabTrackSelectIndex = index;
                    tabSelectedRecord = record;
                },
				afterrender: function (Grid) {
					Ps.initialize(Grid.body.dom);
					Ps.update(Grid.body.dom);
				}
            }
        });
		
        var trackerMenu = Ext.create('Ext.menu.Menu', {
            scope: this,
			items: [{
                text: _S('COMMON','ADD'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'add.png'),
				handler: function() {
					trackAdd();
				}
            }, {
                text: _S('COMMON','REMOVE'),
				icon: AS.ARC.util.getThemeIcon('../apps/download-center/images/menu/', 'clear.png'),
				handler: function() {
					trackDelete();
				}
			}]
		});
        //-------------------------------------- tab panel UI general, information, speed, content---------------------------------------------------

        var tabPanel = Ext.create('Ext.tab.Panel', {
            activeTab: 0,
            flex: 1,
            region: 'south',
            border: false,
            items: [{
                    xtype: 'panel',
                    itemId: 'transInfo',
                    border: false,
					cls: 'dc-show-tab-info',
                    flex: 1,
                    title: _S('DOWNLOAD_CENTER', 'INFO_TRANSFER_INFORMATION'),
                    items: [{
                        type: 'asFlexbox',
                        border: false,
                        items: [
                            timeElapsed,
                            downloadDirectory
                        ]
                    }, {
                        type: 'asFlexbox',
                        border: false,
                        items: [
                            downloadSpeed,
                            uploadSpeed
                        ]
                    }, {
                        type: 'asFlexbox',
                        border: false,
                        items: [
                            seeds,
                            peers
                        ]
                    }, {
                        type: 'asFlexbox',
                        border: false,
                        items: [
                            downloaded,
                            uploaded
                        ]
                    }, {
                        type: 'asFlexbox',
                        border: false,
                        items: [
                            shareRatio,
                            originTorrent
                        ]
                    }]
                }, {
                    xtype: 'panel',
                    border: false,
                    flex: 1,
                    title: _S('DOWNLOAD_CENTER', 'INFO_CONTENT'),
                    items: [infoPanel]
                }, {
                    xtype: 'panel',
                    itemId: 'trackPanel',
                    hidden: true,
                    title: _S('DOWNLOAD_CENTER', 'TRACKER'),
                    border: false,
                    flex: 1,
                    items: [{
                            xtype: 'container',
                            border: false,
                            margin: '15 0 0 13',
                            items: [
                                btnAddTrack,
                                btnDeleteTrack
                                // trackerGridPanel
                            ]
                        },
                        trackerGridPanel
                    ]
                }
            ]
        });

		var btContentPanel = Ext.create('Ext.panel.Panel', {
			flex: 1,
			layout: 'border',
			items: [
			btPanel,
			{
				xtype: 'panel',
				region: 'south',
				border: true,
                dockedItems: [{
    				xtype: 'panel',
    				dock: 'top',
    				border: false,
    				height: 32,
    				layout:'hbox',
                    cls: 'totalContainer',
    				items: [
    				totalDLInfo,
    				{
    					xtype: 'tbfill',
    				}, {
    					xtype: 'container',
                        width: 45,
                        cls: 'expandContainer',
                        items: {
                            xtype: 'container',
                            itemId: 'expand',
                            cls: 'expandImg'
                        }
    				}],
    				listeners:{
    					afterrender: function( toolbar, eOpts ) {
                            var btPanelHeight = btPanel.getHeight();
                            btContentPanel.items.items[1].setHeight(260);
                            btPanel.setHeight(btPanelHeight - 260);
                            btContentPanel.items.items[1].dockedItems.items[0].items.items[2].items.get('expand').addCls('expandImg-expand');
    						Ext.fly(this.el).on('click', function(e, t) {
    							if (btContentPanel.items.items[1].getHeight() === 32) {
                                    btContentPanel.items.items[1].dockedItems.items[0].items.items[2].items.get('expand').addCls('expandImg-expand');
    								btContentPanel.items.items[1].setHeight(260);
                                    btPanel.setHeight(btPanelHeight - 260);
    							} else {
    								btContentPanel.items.items[1].dockedItems.items[0].items.items[2].items.get('expand').removeCls('expandImg-expand');
                                    btContentPanel.items.items[1].setHeight(32);
    								btPanel.setHeight(btPanelHeight + 278);
    							}
    						});
    					}
    				}
    			}],
    			items:[
    				tabPanel
    			]
			}]
		});

		var mainPanel = Ext.create('Ext.panel.Panel', {
			autoScroll: true,
			activeItem: 0,
			flex: 2,
			region: 'center',
			broder: false,
			layout: 'card',
			items:[
			btContentPanel,
			searchResultPanel,
			rssFeedGridPanel,
			rssFeedItemGridPanel
			]
		});

		//========================================================= DOWNLOAD CENTER WINDOW UI=========================================================

		//-------------------------------------- filter btpanel key ---------------------------------------------------
		var filterBTText = Ext.create('Ext.form.field.Text', {
            cls: 'filterText',
			enableKeyEvents: true,
			checkChangeBuffer: AS.ARC.config.keyBuffer,
			listeners: {
                focus: function(field, eOpts) {
                    downloadFilterImg.el.dom.classList.add('download-filter-focused');
				},
                blur: function(field){
                    downloadFilterImg.el.dom.classList.remove('download-filter-focused');
                },
				specialkey: function(field, e){
                    // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                    // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                    if (e.getKey() == e.ENTER) {
						var key = filterBTText.getValue();

						if (key != '') {
							createBTKeyFilter(key);
						} else {
							filterKey = '';
							BTStoreFilter = null;
						}
						reloadBTStore();
                    }
                },
				change: function( field, newValue, oldValue, eOpts ) {

					if (newValue != oldValue) {
						if (newValue != '') {
							createBTKeyFilter(newValue);
						} else {
							filterKey = '';
							BTStoreFilter = null;
						}
						reloadBTStore();
					}

				}
			}
		});

		var searchImg = Ext.create(Ext.container.Container, {
            cls: 'searchImg',
            border: false,
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						if (!winapp.win.el.isMasked()) {
						    if (searchKey.getValue() != '') {
						        if (canSearch) {
						            goSearch();
						        }
							}
						}
					});
				}
			}
		});
		//--------------------------------------count string px

		//-------------------------------------- west panel UI ---------------------------------------------------
		var searchContainer = Ext.create(Ext.container.Container, {
			height: 48,
			minHeight: 48,
            cls: 'searchContainer',
			width: winapp.WESTPANEL_WIDTH,
			layout: {
				align: 'stretch',
				type: 'hbox'
			},
			items: [
                searchImg, 
                searchKey
            ]
		});
		var searchMainPanel = Ext.create(Ext.panel.Panel, {
			minHeight: 188,
			cls: 'download-center-search_main_panel',
			// region: 'center',
			layout: 'vbox',
			border: false,
			width: winapp.WESTPANEL_WIDTH,
			items: [
				searchContainer,
				searchPanel
			]
		});

		var westPanel = Ext.create('Ext.panel.Panel', {
			region: 'west',
			hideCollapseTool: true,
			layout: 'vbox',
			border: false,
			width: winapp.WESTPANEL_WIDTH,
			autoScroll: true,
			items: [
				downloadPanel,
				searchMainPanel,
				rssPanel
			],
			listeners: {
				collapse: function( p, eOpts ) { },
				expand: function( p, eOpts ) { },
				resize: function (com, adjWidth, adjHeight, eOpts ) {
					downloadPanel.setWidth(adjWidth);
					searchMainPanel.setWidth(adjWidth);
					rssPanel.setWidth(adjWidth);

					var changeHeight = (adjHeight - 170) / 2;
					searchMainPanel.setHeight(changeHeight)
					rssPanel.setHeight(changeHeight);
				}
			}
		});

		//-------------------------------------- download toolbar  UI ---------------------------------------------------
		var downloadAddImg = Ext.create(Ext.container.Container, {
			title: 'clearButton',
            cls: 'download-add',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openAddWin();
					});
					downloadAddImg.el.dom.title = _S('COMMON', 'ADD');
				}
			}
		});

		var downloadDeleteImg = Ext.create(Ext.container.Container, {
            cls: 'download-delet',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_BT) {
							openDeleteConfirmWin(winapp.CONFIRM_TYPE_DOWNLOAD_RESULT);
						}
					});
                    
                    if (focus == winapp.FOCUS_BT) {
                        var select = btPanel.getSelectionModel().getSelection();
                        if (select.length === 0) {
                            downloadDeleteImg.addCls('download-disable');
                        } else {
                            downloadDeleteImg.removeCls('download-disable');
                        }
                    } else {
                        downloadDeleteImg.addCls('download-disable');
                    }
					downloadDeleteImg.el.dom.title = _S('COMMON', 'DELETE');
				}
			}
		});

		var downloadStartImg = Ext.create(Ext.container.Container, {
            cls: 'download-start',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_BT) {
							doStart();
						}
					});
                    if (focus == winapp.FOCUS_BT) {
                        var select = btPanel.getSelectionModel().getSelection();
                        if (select.length === 0) {
                            downloadStartImg.addCls('download-disable');
                        } else {
                            downloadStartImg.removeCls('download-disable');
                        }
                    } else {
                        downloadStartImg.addCls('download-disable');
                    }
					downloadStartImg.el.dom.title = _S('COMMON', 'START');
				}
			}
		});

		var downloadStopImg = Ext.create(Ext.container.Container, {
            cls: 'download-stop',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_BT) {
							doStop();
						}
					});
                    if (focus == winapp.FOCUS_BT) {
                        var select = btPanel.getSelectionModel().getSelection();
                        if (select.length === 0) {
                            downloadStopImg.addCls('download-disable');
                        } else {
                            downloadStopImg.removeCls('download-disable');
                        }
                    } else {
                        downloadStopImg.addCls('download-disable');
                    }
					downloadStopImg.el.dom.title = _S('COMMON', 'STOP');
				}
			}
		});

		var downloadUpImg = Ext.create(Ext.container.Container, {
            cls: 'download-up',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {


					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_BT) {
							var select = btPanel.getSelectionModel().getSelection();
							if (select.length != 0) {
								if (select[0].data.type === 'BT' && select[0].data.status === 'Queued')
									doDirection('up');
							}
						}
					});
                    if (focus == winapp.FOCUS_BT) {
                        var select = btPanel.getSelectionModel().getSelection();
                        if (select.length === 0) {
                            downloadUpImg.addCls('download-disable');
                        } else {
							if (select[0].data.type !== 'BT' || select[0].data.status !== 'Queued')
                            	downloadUpImg.removeCls('download-disable');
                        }
                    } else {
                        downloadUpImg.addCls('download-disable');
                    }
					downloadUpImg.el.dom.title = _S('DOWNLOAD_CENTER', 'UP');
				}
			}
		});

		var downloadDownImg = Ext.create(Ext.container.Container, {
            cls: 'download-down',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_BT) {
							var select = btPanel.getSelectionModel().getSelection();
							if (select.length != 0) {
								if (select[0].data.type === 'BT' && select[0].data.status === 'Queued')
									doDirection('down');
							}
						}
					});
                    if (focus == winapp.FOCUS_BT) {
                        var select = btPanel.getSelectionModel().getSelection();
                        if (select.length != 0) {
                            if (select[0].data.type === 'BT' && select[0].data.status === 'Queued')
                                downloadDownImg.removeCls('download-disable');
                        } else {
                            downloadDownImg.addCls('download-disable');
                        }
                    } else {
                        downloadDownImg.addCls('download-disable');
                    }
					downloadDownImg.el.dom.title = _S('DOWNLOAD_CENTER', 'DOWN');
				}
			}
		});

		var downloadPrefImg = Ext.create(Ext.container.Container, {
            cls: 'download-pre',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openPreferenceWin();
					});
					downloadPrefImg.el.dom.title = _S('COMMON', 'PREFERENCES');
				}
			}
		});

		var downloadFilterImg = Ext.create(Ext.container.Container, {
            cls: 'download-filter',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						var key = filterBTText.getValue();

						if (key != '') {
							createBTKeyFilter(key);
						} else {
							BTStoreFilter = null;
							filterKey = '';
						}
						reloadBTStore();
					});
					downloadFilterImg.el.dom.title = _S('DOWNLOAD_CENTER', 'FILTER');
				}
			}
		});
		var filterClearImg = Ext.create('Ext.Img', {
			width: 25,
			height: 20,
			flex: 0,
			src: '../apps/download-center/images/search_clean.png',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						filterClearImg.setSrc('../apps/download-center/images/search_clean_press.png');
						filterBTText.setValue('');

						setTimeout(function(){
						filterClearImg.setSrc('../apps/download-center/images/search_clean.png');
						},200);
					});
					Ext.fly(this.el).on('mouseover', function(e, t) {
						filterClearImg.setSrc('../apps/download-center/images/search_clean_over.png');
					});
					Ext.fly(this.el).on('mouseout', function(e, t) {
						filterClearImg.setSrc('../apps/download-center/images/search_clean.png');
					});

					filterClearImg.el.dom.title = _S('DOWNLOAD_CENTER', 'CLEAR');
				}
			}
		});
		var downloadTBar = Ext.create(Ext.container.Container, {
			region: 'north',
			height: 40,
			flex: 1,
			layout: 'hbox',
			items: [
			downloadAddImg,
			downloadDeleteImg,
			downloadStartImg,
			downloadStopImg,
			downloadUpImg,
			downloadDownImg,
			downloadPrefImg,
			{
				xtype: 'tbfill'
			},
            downloadFilterImg,
            filterBTText
			]
		});
		//-------------------------------------- search result toolbar  UI ---------------------------------------------------

		var searchDownloadImg = Ext.create(Ext.container.Container, {
			cls: 'search-download',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_SEARCHRESULT) {
							checkRunSelectOpenTorrentInfo(searchResultPanel, 'search', searchResultRecord);
						}
					});
					searchDownloadImg.el.dom.title = _S('COMMON', 'DOWNLOAD');
				}

			}
		});
		var searchOpenImg = Ext.create(Ext.container.Container, {
            cls: 'search-open',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_SEARCHRESULT) {
							openWindow(searchResultRecord.data.link, searchResultRecord.data.title);
						}
					});
					searchOpenImg.el.dom.title = _S('DOWNLOAD_CENTER', 'MENU_OPEN');
				}
			}
		});
		var searchPrefImg = Ext.create(Ext.container.Container, {
            cls: 'search-pref',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openPreferenceWin();
					});
					searchPrefImg.el.dom.title = _S('COMMON', 'PREFERENCES');
				}
			}
		});
		var searchStoreFilter = null;

		var reloadSearchType = function(key) {

			var urlOpts = {
				act: 'torrent-search-category',
				query: key
			};

			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					var Datas = new Array();
					var category;
					for (var i=0; i< json.items.length; i++) {
						category = json.items[i];
						Datas.push(category);
					}
					reCreateSearchType();
					var storeData = [
						[_S('COMMON', 'ALL_CATEGORIES'), 'all']
					];
					for (var i=0; i< Datas.length; i++) {
						item = [Datas[i], Datas[i]];
						storeData.push(item);
					}
					var dataStore = new Ext.data.ArrayStore({
						fields: ['display', 'value'],
						data: storeData
					});

					dataStore.load();
					searchType.bindStore(dataStore);
				},
				failure: function (json, opts) {

				}
			});

		};

		var initSearchType = function(key) {
			testKey = key;
			var urlOpts = {
				act: 'torrent-search-category',
				query: key
			};

			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(winapp.SearchUrl, urlOpts),
				method: 'post',
				success: function (json, opts) {
					reCreateSearchType();
					setTimeout(function() {
						if (winapp.app.win.isDestroyed) {
							return false;
						}
						var Datas = new Array();
						var category;
						for (var i=0; i< json.items.length; i++) {
							category = json.items[i];
							Datas.push(category);
						}

						var storeData = [
							[_S('COMMON', 'ALL_CATEGORIES'), 'all']
						];
						for (var i=0; i< Datas.length; i++) {
							item = [Datas[i], Datas[i]];
							storeData.push(item);
						}

						var dataStore = new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: storeData
						});

						var store = searchType.getStore();
						store.removeAll();
						var records = dataStore.getRange();

						var length = records.length;
						for (var i=0; i< length; i++) {
							var item = dataStore.getAt(i);
							item.data.value = records[i].data.value;
							store.add(dataStore.getAt(i));
						}
					}, 1000);
				},
				failure: function (json, opts) {

				}
			});
		};

		var searchType = Ext.create(Ext.form.ComboBox, {
			width: 200,
			margin: '2, 10, 0, 0',
			store: new Ext.data.ArrayStore({
				fields: ['display', 'value'],
				data: [
					[_S('COMMON', 'ALL_CATEGORIES'), 'all']
				]
			}),
			displayField: 'display',
			valueField: 'value',
			editable: false,
			scope: this,
			listeners: {
				render: function (combo, eOpts) {
					this.select('all');
				},
				change: function(field, newValue, oldValue, eOpts) {
					if (typeof(oldValue) !== 'undefined') {
						if (field.getValue() === 'all') {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						} else {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						}
					}
				}
			}
		});
		var searchfilterKey = '';
		var filterSearchText = Ext.create('Ext.form.field.Text', {
			cls: 'filterText searchfilterText',
			enableKeyEvents: true,
			checkChangeBuffer: AS.ARC.config.keyBuffer,
			listeners: {
                focus: function(field, eOpts) {
                    searchFilterImg.el.dom.classList.add('download-filter-focused');
				},
                blur: function(field){
                    searchFilterImg.el.dom.classList.remove('download-filter-focused');
                },
				specialkey: function(field, e){
                    // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                    // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                    if (e.getKey() == e.ENTER) {
						if (searchType.getValue() != 'all') {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						} else {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						}
                    }
                },
				change: function( field, newValue, oldValue, eOpts ) {
					if (winapp.isChangeSearchKeywordResult) {
						winapp.isChangeSearchKeywordResult = false;
						return;
					}

					if (newValue != oldValue) {
						if (searchType.getValue() != 'all') {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						} else {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						}
					}
				}
			}
		});
		var searchFilterImg = Ext.create(Ext.container.Container, {
            cls: 'download-filter',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						if (searchType.getValue() != 'all') {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						} else {
							winapp.isRefreshResultPanel = true;
							winapp.isNeedToReloadSearchResultPagingBar = true;
							reloadSearchResultStore(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						}
					});

					searchFilterImg.el.dom.title = _S('DOWNLOAD_CENTER', 'FILTER');

				}
			}
		});
		var searchCategoryContainer = Ext.create(Ext.container.Container, {
            cls: 'searchCategory',
			items: [
				searchType
			]
		});
		var searchClearImg = Ext.create('Ext.Img', {
			width: 25,
			height: 20,
			flex: 0,
			src: '../apps/download-center/images/search_clean.png',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						searchClearImg.setSrc('../apps/download-center/images/search_clean_press.png');
						filterSearchText.setValue('');

						if (searchType.getValue() != 'all') {
							loadCategorySearchResult(searchRecord.data.search_id, searchRecord.data.query, searchType.getValue(), filterSearchText.getValue());
						} else {
							searchStoreFilter = null;
							searchfilterKey = '';
							loadCategorySearchResult(searchRecord.data.search_id, searchRecord.data.query, '', filterSearchText.getValue());
						}
						setTimeout(function(){
						searchClearImg.setSrc('../apps/download-center/images/search_clean.png');
						},200);
					});
					Ext.fly(this.el).on('mouseover', function(e, t) {
						searchClearImg.setSrc('../apps/download-center/images/search_clean_over.png');
					});
					Ext.fly(this.el).on('mouseout', function(e, t) {
						searchClearImg.setSrc('../apps/download-center/images/search_clean.png');
					});
					searchClearImg.el.dom.title = _S('DOWNLOAD_CENTER', 'CLEAR');
				}
			}
		});
		var searchTBar = Ext.create('AS.ARC.panelToolbarTop', {
            cls: 'TBar-default',
			region: 'north',
			height: 40,
			layout: 'hbox',
			hidden: true,
			items: [
			searchDownloadImg,
			searchOpenImg,
			searchPrefImg,
			{
				xtype: 'tbfill'
			},
			searchCategoryContainer,
            searchFilterImg,
            filterSearchText
			]
		});
		//-------------------------------------- rss toolbar  UI ---------------------------------------------------

		var rssAddImg = Ext.create(Ext.container.Container, {
            cls: 'download-add',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openAddRss();
					});
					rssAddImg.el.dom.title = _S('COMMON', 'ADD');
				}
			}
		});

		var rssDeleteImg = Ext.create(Ext.container.Container, {
            cls: 'download-delet',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_RSSFEEDGRID) {
							openDeleteConfirmWin(winapp.CONFIRM_TYPE_RSS_FEED_PANEL);
						}
					});if (focus == winapp.FOCUS_RSSFEEDGRID) {
                        var select = rssFeedGridPanel.getSelectionModel().getSelection();
                        if (select.length != 0) {
                            rssDeleteImg.removeCls('download-disable');
                        } else {
                            rssDeleteImg.addCls('download-disable');
                        }
                    } else {
                        rssDeleteImg.addCls('download-disable');
                    }
					rssDeleteImg.el.dom.title = _S('COMMON', 'DELETE');
				}
			}
		});

		var rssEditImg = Ext.create(Ext.container.Container, {
            cls: 'rss-erit',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {

				    Ext.fly(this.el).on('click', function (e, t) {
						if (focus == winapp.FOCUS_RSSFEEDGRID) {
							openEditRss();
						}
					});
                    if (focus == winapp.FOCUS_RSSFEEDGRID) {
                        var select = rssFeedGridPanel.getSelectionModel().getSelection();
                        if (select.length != 0) {
                            rssEditImg.removeCls('download-disable');
                        } else {
                            rssEditImg.addCls('download-disable');
                        }
                    } else {
                        rssEditImg.addCls('download-disable');
                    }
					rssEditImg.el.dom.title = _S('COMMON', 'EDIT');
				}
			}
		});

		var rssUpdateImg = Ext.create(Ext.container.Container, {
            cls: 'rss-update',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						updateRss();
					});
					rssUpdateImg.el.dom.title = _S('COMMON', 'UPDATE');
				}
			}
		});

		var rssManagerImg = Ext.create(Ext.container.Container, {
            cls: 'rss-manager',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						var urlOpts = {
							act: 'rss-filter-list'
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								openFilterManager(json);
							},
							failure: function (json, opts) {
								winapp.showErrorMsgWin('rss-filter-list', json, winap.win);
							}
						});
					});
					rssManagerImg.el.dom.title = _S('DOWNLOAD_CENTER', 'TITLE_FILTER_MANAGER');
				}
			}
		});
		//var rssTBar = Ext.create('Ext.toolbar.Toolbar', {
		var rssTBar = Ext.create('AS.ARC.panelToolbarTop', {
            cls: 'TBar-default',
			region: 'north',
			height: 40,
			layout: 'hbox',
			hidden: true,
			items: [
			rssAddImg,
			rssDeleteImg,
			rssEditImg,
			rssManagerImg
			]
		});
		//-------------------------------------- rss item toolbar  UI ---------------------------------------------------

		var rssItemAddImg = Ext.create(Ext.container.Container, {
            cls: 'download-add',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openAddRss();
					});
					rssItemAddImg.el.dom.title = _S('COMMON', 'ADD');
				}
			}
		});
		var rssDownloadImg = Ext.create(Ext.container.Container, {
            cls: 'search-download',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						if (focus == winapp.FOCUS_RSSFEEDITEM) {
							winapp.isAddRSSItemUrlAction = true;
							addUrlToOpenTorrentInfo(rssFeedItemRecord.data.url, rssFeedItemRecord.data.title);
						}
					});

                    if (focus == winapp.FOCUS_RSSFEEDITEM) {
                        var select = rssFeedItemGridPanel.getSelectionModel().getSelection();
                        if (select.length != 0) {
                            rssDownloadImg.removeCls('download-disable');
                        } else {
                            rssDownloadImg.addCls('download-disable');
                        }
                    } else {
                        rssDownloadImg.addCls('download-disable');
                    }
					rssDownloadImg.el.dom.title = _S('COMMON', 'DOWNLOAD');
				}
			}
		});
		var rssOpenImg = Ext.create(Ext.container.Container, {
            cls: 'search-open',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						openWindow(rssFeedItemRecord.data.link, rssFeedItemRecord.data.title);
					});

                    if (focus == winapp.FOCUS_RSSFEEDITEM) {
                        var select = rssFeedItemGridPanel.getSelectionModel().getSelection();

                        if (select.length != 0) {
                            rssOpenImg.removeCls('download-disable');
                        } else {
                            rssOpenImg.addCls('download-disable');
                        }
                    } else {
                        rssOpenImg.addCls('download-disable');
                    }
					rssOpenImg.el.dom.title = _S('DOWNLOAD_CENTER', 'MENU_OPEN');
				}
			}
		});
		var rssItemUpdateImg = Ext.create(Ext.container.Container, {
            cls: 'rss-update',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {
						updateRss();
					});
					rssItemUpdateImg.el.dom.title = _S('COMMON', 'UPDATE');
				}
			}
		});

		var rssItemManagerImg = Ext.create(Ext.container.Container, {
            cls: 'rss-manager',
			scope: this,
			listeners: {
				render: function( com, eOpts ) {
					Ext.fly(this.el).on('click', function(e, t) {

						var urlOpts = {
							act: 'rss-filter-list'
							//id: rssRecord.data.id
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								openFilterManager(json);
							},
							failure: function (json, opts) {
								winapp.showErrorMsgWin('rss-filter-list', json, winap.win);
							}
						});
					});
					rssItemManagerImg.el.dom.title = _S('DOWNLOAD_CENTER', 'TITLE_FILTER_MANAGER');
				}
			}
		});

		var rssItemTBar = Ext.create('AS.ARC.panelToolbarTop', {
			region: 'north',
			height: 40,
			layout: 'hbox',
			hidden: true,
			items: [
			rssItemAddImg,
			rssDownloadImg,
			rssOpenImg,
			rssItemUpdateImg,
			rssItemManagerImg
			]
		});
		//-------------------------------------- toolbar container  UI ---------------------------------------------------
		var toolBarContainer = Ext.create('Ext.container.Container', {
			region: 'north',
			layout: 'card',
			activeItem: winapp.TOOLBAR_INDEX_DOWNLOAD,
			items:[
			downloadTBar,
			searchTBar,
			rssTBar,
			rssItemTBar
			]
		});

		/*
        @ Change to correct home folder path 
        @ if select 'Home' folder, give the correct path and return
        */
        var changeHomeFolder = function(folderName) {
			var homeFolder = winapp.HOME_FOLDER_ARRAY,
				name = [],
				rootFolder = '';

			name = folderName.split('/');
			rootFolder = name[1];

			if (rootFolder === 'home' || rootFolder === 'Home') {
				if (name.length > 2) {
					var homePath = homeFolder;
					for (var i = 2; i < name.length; i++) {
						homePath = homePath + '/' + name[i];
					}

					return homePath;
				} else {
					return homeFolder;
				}
            } else {
                return folderName;
            }
        };
        /*
        @ Change home folder name
        @ Home: real name is '/home/(owner)/subfolder..' , it has to transfor '/Home/subfolder..'
        */
        var changeToHome = function(folderName) {
			if (!folderName) return;
            var name =  [];
            name = folderName.split('/');
            if(name[1] === 'home' || name[1] === 'Home') {
				if(name.length > 3) {
					var homePath = '/Home';
					for(var i = 3; i < name.length; i++) {
						homePath = homePath + '/' + name[i];
					}
					return homePath;
				} else return '/Home';
            } else return folderName;
        };

		var isFirstOpen = false;

		var firstOpen = function() {
            isFirstOpen = true;

			var btnOk = Ext.create('Ext.button.Button', {
					text: _S('COMMON', 'OK'),
					handler: function() {
						isFirstOpen = false;

                        var firstDir = changeHomeFolder(savePath.getValue());

						var urlOpts = {
							act: 'set-user-initial-pref',
							default_dl_dir: firstDir,
							enable_auto_remove: false,
							enable_watch: false,
							watch_dir: firstDir,
							ignore_other_user: false
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
							    if (typeof(win) != 'undefined') {
							        if (typeof(win.el) != 'undefined') {
							            win.el.unmask();
							        }
							    }
							},
							failure: function (json, opts) {
							    if (typeof(win) != 'undefined') {
							        if (typeof(win.el) != 'undefined') {
							            win.el.unmask();
							        }
								}
								winapp.showErrorMsgWin('set-user-initial-pref', json, winapp.win);
							}
						});
						win.close();
					}
			});

			var saveBrowse = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'BROWSE'),
				flex: 0,
				handler: function() {
					var fs = Ext.create('DownloadCenter.treeSelector', {
						parentWin: win,
						objectPath: savePath
					});
					fs.win.show();
				}
			});

			var pathValue = '',
                folderArray = [],
                count = 0;
                
            var info = Ext.create(Ext.form.field.Display, {
                value: _S('ERROR', 'NO_ACCESS_RIGHT_SHARE_FOLDERS')
            });
            
            var msgWin = new AS.ARC.msgWindow({
                title: _S('COMMON', 'WARNING'),
                parentWin: win,
                scope: this,
                iconType: 'warning',
                fbar: [{
                    text: _S('COMMON', 'OK'),
                    handler: function () {
                        win.el.unmask();
                        msgWin.close();
                        winapp.win.close();
                    }
                }],
                asItems: [info]
            });
                
            AS.ARC.ajax({
                url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', {
        			act: 'file_list',
        			path: 'share_folders',
        			showhome: true
        		}),
                method: 'post',
                success: function (json, opts) {
                    if(json.data.length !== 0) {
                        for(count = 0; count < json.data.length; count ++) {
                           if(!winapp.isReadOnly(json.data[count].access_permission)) {
                               folderArray[count] = json.data[count].filename;
                           }
                       }

                        if (folderArray.indexOf('Download') !== -1) {
                            savePath.setValue('/Download');
                        } else {
                            if (folderArray.indexOf('Home') !== -1) {
                                savePath.setValue('/Home');
                            } else {
                                savePath.setValue('/'+folderArray[0]);
                            }
                        }
                    } else {
                        win.el.mask();
                        msgWin.show();
                    }
                },
                failure: function (json, opts) {
                }
            });
            
            var savePath = Ext.create('Ext.form.field.Text',{
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE','HF00011'),
				width: 330,
				margin: '0, 5, 0, 5'
			});

			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('DOWNLOAD_CENTER', 'INFO_DEFAULT_DOWNLOAD_DIRECTORY'),
				width: 500,
				height: 200,
				parentWin: winapp.win,
				fbar: [
                    btnOk,
                    {
                        text: _S('COMMON', 'CANCEL'),
                        handler: function () {
                            winapp.win.close();
                        }
                    }
                ],
				items: [
				{
					xtype: 'asPanelTop20',
					itemId: 'panel-group',
					items: [
					{
						xtype: 'panel',
						itemId: 'add-group',
						items: [
						{
							xtype: 'container',
							itemId: 'first-browser',
							border: false,
							items:[{
								xtype: 'displayfield',
								value: _S('DOWNLOAD_CENTER', 'CHOOSE_FOLDER'),
                                margin: '0, 0, 15, 10'
							},{
								layout: 'hbox',
								border: false,
								items: [
								savePath,
								saveBrowse
								]
							}]
						}]
					}]
				}]
			});
			win.show();
		};

		//-------
		var maxHeight;
		var maxWidth;
		var isMaxiMode = false;
		//========================================================= DOWNLOAD CENTER WINDOW =========================================================
		this.win = this.desktop.createWindow({
			app: this.app,
			id: this.id,
			itemId: this.id,
			title: _S('DOWNLOAD_CENTER', 'DOWNLOAD_CENTER'),
			taskIcon: '../apps/download-center/icon-app.png',
			width: 1200,
			height: 600,
			minWidth: 1200,
			minHeight: 600,
			resizable: true,
			maximizable: true,
			border: false,
			layout: 'border',
            items: [
            {
				region: 'north',
                xtype: 'container',
                height: 40,
                cls: 'toolBar',
                items: [
				toolBarContainer
				]
            },
			westPanel,
			{
				region: 'center',
                xtype: 'container',
                cls: 'center',
				autoScroll: true,
				layout: {
					align: 'stretch',
					type: 'border'
				},
				flex: 1,
                items: [
				mainPanel
				]
            }],
			listeners: {
				afterrender: function (win) {
					getHomeFolderPath();
					win.header.items.items[1].hide();

					// JN: drag & drop files for multi uploading
					var dropPanelDiv = document.createElement('div');
					dropPanelDiv.className = "app-fileExplorer-HTML5DDPanel";
					win.el.dom.insertBefore(dropPanelDiv, win.el.dom.firstChild);

					var to;
					win.getEl().on(
						{
							'dragover': function(e) {
								clearTimeout(to);

								e.preventDefault();
								dropPanelDiv.style.display = "block";
							},
							'dragleave': function(e) {
								to = setTimeout(function(){dropPanelDiv.style.display = "none";}, 0);
							},
							'drop': function(e) {
								e.preventDefault();
								dropPanelDiv.style.display = "none";
								if(openAddWin())
									winapp.selectFiles(e.browserEvent.dataTransfer.files);
							}
						}
					);
				},
				beforeshow: function( com, eOpts ) {
				    if (AS.ARC.configs.DOWNLOADCENTER_REFRESH) {
				        clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
						winapp.BT_REFRESH_TIMEOUT_ID = setTimeout(reloadBTStore, winapp.BT_REFRESH_TIME_INTERVAL);
					}
				},
				maximize: function( win, eOpts ) {
				    maxHeight = win.getHeight();
				    maxWidth = win.getWidth();
					var changeHeight = (win.getHeight()-30-125-30-30)/2;
					searchMainPanel.setHeight(changeHeight);
					searchPanel.setHeight(changeHeight - 27);

					win.resizer.disable();

					isMaxiMode = true;

				},
				restore: function ( win, width, height, eOpts ) {
					searchMainPanel.setHeight(188);
					searchPanel.setHeight(140);

					win.resizer.enable();

					isMaxiMode = false;
				},
				show: function(win, eOpts) {
				    //get preference
				    winapp.BTStore.load();
				    searchPanel.getStore().load();
				    rssPanel.getStore().load();
					setTimeout(function() {
						winapp.win.el.mask(_S('COMMON', 'LOADING'));

						var urlOpts = {
							act: 'get-user-pref'
						};

						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
							method: 'post',
							success: function (json, opts) {
								defaultDir = json.default_dl_dir;
								var total = [json.default_dl_dir,json.incomplete_dir,json.watch_dir];
								var num = 0;
								var checkFolderAccess = function() {
									if(num < 3) {
										var folderPath = total[num],
										lastFolderString = "/" + folderPath.split("/").pop(),
										node = changeHomeFolder(folderPath.split(lastFolderString).shift());

										if(node === "") node = 'share_folders';

										var urlOpts = {
											act: 'file_list',
											path: node,
											showhome: true,
											onlydir: true
										};

										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
											method: 'post',			
											success: function (json, opts) {
												var datas;

												if(node !== 'share_folders') datas = json.data;
												else  datas = json.data;
												
												for (var i=0; i< datas.length; i++) {
													var folderName = datas[i].filename;
													if(folderName === folderPath.split("/").pop()){
														if(winapp.isReadOnly(datas[i].access_permission)) {
															isFirstOpen = true;
															if(num === 0)  	winapp.PRE_CHECK_DEFAULT = true;
															else if(num === 1) winapp.PRE_CHECK_INCOMPLETE = true;
															else winapp.PRE_CHECK_WATCH = true;
														}
													}
												}
												num++;
												checkFolderAccess();
											},
											failure: function (json, opts) {
											}
										});
									} else {
										if(winapp.PRE_CHECK_DEFAULT === true || winapp.PRE_CHECK_INCOMPLETE === true|| winapp.PRE_CHECK_WATCH === true) {
											win.el.mask();
											openPreferenceWin();
										} else winapp.win.el.unmask();
									}
								}
								checkFolderAccess();

								var urlOpts = {
									act: 'rss-filter-list'
								};

								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
									method: 'post',
									success: function (json, opts) {
										var total = json.total;
										var num = 0;
										if(total !== 0) {
											for(var i = 0; i < total; i++) {
												var folderPath = json.items[i].save_as.download_dir,
													lastFolderString = "/" + folderPath.split("/").pop(),
													node = changeHomeFolder(folderPath.split(lastFolderString).shift());

												if(node === "") node = 'share_folders';

												var urlOpts = {
													act: 'file_list',
													path: node,
													showhome: true,
													onlydir: true
												};

												AS.ARC.ajax({
													url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
													method: 'post',			
													success: function (json, opts) {
														var datas;

														if(node !== 'share_folders') datas = json.data;
														else  datas = json.data;
														
														for (var i=0; i< datas.length; i++) {
															var folderName = datas[i].filename;
															if(folderName === folderPath.split("/").pop()){
																if(winapp.isReadOnly(datas[i].access_permission)) {
																	winapp.RSS_FILTER_DIR_ACCESS = false;
																	document.getElementById('rssIcon').style.display = 'inline-block';
																	winapp.RSS_ROWINDEX[num] = num;
																} else {
																	winapp.RSS_FILTER_DIR_ACCESS = true;
																} 
															}
														}
													},
													failure: function (json, opts) {
													}
												});
											}
										}
									},
									failure: function (json, opts) {}
								});
							},
							failure: function (json, opts) {

								if (json.error_code === 5005) {
									firstOpen();
								} else if (!AS.ARC.user.isAdmin && json.error_code === undefined) {
									var total = [json.default_dl_dir,json.incomplete_dir,json.watch_dir];
									var num = 0;
									var checkFolderAccess = function() {
										if(num < 3) {
											var folderPath = total[num],
											lastFolderString = "/" + folderPath.split("/").pop(),
											node = changeHomeFolder(folderPath.split(lastFolderString).shift());

											if(node === "") node = 'share_folders';

											var urlOpts = {
												act: 'file_list',
												path: node,
												showhome: true,
												onlydir: true
											};

											AS.ARC.ajax({
												url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
												method: 'post',			
												success: function (json, opts) {
													var datas;

													if(node !== 'share_folders') datas = json.data;
													else  datas = json.data;
													
													for (var i=0; i< datas.length; i++) {
														var folderName = datas[i].filename;
														if(folderName === folderPath.split("/").pop()){
															if(winapp.isReadOnly(datas[i].access_permission)) {
																isFirstOpen = true;
																if(num === 0)  	winapp.PRE_CHECK_DEFAULT = true;
																else if(num === 1) winapp.PRE_CHECK_INCOMPLETE = true;
																else winapp.PRE_CHECK_WATCH = true;
															}
														}
													}
													num++;
													checkFolderAccess();
												},
												failure: function (json, opts) {
												}
											});
										} else {
											if(winapp.PRE_CHECK_DEFAULT === true || winapp.PRE_CHECK_INCOMPLETE === true|| winapp.PRE_CHECK_WATCH === true) {
												win.el.mask();
												openPreferenceWin();
											}  else winapp.win.el.unmask();
										}
										
									}
									checkFolderAccess();
									defaultDir = json.default_dl_dir;
								} else {
									var cb = function () {
										if (json.error_code === 5026) {
											winapp.win.close();
										}
									}

									winapp.showErrorMsgWin('get-user-pref', json, winapp.win, 'warning', cb);
								}
								var urlOpts = {
									act: 'rss-filter-list'
								};

								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(winapp.BTUrl, urlOpts),
									method: 'post',
									success: function (json, opts) {
										var total = json.total;
										var num = 0;
										if(total !== 0) {
											for(var i = 0; i < total; i++) {
												var folderPath = json.items[i].save_as.download_dir,
													lastFolderString = "/" + folderPath.split("/").pop(),
													node = changeHomeFolder(folderPath.split(lastFolderString).shift());

												if(node === "") node = 'share_folders';

												var urlOpts = {
													act: 'file_list',
													path: node,
													showhome: true,
													onlydir: true
												};

												AS.ARC.ajax({
													url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/' + 'fileExplorer' + '/' + 'fileExplorer.cgi', urlOpts),
													method: 'post',			
													success: function (json, opts) {
														var datas;

														if(node !== 'share_folders') datas = json.data;
														else  datas = json.data;
														
														for (var i=0; i< datas.length; i++) {
															var folderName = datas[i].filename;
															if(folderName === folderPath.split("/").pop()){
																if(winapp.isReadOnly(datas[i].access_permission)) {
																	winapp.RSS_FILTER_DIR_ACCESS = false;
																	document.getElementById('rssIcon').style.display = 'inline-block';
																	winapp.RSS_ROWINDEX[num] = num;
																} else {
																	winapp.RSS_FILTER_DIR_ACCESS = true;
																} 
															}
														}
													},
													failure: function (json, opts) {
													}
												});
											}
										}
									},
									failure: function (json, opts) {}
								});
							}
						});
					}, 300);
				},
				beforeclose: function(win, eOpts ) {
				    clearTimeout(winapp.BT_REFRESH_TIMEOUT_ID);
					clearTimeout(winapp.RSS_REFRESH_TIMEOUT_ID);
					//winapp.ISSTART = false;

					winapp.isMainWindowClosed = true;
				},
				resize: function (win, adjWidth, adjHeight, eOpts) {
                    var centerWidth = win.items.items[2].getWidth(), // centerpanel
                        centerHeight = win.items.items[2].getHeight();
                    /*
					@ Center panel's width and height is longer than mainPanel,
					@ and it's difference of 18cm
					*/
                    win.items.items[2].items.items[0].setWidth(centerWidth - 18); //set mainPanel's width and height
                    win.items.items[2].items.items[0].setHeight(centerHeight - 18);
                    
				    if (isMaxiMode) {
				        // win.fireEvent('restore', win, adjWidth, adjHeight);
				    }
				}
			}
		});
	},

	delayWindowUnmask: function(seconds) {
		var millisecond = 1000;
		var second = seconds * millisecond;
		setTimeout(function delayWindowUnmask() {
			try {
				if (winapp.win.el.isMasked()) {
					winapp.win.el.unmask();
				}
			} catch (e) {
				console.error(e);
				winapp.win.el.unmask();
			}
		}, second);
	}
});

/**
 * @class AS.ARC.apps.downloadCenter.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('AS.ARC.apps.downloadCenter.main', {
	extend: 'AS.ARC._appBase',
	//user-download-center
	appTag: 'download-center',
	title: 'Download Center',

	createWindow: function () {
		var desktop = this.core.getDesktop(),
			win = desktop.getWindow(this.id);

		if (!win) {
			var newDC = new AS.ARC.apps.downloadCenter.core({
				app: this,
				desktop: desktop,
				title: this.title,
				id: this.id
			});

			// Set win to this app
			this.win = newDC.win;

			win = newDC.win;
		}
		win.show();
	}
});